<?php

namespace AdministracionBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\ORM\Tools\Pagination\Paginator;
use PagoBundle\Entity\business;
use PagoBundle\Form\businessType;
use PagoBundle\Form\businesspoliticaType;
use Symfony\Component\HttpFoundation\Response;

class BusinessController extends Controller
{
    public function indexAction(Request $request, $page)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            if ($page == NULL){
                $page = 1;
            }

            $em = $this->getDoctrine()->getManager();
            $businessQuery = $em->getRepository('PagoBundle:business')->findAllQuery();

            $pageSize = 20;
            $business = $this->getPaginate($pageSize, $page, $businessQuery);
            $totalItems = count($business);
            $pagescount = ceil($totalItems / $pageSize);
            return $this->render('AdministracionBundle:Administracion:businesslist.html.twig' ,
                                array(  "businesss" => $business,
                                        "totalItems" => $totalItems,
                                        "pagesCount" => $pagescount,
                                        "currentpage" => $page,
                                    )
                                );
        }
        return $this->redirectToRoute('business_index');
    }
    
    public function getPaginate($pageSize, $currentPage, $queryBuilder){
        if ($currentPage > 0){
            $queryBuilder->setFirstResult($pageSize * ($currentPage - 1))->setMaxResults($pageSize);
        }
        $paginator = new Paginator($queryBuilder, $fetchJoinCollection = true);
        return $paginator;
    }
    
    public function editAction(Request $request, $id)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $editar = true;
            $idbusiness = 0;
            if($id == NULL){
                $business = new business();
                $editar = false;
            }else{
                $business = $em->getRepository('PagoBundle:business')->find($id);
                if($business == NULL){
                    $business = new business();
                    $editar = false; 
                }else{
                    $idbusiness = $business->getId();
                }
            }
            $laspass = $business->desencryptarPassword();
            $business->setPassword($laspass);
            $planes = $em->getRepository('AdministracionBundle:plan')->findBy(array('business'=>$business,'eliminado'=>0));
            $form = $this->createForm(businessType::class, $business, 
                            array("attr" => array("disabled" => FALSE,'idbusiness'=>$idbusiness)));
            if($request->getMethod() == 'POST'){
                 $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) {
                        $business->encryptarPassword();
                        $em->persist($business);
                        $em->flush();
                        
                        $ruta = $business->getRuta();
                        foreach ($_FILES as $n => $key) {
                            if($key['error'] == UPLOAD_ERR_OK ){                        
                                $name = $key['name'];
                                $ext = pathinfo($name, PATHINFO_EXTENSION);
                                mt_srand (time());
                                $nombretemporal = $business->getId() .  "-imagenemail" ;
                                $rand = rand(1, 1000);
                                $namefinal = $nombretemporal . "-" . $rand . "." . $ext;
                                $temporal = $key['tmp_name']; //Obtenemos el nombre del archivo temporal
                                if ($key['type'] == 'image/png' || 
                                    $key['type'] == 'image/jpg' || 
                                    $key['type'] == 'image/jpeg'){
                                    move_uploaded_file($temporal, $ruta . $namefinal);
                                    $business->removeUpload();
                                    $business->setPathimagenemail($namefinal);
                                    $em->persist($business);
                                    $em->flush();
                                }
                            }else{
                                // $key['error']; //Si no se cargo mostramos el error
                            }
                        }
                        
                        return $this->redirectToRoute('business_index');

                    }
            }
            return $this->render('AdministracionBundle:Administracion:businessedit.html.twig',array('form'=>$form->createView(),
                                'business'=>$business,'planes'=>$planes,'idbusiness'=>$idbusiness));
        }
        return $this->redirectToRoute('login');
    }
    
    public function deleteAction($id){
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('PagoBundle:business')->find($id);
            if($business){
                $business->setEliminado(1);
                $em->persist($business);
                $em->flush();
            }
        
            return $this->redirectToRoute('business_index');
        }
        return $this->redirectToRoute('login');    
    }
    
    public function politicaprivacidadAction($id)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('PagoBundle:business')->find($id);
            if($business != NULL){
                return $this->render('AdministracionBundle:Administracion:politicaprivacidad.html.twig',
                                array('business'=>$business));
            }
        }
        return $this->redirectToRoute('business_index');
    }
    
    public function politicaprivacidadeditAction(Request $request, $id)
    {
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('PagoBundle:business')->find($id);
            if($business != NULL){
                $form = $this->createForm(businesspoliticaType::class, $business, array("attr" => array("disabled" => FALSE)));
                if($request->getMethod() == 'POST'){
                    $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) {
                        $em->persist($business);
                        $em->flush();
                        return $this->redirectToRoute('business_politica_privacidad', array("id" => $business->getId()));
                    }
                }
                return $this->render('AdministracionBundle:Administracion:politicaprivacidadedit.html.twig',
                                array('form'=>$form->createView(), 'business'=>$business));
            }
        }
        return $this->redirectToRoute('business_index');
    }
    
    public function getFileAction($id){
        $em = $this->getDoctrine()->getManager();
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $business = $em->getRepository('PagoBundle:business')->find($id);
            if ($business != NULL && $business->getPathimagenemail() != NULL){
                $ruta= $business->getRuta() . $business->getPathimagenemail();
                if (file_exists($ruta)){
                    $headers = array('Content-Type' => "image/png",
                        'Content-Disposition' => 'inline; '
                        . 'filename="'.$ruta.'"');

                    $file =  readfile($ruta);
                    return new Response($file, 200, $headers); 
                }
            }
        }
        $response = new Response(json_encode(array()));
        return $response;
    }
}
