<?php

namespace AdministracionBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\ORM\Tools\Pagination\Paginator;
use AdministracionBundle\Entity\plan;
use AdministracionBundle\Form\planType;

class PlanController extends Controller
{
    public function indexAction($page, $idbusiness)
    {
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('PagoBundle:business')->find($idbusiness);
            if($business){
                if ($page == NULL){
                    $page = 1;
                }

                $em = $this->getDoctrine()->getManager();
                $planQuery = $em->getRepository('AdministracionBundle:plan')->findAllQuery($idbusiness);

                $pageSize = 20;
                $planes = $this->getPaginate($pageSize, $page, $planQuery);
                $totalItems = count($planes);
                $pagescount = ceil($totalItems / $pageSize);
                return $this->render('AdministracionBundle:Administracion:planlist.html.twig' ,
                                    array(  "planes" => $planes,
                                            "totalItems" => $totalItems,
                                            "pagesCount" => $pagescount,
                                            "currentpage" => $page,
                                            'business' => $business
                                        )
                                    );
            }    
        }
        return $this->redirectToRoute('login');
    }
    
    public function getPaginate($pageSize, $currentPage, $queryBuilder){
        if ($currentPage > 0){
            $queryBuilder->setFirstResult($pageSize * ($currentPage - 1))->setMaxResults($pageSize);
        }
        $paginator = new Paginator($queryBuilder, $fetchJoinCollection = true);
        return $paginator;
    }
    
    public function editAction(Request $request, $id,$idbusiness)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('PagoBundle:business')->find($idbusiness);
            if($business){
                $editar = true;
                if ($id == NULL){
                    $id = -1;
                }
                $plan = $em->getRepository('AdministracionBundle:plan')->find($id);
                if($plan == NULL){
                    $plan = new plan();
                    $plan->setBusiness($business);
                    $editar = false; 
                }
                if ($plan->getBusiness()->getId() == $business->getId()){
                    $form = $this->createForm(planType::class, $plan, 
                                    array("attr" => array("disabled" => FALSE)));
                    if($request->getMethod() == 'POST'){
                         $form->handleRequest($request);
                            if ($form->isSubmitted() && $form->isValid()) {
                                $em->persist($plan);
                                $em->flush();
                                return $this->redirectToRoute('plan_index',array('idbusiness'=>$business->getId()));

                            }
                    }
                    return $this->render('AdministracionBundle:Administracion:planedit.html.twig',array('form'=>$form->createView(),
                                    'business'=>$business,'plan'=>$plan));
                }
            }    
        }
        return $this->redirectToRoute('login');
    }
    
    public function deleteAction($id,$idbusiness){
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository('AdministracionBundle:plan')->find($idbusiness);
            if($business){
                $plan = $em->getRepository('AdministracionBundle:plan')->find($id);
                if($plan){
                    $plan->setEliminado(1);
                    $em->persist($plan);
                    $em->flush();
                }
            }    
            return $this->redirectToRoute('plan_index',array('idbusiness'=>$idbusiness));
        }
        return $this->redirectToRoute('login');    
    }
}
