<?php

namespace AdministracionBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\ORM\Tools\Pagination\Paginator;

class UsereliminadosController extends Controller
{
    public function indexAction(Request $request, $page)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            if ($page == NULL){
                $page = 1;
            }
            $text = $request->query->get("text");
            $idbusiness = intval($request->query->get("idbusiness"));
            $em = $this->getDoctrine()->getManager();
            $usuarioQuery = $em->getRepository('UsuarioBundle:administrador')
                    ->findAllusersQuery($idbusiness, $text, 0);
            $pageSize = 20;
            $usuarios = $this->getPaginate($pageSize, $page, $usuarioQuery);
            $totalItems = count($usuarios);
            $pagescount = ceil($totalItems / $pageSize);
            
            $business = $em->getRepository('PagoBundle:business')->findBusiness();
            
            return $this->render('AdministracionBundle:Administracion:usuarioslisteliminados.html.twig' ,
                                array(  
                                    "usuarios" => $usuarios,
                                    "totalItems" => $totalItems,
                                    "pagesCount" => $pagescount,
                                    "currentpage" => $page,
                                    "text" => $text,
                                    "idbusiness" => $idbusiness,
                                    "business" => $business
                                    )
                                );
        }
        return $this->redirectToRoute('login');
    }
    
    public function getPaginate($pageSize, $currentPage, $queryBuilder){
        if ($currentPage > 0){
            $queryBuilder->setFirstResult($pageSize * ($currentPage - 1))->setMaxResults($pageSize);
        }
        $paginator = new Paginator($queryBuilder, $fetchJoinCollection = true);
        return $paginator;
    }
    
    public function deleteAction($id){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true 
                && $usuario->getId() == 1){
            $em = $this->getDoctrine()->getManager();
            $administrador = $em->getRepository('UsuarioBundle:administrador')->find($id);
            if($administrador){
                $pagos = $em->getRepository("PagoBundle:pago")
                        ->findBy(array("usuario" => $administrador->getId()));
                foreach ($pagos as $p) {
                    $em->remove($p);
                }
                $em->flush();
                
                $eventostripes = $em->getRepository("PagoBundle:eventostripe")
                        ->findBy(array("usuario" => $administrador->getId()));
                foreach ($eventostripes as $e) {
                    $em->remove($e);
                }
                $em->flush();
                
                $briefing = $administrador->getBriefing();
                if ($briefing != NULL){
                    $briefing->setAdministrador(NULL);
                    $administrador->setBriefing(NULL);

                    $em->persist($briefing);
                    $em->persist($administrador);
                    $em->remove($briefing);
                    $em->flush();
                }
                
                $em->remove($administrador);
                $em->flush();
            }
        }
        return $this->redirectToRoute('usuarios_eliminados');    
    }
}
