<?php

namespace AdministracionBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * order
 *
 * @ORM\Table(name="plan")
 * @ORM\Entity(repositoryClass="AdministracionBundle\Repository\planRepository")
 */
class plan
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
    
    /**
     * @var client
     *
     * @ORM\ManyToOne(targetEntity="PagoBundle\Entity\business")
     */
    private $business;

   /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;

    /**
     * @var integer
     *
     * @ORM\Column(name="orden", type="integer")
     */
    private $orden;

    /**
     * @var float
     *
     * @ORM\Column(name="total", type="float")
     */
    private $totalmensual;

    /**
     * @var float
     *
     * @ORM\Column(name="porcentajeiva", type="float")
     */
    private $porcentajeiva;

    /**
     * @var float
     *
     * @ORM\Column(name="totaliva", type="float")
     */
    private $totaliva;
    
     /**
     * @var string
     *
     * @ORM\Column(name="idplanstripe", type="string", nullable=true)
     */
    private $idplanstripe;
    
     /**
     * @var string
     *
     * @ORM\Column(name="idplanstripetest", type="string", nullable=true)
     */
    private $idplanstripetest;
    
    /**
     * @var int
     *
     * @ORM\Column(name="eliminado", type="integer")
     */
    private $eliminado;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="condominio", type="boolean")
     */
    private $condominio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="tiendaactiva", type="boolean")
     */
    private $tiendaactiva; 
    
    /**
     * @var integer
     *
     * @ORM\Column(name="numeromaximoemails", type="integer")
     */
    private $numeromaximoemails; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="crmeactivo", type="boolean")
     */
    private $crmeactivo; 
    
    /**
     * @var integer
     *
     * @ORM\Column(name="textoservicio", type="string", nullable=true, length=255)
     */
    private $textoservicio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="standardcreatuaplicacion", type="boolean")
     */
    private $standardcreatuaplicacion; 
    
    public function getCosteimpuestos(){
        return $this->getTotaliva() - $this->getTotalmensual();
    }
    
    public function getIDstripe($mode){
        if ($mode == 1){
            return $this->getIdplanstripetest();
        }else if ($mode == 2){
            return $this->getIdplanstripe();
        }
        return "";
    }
    
    public function getTextoserviciosincluidos(){
        $t = "<ul class='ulservicios'>";
        if ($this->getCondominio()){
            $t .= "<li>Reserva de dominio.</li>";
        }
        if ($this->getTiendaactiva()){
            $t .= "<li>Tienda activa.</li>";
        }
        if ($this->getNumeromaximoemails() > 0){
            $t .= "<li>Número de emails incluidos en el plan: " . $this->getNumeromaximoemails() . ".</li>";
        }
        if ($this->getCrmeactivo()){
            $t .= "<li>CRM EActivo activado.</li>";
        }
        if ($this->getTextoservicio()){
            $t .= "<li>" . $this->getTextoservicio() . ".</li>";
        }
        if ($this->getStandardcreatuaplicacion()){
            $t .= "<li>Standard CreaTuAplicación</li>";
        }
        $t .= "</ul>";
        return $t;
    }
   
    public function __construct() {
        $this->eliminado = false;
        $this->totalmensual = 0;
        $this->totaliva = 0;
        $this->condominio = false;
        $this->tiendaactiva = false;
        $this->numeromaximoemails = 0;
        $this->orden = 0;
        $this->crmeactivo = 0;
    }

    public function __toString() {
        return $this->name." - ".$this->totalmensual." €";
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     *
     * @return plan
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set totalmensual
     *
     * @param float $totalmensual
     *
     * @return plan
     */
    public function setTotalmensual($totalmensual)
    {
        $this->totalmensual = $totalmensual;

        return $this;
    }

    /**
     * Get totalmensual
     *
     * @return float
     */
    public function getTotalmensual()
    {
        return $this->totalmensual;
    }

    /**
     * Set eliminado
     *
     * @param integer $eliminado
     *
     * @return plan
     */
    public function setEliminado($eliminado)
    {
        $this->eliminado = $eliminado;

        return $this;
    }

    /**
     * Get eliminado
     *
     * @return integer
     */
    public function getEliminado()
    {
        return $this->eliminado;
    }

    /**
     * Set business
     *
     * @param \PagoBundle\Entity\business $business
     *
     * @return plan
     */
    public function setBusiness(\PagoBundle\Entity\business $business = null)
    {
        $this->business = $business;

        return $this;
    }

    /**
     * Get business
     *
     * @return \PagoBundle\Entity\business
     */
    public function getBusiness()
    {
        return $this->business;
    }

    /**
     * Set idplanstripe
     *
     * @param string $idplanstripe
     *
     * @return plan
     */
    public function setIdplanstripe($idplanstripe)
    {
        $this->idplanstripe = $idplanstripe;

        return $this;
    }

    /**
     * Get idplanstripe
     *
     * @return string
     */
    public function getIdplanstripe()
    {
        return $this->idplanstripe;
    }

    /**
     * Set condominio
     *
     * @param boolean $condominio
     *
     * @return plan
     */
    public function setCondominio($condominio)
    {
        $this->condominio = $condominio;

        return $this;
    }

    /**
     * Get condominio
     *
     * @return boolean
     */
    public function getCondominio()
    {
        return $this->condominio;
    }

    /**
     * Set tiendaactiva
     *
     * @param boolean $tiendaactiva
     *
     * @return plan
     */
    public function setTiendaactiva($tiendaactiva)
    {
        $this->tiendaactiva = $tiendaactiva;

        return $this;
    }

    /**
     * Get tiendaactiva
     *
     * @return boolean
     */
    public function getTiendaactiva()
    {
        return $this->tiendaactiva;
    }

    /**
     * Set numeromaximoemails
     *
     * @param integer $numeromaximoemails
     *
     * @return plan
     */
    public function setNumeromaximoemails($numeromaximoemails)
    {
        $this->numeromaximoemails = $numeromaximoemails;

        return $this;
    }

    /**
     * Get numeromaximoemails
     *
     * @return integer
     */
    public function getNumeromaximoemails()
    {
        return $this->numeromaximoemails;
    }

    /**
     * Set orden
     *
     * @param integer $orden
     *
     * @return plan
     */
    public function setOrden($orden)
    {
        $this->orden = $orden;

        return $this;
    }

    /**
     * Get orden
     *
     * @return integer
     */
    public function getOrden()
    {
        return $this->orden;
    }

    /**
     * Set textoservicio
     *
     * @param string $textoservicio
     *
     * @return plan
     */
    public function setTextoservicio($textoservicio)
    {
        $this->textoservicio = $textoservicio;

        return $this;
    }

    /**
     * Get textoservicio
     *
     * @return string
     */
    public function getTextoservicio()
    {
        return $this->textoservicio;
    }

    /**
     * Set crmeactivo
     *
     * @param boolean $crmeactivo
     *
     * @return plan
     */
    public function setCrmeactivo($crmeactivo)
    {
        $this->crmeactivo = $crmeactivo;

        return $this;
    }

    /**
     * Get crmeactivo
     *
     * @return boolean
     */
    public function getCrmeactivo()
    {
        return $this->crmeactivo;
    }

    /**
     * Set idplanstripetest
     *
     * @param string $idplanstripetest
     *
     * @return plan
     */
    public function setIdplanstripetest($idplanstripetest)
    {
        $this->idplanstripetest = $idplanstripetest;

        return $this;
    }

    /**
     * Get idplanstripetest
     *
     * @return string
     */
    public function getIdplanstripetest()
    {
        return $this->idplanstripetest;
    }

    /**
     * Set standardcreatuaplicacion
     *
     * @param boolean $standardcreatuaplicacion
     *
     * @return plan
     */
    public function setStandardcreatuaplicacion($standardcreatuaplicacion)
    {
        $this->standardcreatuaplicacion = $standardcreatuaplicacion;

        return $this;
    }

    /**
     * Get standardcreatuaplicacion
     *
     * @return boolean
     */
    public function getStandardcreatuaplicacion()
    {
        return $this->standardcreatuaplicacion;
    }

    /**
     * Set totaliva
     *
     * @param float $totaliva
     *
     * @return plan
     */
    public function setTotaliva($totaliva)
    {
        $this->totaliva = $totaliva;

        return $this;
    }

    /**
     * Get totaliva
     *
     * @return float
     */
    public function getTotaliva()
    {
        return $this->totaliva;
    }

    /**
     * Set porcentajeiva
     *
     * @param float $porcentajeiva
     *
     * @return plan
     */
    public function setPorcentajeiva($porcentajeiva)
    {
        $this->porcentajeiva = $porcentajeiva;

        return $this;
    }

    /**
     * Get porcentajeiva
     *
     * @return float
     */
    public function getPorcentajeiva()
    {
        return $this->porcentajeiva;
    }
}
