<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace AdministracionBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;

class planType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {     
        $builder
            ->add('name', TextType::class, array(
                'label' => 'Nombre del plan',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('porcentajeiva', NumberType::class, array(
                'label' => 'Procentaje Impuestos(%)',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('totaliva', NumberType::class, array(
                'label' => 'Total con IVA',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('orden', NumberType::class, array(
                'label' => 'Orden',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('totalmensual', NumberType::class, array(
                'label' => 'Total al mes €',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('idplanstripe', TextType::class, array(
                'label' => 'ID de Stripe para el plan',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('idplanstripetest', TextType::class, array(
                'label' => 'ID de Stripe para el plan test',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            )) 
            ->add('condominio', ChoiceType::class, array(
                'choices' => array(
                    'NO' => 0,
                    'SI' => 1, 
                    ),
                'label' => '¿Puede reservar dominio?',
                'expanded' => false,
                'required' => true,
                "disabled" => $options["attr"]["disabled"],
                "attr" => array("class" => "form-control required"),
            )) 
            ->add('tiendaactiva', ChoiceType::class, array(
                'choices' => array(
                    'NO' => 0,
                    'SI' => 1, 
                    ),
                'label' => '¿Puede activar la tienda?',
                'expanded' => false,
                'required' => true,
                "disabled" => $options["attr"]["disabled"],
                "attr" => array("class" => "form-control required"),
            ))
            ->add('numeromaximoemails', NumberType::class, array(
                'label' => 'Número máximo de emails',
                "required" => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('textoservicio', TextType::class, array(
                'label' => 'Texto con los servicios',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('crmeactivo', ChoiceType::class, array(
                'choices' => array(
                    'NO' => 0,
                    'SI' => 1, 
                    ),
                'label' => '¿Puede activar el CRM EActivo?',
                'expanded' => false,
                'required' => true,
                "disabled" => $options["attr"]["disabled"],
                "attr" => array("class" => "form-control required"),
            )) 
            ->add('standardcreatuaplicacion', ChoiceType::class, array(
                'choices' => array(
                    'NO' => 0,
                    'SI' => 1, 
                    ),
                'label' => '¿Standard CreaTuAplicación?',
                'expanded' => false,
                'required' => true,
                "disabled" => $options["attr"]["disabled"],
                "attr" => array("class" => "form-control required"),
            )) ;
        
        
        
    }
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AdministracionBundle\Entity\plan',
            "allow_extra_fields" => true
        ));
    }
    public function getName()
    {
        return 'plan';
    }
}

