<?php

namespace ApiBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use CoreBundle\Entity\Cipher;
use CoreBundle\Entity\Utils;
use UsuarioBundle\Entity\administrador;
use WebBundle\Entity\briefing;

class ApiController extends Controller
{
    public function methodAction(Request $request)
    {
        $errorcode = 0;
        $errormessage = "";
        $paramsreturn = array();
        if ($request->getMethod() == "POST"){
            $ajson = $request->getContent();
            //$ajson = "5YOQX5nNVqj2tiaR4Mcw1Iipe+wPJN7QsRIOFhGd2b8LLD4Q3deQ2nWd8nnzkU4hZZAoSn5HcN+JWTjr5MdQRUC7yHlsMqx/B+RNb8HpO4tHksS7wo4XjXC1AY9soYzwPNSd/svFXpm3e1CAQQxdezFE4rog7dr28Y2Lk9OkoZMvyg9cMtZpwaFo8EoUlyw1TwHJSF9wt/LRvUvznBORvND449HmwTt/EePYPWAn7vc=";
            $jsondecrypt = Cipher::decrypt($ajson);
            $em = $this->getDoctrine()->getManager();
            Utils::crearlogpeticion("alta", $jsondecrypt);

            $arrayjson = json_decode($jsondecrypt, true);
            $action = $arrayjson["action"];
            $params = $arrayjson["params"];
            
            switch ($action){
                case "createweb";
                    list($errorcode, $errormessage, $creado) = $this->createweb($em, $params);
                    $paramsreturn["creado"] = $creado;
                    break;
                case "updatepassword";
                    list($errorcode, $errormessage, $actualizada) = $this->updatepassword($em, $params);
                    $paramsreturn["actualizada"] = $actualizada;
                    break;
                default:
                    Utils::crearlogpeticion("alta", "Error en el nombre de la acción");
                    break;
            }
        }else{
            $errorcode = 1;
            $errormessage = "Error en la petición";
            Utils::crearlogpeticion("alta", $errormessage);
        }
        $response = json_encode(array("errorcode" => $errorcode, 
            "errormessage" => $errormessage, "return" => $paramsreturn));
        Utils::crearlogpeticion("alta", $response);
        return new Response($response);
    }
    
    public function updatepassword($em, $params){
        $passopen = $params["passopen"];
        $email = $params["email"];
        $newpass = $params["newpass"];
        
        $actualizada = 0;
        $errorcode = 0;
        $errormessage = "";
        
        $administrador = $em->getRepository("UsuarioBundle:administrador")
                ->findAdministrador($email);
        if ($administrador != NULL){
            $encoder = $this->get('security.encoder_factory')->getEncoder($administrador);
            $passwordCodificado = $encoder->encodePassword($passopen, $administrador->getSalt());
            if ($passwordCodificado == $administrador->getPassword()){
                $administrador->setSalt(md5(time()));
                $encoder = $this->get('security.encoder_factory')->getEncoder($administrador);
                $passwordCodificado = $encoder->encodePassword($newpass, $administrador->getSalt());
                $administrador->setPassword($passwordCodificado);
                $administrador->setPasscifrada(Cipher::crypt($newpass));
                $em->persist($administrador);
                $em->flush();
                $actualizada = 1;
            }else{
                $errorcode = 1;
                $errormessage = "La contraseña no corresponde";
            }
        }else{
            $errorcode = 1;
            $errormessage = "No existe el administrador";
        }
        
        return array($errorcode, $errormessage, $actualizada);
    }
    
    public function createweb($em, $params){
        $passopen = $params["passopen"];
        $email = $params["email"];
        $nombre = $params["nombre"];
        $idbusiness = intval($params["idbusiness"]);
        $idplan = intval($params["idplan"]);
        $fechaexpiracion = $params["fechaexpiracion"];
        
        $fecha = new \DateTime();
        if ($fechaexpiracion != NULL){
            $fecha = \DateTime::createFromFormat('d/m/Y', $fechaexpiracion);
            if ($fecha == NULL){
                $fecha = new \DateTime();
            }
        }
        
        $errorcode = 0;
        $errormessage = "";
        $creado = 0;
        
        $business = $em->getRepository('PagoBundle:business')
                ->find($idbusiness);
        $plan = $em->getRepository('AdministracionBundle:plan')
                ->find($idplan);
        $existe = $em->getRepository('UsuarioBundle:usuario')->findExists($email);
        if ($existe == NULL && $business != NULL && $plan 
                && $plan->getBusiness()->getId() == $business->getId()){
            $administrador = new administrador();
            $administrador->setEmail($email);
            $administrador->setPlanseleccionado($plan);
            $administrador->setBusiness($business);
            $administrador->setActivo(TRUE);
            $administrador->setFechaexpiracion($fecha);
            $administrador->setNombre($nombre);
            $administrador->setCondominio($plan->getCondominio());
            $administrador->setTiendaactiva($plan->getTiendaactiva());
            $administrador->setNumeromaximoemails($plan->getNumeromaximoemails());
            $administrador->setCrmeactivo($plan->getCrmeactivo());
            $administrador->setTextoservicio($plan->getTextoservicio());
            $administrador->setStandardcreatuaplicacion($plan->getStandardcreatuaplicacion());
            $administrador->setPlanactivo(TRUE);
            $administrador->setSalt(md5(time()));
            $encoder = $this->get('security.encoder_factory')->getEncoder($administrador);
            $passwordCodificado = $encoder->encodePassword($passopen, $administrador->getSalt());
            $administrador->setPassword($passwordCodificado);
            $administrador->setPasscifrada(Cipher::crypt($passopen));
            $em->persist($administrador);
            $em->flush();
            
            $briefing = new briefing();
            $briefing->setAdministrador($administrador);
            $administrador->setBriefing($briefing);
            $em->persist($briefing);
            $em->persist($administrador);
            $em->flush();
            
            $creado = 1;
        }else{
            $errorcode = 1;
            $errormessage = "Error en la creación del administrador";
        }
        
        return array($errorcode, $errormessage, $creado);
    }
}
