<?php


namespace CoreBundle\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use CoreBundle\Entity\Cipher;

class verificacionusersCommand extends Command
{     
    protected function configure(){
        $this->setName('verificacion:users')
            ->setDescription('Notificacion a aplicacion');
    }

    protected function execute(InputInterface $input, OutputInterface $output){
        $output->writeln("Comunicación de avisos");
        $em = $this->getApplication()->getKernel()->getContainer()->get('doctrine')->getEntityManager();
        $usuarios = $em->getRepository('UsuarioBundle:usuario')->findExpirados();
        if(count($usuarios)>0){
            //$url = "http://local.edewis.com/app_dev.php/reservar-subdominio/";
            
            foreach($usuarios as $usuario){
                $business = $usuario->getBusiness();
                $url = $business->getURLGenerica()."/gestion-expirados/";
                $fecha = new \DateTime();
                $passopen = Cipher::decrypt($usuario->getPasscifrada());
                $post = ['passopen' => $passopen,
                         "email" => $usuario->getEmail() . "",
                         "nombre" => $usuario->getNombre(). "",
                         "apellidos" => $usuario->getApellidos()."",
                         "fecha" => $fecha->format("d/m/Y"),
                         "telefono" => $usuario->getTelefono(),
                         "expirado" => 1];
                
                $myjson = json_encode($post);
                $key =   $this->getApplication()->getKernel()->getContainer()->getParameter('keycrypt');
                $iv = $this->getApplication()->getKernel()->getContainer()->getParameter('ivcrypt');
                $jsonencrypt = Cipher::crypt($myjson);
                
                $kernel = $this->getApplication()->getKernel();
                $isdebug = $kernel->isDebug();
                if ($isdebug == false){
                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonencrypt);
                    $response = curl_exec($ch);
                    // close the connection, release resources used
                    curl_close($ch);
                    // do anything you want with your response
                    $responsejson = json_decode($response, true);
                    $errorcode = intval($responsejson["errorcode"]);
                
                    if ($errorcode == 0){
                        $usuario->setPlanactivo(0);
                        $em->persist($usuario);
                        $em->flush();
                    }
                }
            }
        }
    }
}