<?php

namespace CoreBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use CoreBundle\Entity\category;
use CoreBundle\Form\categoryType;

class CategoryController extends Controller
{
    public function indexAction()
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $categories = $em->getRepository('CoreBundle:category')->findCategories();

            return $this->render('CoreBundle:Category:index.html.twig' ,
                                array(  "categories" => $categories));
        }
        return $this->redirectToRoute('login');
    }
    
    public function editAction(Request $request, $id)
    {
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $em = $this->getDoctrine()->getManager();
            if($id == NULL){
                $id = -1;
            }
            $category = $em->getRepository('CoreBundle:category')->find($id);
            if($category == NULL){
                $category = new category();
            }
            
            $form = $this->createForm(categoryType::class, $category, 
                            array("attr" => array("disabled" => FALSE)));
            if($request->getMethod() == 'POST'){
                 $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) {
                        $em->persist($category);
                        $em->flush();
                        return $this->redirectToRoute('category_index');
                    }
            }
            return $this->render('CoreBundle:Category:edit.html.twig',
                    array('form'=>$form->createView(), 
                        'category'=>$category));
        }
        return $this->redirectToRoute('category_index');
    }
    
    public function deleteAction($id){
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $category = $em->getRepository('CoreBundle:category')->find($id);
            if($category){
                $category->setDeleted(1);
                $em->persist($category);
                $em->flush();
            }
        }
        return $this->redirectToRoute('category_index');    
    }
}
