<?php

namespace CoreBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use CoreBundle\Entity\subcategory;
use CoreBundle\Form\subcategoryType;

class SubcategoryController extends Controller
{
    public function indexAction($idcategory)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $category = $em->getRepository('CoreBundle:category')->find($idcategory);
            if ($category != NULL){
                $subcategories = $em->getRepository('CoreBundle:subcategory')->findSubcategories($idcategory);

                return $this->render('CoreBundle:Subcategory:index.html.twig' ,
                                array( "subcategories" => $subcategories,
                                    "category" => $category));
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function editAction(Request $request, $idcategory, $id)
    {
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $em = $this->getDoctrine()->getManager();
            $category = $em->getRepository('CoreBundle:category')->find($idcategory);
            if ($category != NULL){
                if($id == NULL){
                    $id = -1;
                }
                $subcategory = $em->getRepository('CoreBundle:subcategory')->find($id);
                if($subcategory == NULL){
                    $subcategory = new subcategory();
                    $subcategory->setCategory($category);
                }

                $form = $this->createForm(subcategoryType::class, $subcategory, 
                                array("attr" => array("disabled" => FALSE)));
                if($request->getMethod() == 'POST'){
                     $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) {
                            $em->persist($subcategory);
                            $em->flush();
                            return $this->redirectToRoute('subcategory_index', 
                                    array("idcategory" => $idcategory));
                        }
                }
                return $this->render('CoreBundle:Subcategory:edit.html.twig',
                        array('form'=>$form->createView(), 
                            'category'=>$category,
                            "subcategory" => $subcategory));
            }
        }
        return $this->redirectToRoute('subcategory_index', array("idcategory" => $idcategory));
    }
    
    public function deleteAction($idcategory, $id){
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $category = $em->getRepository('CoreBundle:category')->find($idcategory);
            if ($category != NULL){
                $subcategory = $em->getRepository('CoreBundle:subcategory')->find($id);
                if($subcategory){
                    $subcategory->setDeleted(1);
                    $em->persist($subcategory);
                    $em->flush();
                }
            }
        }
        return $this->redirectToRoute('subcategory_index', array("idcategory" => $idcategory));    
    }
}
