<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace CoreBundle\Entity;
use CoreBundle\Entity\Utils;
use WebBundle\Entity\web;
use Symfony\Component\Process\Process;
use Symfony\Component\Process\Exception\ProcessFailedException;

class Domainutils {
    static public function crearplan($documentroot, $dominio, $server){
        $root ="php " . $documentroot . "/../apidominios/crearplan.php " . $server . " " . $dominio;
        
        Utils::crearlogpeticion("crearplan", $root);
        $process = new Process($root);
        $process->run();
        if (!$process->isSuccessful()) {
            throw new ProcessFailedException($process);
        }
        $response = $process->getOutput();
        
        Utils::crearlogpeticion("crearplan", $response);
        $code = 0;
        $array = json_decode($response, TRUE);
        if (isset($array["_code"])){
            $code = intval($array["_code"]);
        }
        return $code;
    }
    
    static public function crearemail($documentroot, $email, $pass){
        $root ="php " . $documentroot . "/../apidominios/emailcrear.php " . $email . " " . $pass;
        $process = new Process($root);
        $process->run();
        if (!$process->isSuccessful()) {
            throw new ProcessFailedException($process);
        }
        $response = $process->getOutput();
        $array = json_decode($response, TRUE);
        Utils::crearlogpeticion("emailcrear", $response);
        
        $code = 200;
        $error = "";
        $message = "";
        if (isset($array["_code"])){
            $code = intval($array["_code"]);
        }
        if (isset($array["error"])){
            $error = $array["error"];
        }
        if (isset($array["message"])){
            $message = $array["message"];
        }
        
        return array($code, $error, $message);
    }
    
    static public function actualizaremail($documentroot, $email, $pass){
        $root ="php " . $documentroot . "/../apidominios/emailactualizar.php " . $email . " " . $pass;
        $process = new Process($root);
        $process->run();
        if (!$process->isSuccessful()) {
            throw new ProcessFailedException($process);
        }
        $response = $process->getOutput();
        $array = json_decode($response, TRUE);
        Utils::crearlogpeticion("actualizaremail", $response);
        $code = 200;
        $error = "";
        $message = "";
        if (isset($array["_code"])){
            $code = intval($array["_code"]);
        }
        if (isset($array["error"])){
            $error = $array["error"];
        }
        if (isset($array["message"])){
            $message = $array["message"];
        }
        return array($code, $error, $message);
    }
    
    static public function eliminaremail($documentroot, $email){
        $root ="php " . $documentroot . "/../apidominios/emaileliminar.php " . $email;
        $process = new Process($root);
        $process->run();
        if (!$process->isSuccessful()) {
            throw new ProcessFailedException($process);
        }
        $response = $process->getOutput();
        $array = json_decode($response, TRUE);
        
        Utils::crearlogpeticion("eliminaremail", $response);
        $code = 200;
        $error = "";
        $message = "";
        if (isset($array["_code"])){
            $code = intval($array["_code"]);
        }
        if (isset($array["error"])){
            $error = $array["error"];
        }
        if (isset($array["message"])){
            $message = $array["message"];
        }
        return array($code, $error, $message);
    }
    
    static public function crearsubdominioenweb($em, $usuario, $isdebug){
        $errorcode = 0;
        $errortext = "";
        
        $business = $usuario->getBusiness();
        if ($business && $usuario->getSubdominiocreado() == false ){
            $url = $business->getUrlcrearweb();
            if ($isdebug == true){
                $url .= "/app_dev.php/apires/reservar-subdominio2/";
            }else{
                $url .= "/apires/reservar-subdominio2/";
            }
            
            if ($usuario->getSubdominio() == NULL){
                $contador = $business->getContadorsubdominios() + 1;
                $business->setContadorsubdominios($contador);
                $em->persist($business);
                
                $suddomain = sprintf('d%03d', $contador);
                $suddomain .= $business->getUrlsubdominios();
                $usuario->setSubdominio($suddomain);
                $em->persist($usuario);
                $em->flush();
            }
            
            $fecha = new \DateTime();
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            
            $post = ['passopen' => $passopen,
                     "email" => $usuario->getEmail() . "",
                     "nombre" => $usuario->getNombre(). "",
                     "apellidos" => $usuario->getApellidos()."",
                     "fecha" => $fecha->format("d/m/Y"),
                     "telefono" => $usuario->getTelefono(),
                     "subdominio" => $usuario->getSubdominio(),
                    "tiendaactiva" => intval($usuario->getTiendaactiva())];
            
            $myjson = json_encode($post);
            $jsonencrypt = Cipher::crypt($myjson);
            $postcifrado = ['cifrado' => $jsonencrypt];
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postcifrado);
            $response = curl_exec($ch);
            // close the connection, release resources used
            curl_close($ch);
            //echo var_dump($response);
            // do anything you want with your response
            
            $responsejson = json_decode($response, true);
            $errorcode = intval($responsejson["errorcode"]);
            $errortext = $responsejson["errortext"];

            if ($errorcode == 0){
                $usuario->setSubdominiocreado(TRUE);
                $usuario->setCodigoverificacion(NULL);
                $em->persist($usuario);
                $em->flush();
            }
        }
        return array($usuario, $errorcode, $errortext);
    }
    
    static public function editarinformacion($em, $usuario, $briefing, $pathbanner, $pathlogo, $isdebug, $protocol){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business && $usuario->getSubdominiocreado() == true){
            $em->persist($briefing);
            $em->flush();
            
            $idstyle = 1;
            if ($business->getStyle() != NULL){
                $idstyle = $business->getStyle()->getEquilanciaedewis();
            }
            
            $urlbase = $protocol . "://" . $business->getUrlregistro();
            
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $plaintext = ['passopen' => $passopen,
                         "email" => $usuario->getEmail() . "",
                         "fecha" => $fecha->format("d/m/Y"),
                         "subdominio" => $usuario->getSubdominio()];
            
            $post = $briefing->getArrayvalores($plaintext);
            
            $url = $business->getUrlcrearweb();
            if ($isdebug == true){
                $url .= "/app_dev.php/apires/editar-informacionv2/";
            }else{
                $url .= "/apires/editar-informacionv2/";
            }
            
            if ($pathbanner != NULL && strlen($pathbanner) > 0){
                $post["pathbanner"] =  $urlbase . $pathbanner;
            }else{
                $post["pathbanner"] = "";
            }
            if ($pathlogo != NULL && strlen($pathlogo) > 0){
                $post["pathlogo"] =  $urlbase . $pathlogo;
            }else{
                $post["pathlogo"] = "";
            }
            
            $post["style"] = $idstyle;
            $post["tiendaactiva"] = intval($usuario->getTiendaactiva());
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            $errorcode = intval($responsejson["errorcode"]);
        }
    }
    
    static public function crearaplicacion($usuario, $pathbanner, $pathlogo, $protocol){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business 
                && $usuario->getAplicacioncreada() == false 
                && $business->getUrlcrearapp() != NULL){
            $plan = $usuario->getPlanseleccionado();
            $idplan = -1;
            if ($plan != NULL){
                $idplan = $plan->getId();
            }
            $fechaexpiracion = "";
            if ($usuario->getFechaexpiracion()){
                $fechaexpiracion = $usuario->getFechaexpiracion()->format("d/m/Y");
            }else{
                $now = new \DateTime();
                $fechaexpiracion = $now->format("d/m/Y");
            }
            $urlbase = $protocol . "://" .  $business->getUrlregistro();
            
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "createapp");
            $params = ['passopen' => $passopen,
                         "email" => $usuario->getEmail() . "",
                         "fecha" => $fecha->format("d/m/Y"),
                         "nombredeapp" => $usuario->getNombredeapp()];
            if ($pathbanner != NULL && strlen($pathbanner) > 0){
                $params["pathbanner"] =  $urlbase . $pathbanner;
            }else{
                $params["pathbanner"] = "";
            }
            if ($pathlogo != NULL && strlen($pathlogo) > 0){
                $params["pathlogo"] =  $urlbase . $pathlogo;
            }else{
                $params["pathlogo"] = "";
            }
            $params["idplan"] = $idplan;
            $params["fechaexpiracion"] = $fechaexpiracion;
            $post["params"] = $params;
            
            $url = $business->getUrlcrearapp();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            Utils::crearlogpeticion("crearaplicacion", $response);
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            Utils::crearlogpeticion("crearaplicacion", json_encode($return));
            
            return array($errorcode, $errormessage, $return);
        }
    }
    
    static public function actualizarfechaexpiracion($usuario, $fechaexpiracion){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business){
            if ($usuario->getFechaexpiracion()){
                $fechaexpiracion = $usuario->getFechaexpiracion()->format("d/m/Y");
            }else{
                $now = new \DateTime();
                $fechaexpiracion = $now->format("d/m/Y");
            }
            
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "updateexpirationdate");
            $params = ['passopen' => $passopen,
                         "email" => $usuario->getEmail() . "",
                         "usuarioapp" => $usuario->getUsuarioapp() . "",
                         "fecha" => $fecha->format("d/m/Y")];
            $params["fechaexpiracion"] = $fechaexpiracion;
            $post["params"] = $params;
            
            $url = $business->getUrlcrearapp();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            return array($errorcode, $errormessage, $return);
        }
    }
    
    static public function activaraplicacion($usuario, $fechaexpiracion){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business){
            if ($usuario->getFechaexpiracion()){
                $fechaexpiracion = $usuario->getFechaexpiracion()->format("d/m/Y");
            }else{
                $now = new \DateTime();
                $fechaexpiracion = $now->format("d/m/Y");
            }
            
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "activateapp");
            $params = ['passopen' => $passopen,
                         "email" => $usuario->getEmail() . "",
                         "usuarioapp" => $usuario->getUsuarioapp() . "",
                         "fecha" => $fecha->format("d/m/Y"),
                        "idapp" => $usuario->getIdapp()];
            $params["fechaexpiracion"] = $fechaexpiracion;
            $post["params"] = $params;
            
            $url = $business->getUrlcrearapp();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            return array($errorcode, $errormessage, $return);
        }
    }
    
    static public function desactivaraplicacion($usuario){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business){
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "disabledapp");
            $params = ['passopen' => $passopen,
                        "email" => $usuario->getEmail() . "",
                        "usuarioapp" => $usuario->getUsuarioapp() . "",
                        "fecha" => $fecha->format("d/m/Y"),
                        "idapp" => $usuario->getIdapp()];
            $post["params"] = $params;
            
            $url = $business->getUrlcrearapp();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            return array($errorcode, $errormessage, $return);
        }
    }
    
    static public function actualizarpass($usuario, $lastpass){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business){
            $newpass = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "updatepassword");
            $params = ['passopen' => $lastpass,
                        "email" => $usuario->getEmail() . "",
                        "usuarioapp" => $usuario->getUsuarioapp() . "",
                        "fecha" => $fecha->format("d/m/Y"),
                        "newpass" => $newpass];
            $post["params"] = $params;
            
            $url = $business->getUrlcrearapp();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            return array($errorcode, $errormessage, $return);
        }
    }
    
    static public function actualizarpassweb($usuario, $lastpass){
        $fecha = new \DateTime();
        $business = $usuario->getBusiness();
        if ($business){
            $newpass = Cipher::decrypt($usuario->getPasscifrada());
            $post = array("action" => "updatepassword");
            $params = ['passopen' => $lastpass,
                        "email" => $usuario->getEmail() . "",
                        "fecha" => $fecha->format("d/m/Y"),
                        "newpass" => $newpass];
            $post["params"] = $params;
            
            $url = $business->getUrlapiweb();
            
            $myjson = json_encode($post);
            $data_string = Cipher::crypt($myjson);
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                'Content-Type: application/json',                                                                                
                'Content-Length: ' . strlen($data_string))                                                                       
            ); 
            $response = curl_exec($ch); 
            curl_close($ch);
            $responsejson = json_decode($response, true);
            
            $errorcode = $responsejson["errorcode"];
            $errormessage = $responsejson["errormessage"];
            $return = $responsejson["return"];
            
            return array($errorcode, $errormessage, $return);
        }
    }
}
