<?php

namespace CoreBundle\Entity;

class Utils {
    
    public static function convertirdatetime($c){
        $date = date('d/m/Y H:i:s', $c); 
        return $date;
    }
    
    public static function limpiardominio($dominio) {
        $dominio = str_replace(" ", "", $dominio);
        $dominio = str_replace("www", "", $dominio);
        $dominio = str_replace("https", "", $dominio);
        $dominio = str_replace("http", "", $dominio);
        $dominio = str_replace(":", "", $dominio);
        $dominio = str_replace("/", "", $dominio);
        return $dominio;
    }    
    
    public static function validarextension($domain){
        $good_domains = array('.es', '.com'); //in the future, just add to this array for more schools
        
        $ext = strstr($domain, '.'); 
        if(in_array($ext, $good_domains)){
            $error = 0;
            $texto = "";
        }else{
            $error = 4;
            $texto = "El dominio solo puede ser .es o .com";
        }
        return array($error, $texto);
    }
    
    function getfont($indice){
        $letra = "./fonts/";
        switch ($indice) {
            case 0:
                $letra .= "Nunito-Regular.ttf";
                break;
            case 1:
                $letra .= "Roboto-Regular.ttf";
                break;
            case 2:
                $letra .= "Cairo-Regular.ttf";
                break;
            case 3:
                $letra .= "MerriweatherSans-Regular.ttf";
                break;
            case 4:
                $letra .= "OpenSans-Regular.ttf";
                break;
            case 5:
                $letra .= "Poppins-Regular.ttf";
                break;
            case 6:
                $letra .= "WorkSans-Regular.ttf";
                break;
            default:
                $letra .= "Nunito-Regular.ttf";
                break;
        }
        return $letra;
    }
    
    function TextToImage_my(
        $text, 
        $path,
        $separate_line_after_chars=40,  
        $font='./myfont.ttf', 
        $size=24,
        $rotate=0,
        $padding=2,
        $transparent=true, 
        $color=array('red'=>0,'grn'=>0,'blu'=>0), 
        $bg_color=array('red'=>0,'grn'=>0,'blu'=>0) 
        ){
        $amount_of_lines= ceil(strlen($text)/$separate_line_after_chars);
        $x=explode("\n", $text); $final='';
        foreach($x as $key=>$value){
            $returnes='';
            do{ $first_part=mb_substr($value, 0, $separate_line_after_chars, 'utf-8');
                $value= "\n".mb_substr($value, $separate_line_after_chars, null, 'utf-8');
                $returnes .=$first_part;
            }  while( mb_strlen($value,'utf-8')>$separate_line_after_chars);
            $final .= $returnes."\n";
        }
        $text=$final;
        $width=$height=$offset_x=$offset_y = 0;
        if(!is_file($font)) { file_put_contents($font,file_get_contents('https://github.com/edx/edx-certificates/raw/master/template_data/fonts/Arial%20Unicode.ttf')); }

        // get the font height.
        $bounds = ImageTTFBBox($size, $rotate, $font, "W");
        if ($rotate < 0)        {$font_height = abs($bounds[7]-$bounds[1]); } 
        elseif ($rotate > 0)    {$font_height = abs($bounds[1]-$bounds[7]); } 
        else { $font_height = abs($bounds[7]-$bounds[1]);}
        // determine bounding box.
        $bounds = ImageTTFBBox($size, $rotate, $font, $text);
        if ($rotate < 0){       $width = abs($bounds[4]-$bounds[0]);                    $height = abs($bounds[3]-$bounds[7]);
                                $offset_y = $font_height;                               $offset_x = 0;
        } 
        elseif ($rotate > 0) {  $width = abs($bounds[2]-$bounds[6]);                    $height = abs($bounds[1]-$bounds[5]);
                                $offset_y = abs($bounds[7]-$bounds[5])+$font_height;    $offset_x = abs($bounds[0]-$bounds[6]);
        } 
        else{                   $width = abs($bounds[4]-$bounds[6]);                    $height = abs($bounds[7]-$bounds[1]);
                                $offset_y = $font_height;                               $offset_x = 0;
        }

        $image = imagecreate($width+($padding*2)+1,$height+($padding*2)+1);

        $background = ImageColorAllocate($image, $bg_color['red'], $bg_color['grn'], $bg_color['blu']);
        $foreground = ImageColorAllocate($image, $color['red'], $color['grn'], $color['blu']);

        if ($transparent) ImageColorTransparent($image, $background);
        ImageInterlace($image, true);

        ImageTTFText($image, $size, $rotate, $offset_x+$padding, $offset_y+$padding, $foreground, $font, $text);
        imagealphablending($image, true);
        imagesavealpha($image, true);

        imagepng($image, $path);
    }
    
    function mb_substr_replace($string, $replacement, $start, $length = null, $encoding = "UTF-8") {
        if (extension_loaded('mbstring') === true){
            $string_length = (is_null($encoding) === true) ? mb_strlen($string) : mb_strlen($string, $encoding);
            if ($start < 0) { $start = max(0, $string_length + $start); }
            else if ($start > $string_length) {$start = $string_length; }
            if ($length < 0){ $length = max(0, $string_length - $start + $length);  }
            else if ((is_null($length) === true) || ($length > $string_length)) { $length = $string_length; }
            if (($start + $length) > $string_length){$length = $string_length - $start;} 
            if (is_null($encoding) === true) {  return mb_substr($string, 0, $start) . $replacement . mb_substr($string, $start + $length, $string_length - $start - $length); }
            return mb_substr($string, 0, $start, $encoding) . $replacement . mb_substr($string, $start + $length, $string_length - $start - $length, $encoding);
        }
        return (is_null($length) === true) ? substr_replace($string, $replacement, $start) : substr_replace($string, $replacement, $start, $length);
    }
    
    public static function generateRandomString($length = 5) {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
    
    public static function encrypt($plaintext, $key) {
        $plaintext = Utils::pkcs5_pad($plaintext, 16);
        return bin2hex(mcrypt_encrypt(MCRYPT_RIJNDAEL_128, hex2bin($key), $plaintext, MCRYPT_MODE_CBC));
    }

    public static function decrypt($encrypted,$unusableKey) {
        /* Really we dont use the second param yet */
        /*echo 'clave origal ';
        var_dump($key);
        $decrypted = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, hex2bin($key), hex2bin($encrypted), MCRYPT_MODE_CBC);
        echo $encrypted . ' desencriptado queda : ';
        var_dump($decrypted);
        $padSize = ord(substr($decrypted, -1));
        return substr($decrypted, 0, $padSize*-1);*/
        $iv = 'wlQsLR7qEk2pbd4W'; #Same as in JAVA
        $key = 'fe8XEHbp81M3tpUN'; #Same as in JAVA
        $code = Utils::hex2bin($encrypted);

        $td = mcrypt_module_open('rijndael-128', '', 'cbc', $iv);

        mcrypt_generic_init($td, $key, $iv);
        $decrypted = mdecrypt_generic($td, $code);

        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);

        return utf8_encode(trim($decrypted));
    }

    public static function pkcs5_pad ($text, $blocksize)
    {
        $pad = $blocksize - (strlen($text) % $blocksize);
        return $text . str_repeat(chr($pad), $pad);
    }
    
    public static function hex2bin($hexdata) {
        $bindata = '';
        for ($i = 0; $i < strlen($hexdata); $i += 2) {
              $bindata .= chr(hexdec(substr($hexdata, $i, 2)));
        }
        return $bindata;
    }
    
    public static function actualizartam($em, $weeventouser) {
        if ($weeventouser != NULL){
            $sumtam = $em->getRepository("FileBundle:image")->findsumtam($weeventouser->getId());
            $tam = floatval($sumtam[0][1]);
            $tammin = floatval($sumtam[0][1]);
            $weeventouser->setTamfotos($tam + $tammin);
            $em->persist($weeventouser);
            $em->flush();
            $weevento = $weeventouser->getWhatevent();
            $dir = $weevento->getRuta();
            $size = Utils::foldersize($dir);
            $weevento->setCapacidadocupada($size);
            $em->persist($weevento);
            $em->flush();
        }
    }
    
    public static function foldersize($dir){
        $count_size = 0;
        $count = 0;
        $dir_array = scandir($dir);
        foreach($dir_array as $key => $filename){
            if($filename!=".." && $filename!="."){
                if(is_file($dir."/".$filename)){
                    $count_size = $count_size + filesize($dir."/".$filename);
                    $count++;
                }
            }
        }
        $size = (($count_size / 1024) / 1024);
        return $size;
    }
    
    public static function encriptar($cadena){
        $key='uVd]PzWbJAmQw6g}';  // Una clave de codificacion, debe usarse la misma para encriptar y desencriptar
        $encrypted = base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, md5($key), $cadena, MCRYPT_MODE_CBC, md5(md5($key))));
        return $encrypted; //Devuelve el string encriptado
    }

    public static function desencriptar($cadena){
         $key='uVd]PzWbJAmQw6g}';  // Una clave de codificacion, debe usarse la misma para encriptar y desencriptar
         $decrypted = rtrim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, md5($key), base64_decode($cadena), MCRYPT_MODE_CBC, md5(md5($key))), "\0");
        return $decrypted;  //Devuelve el string desencriptado
    }
    
    public static function getMes($mes){
        $intmes = intval($mes);
        $arraymeses = array("Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", 
            "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre");
        if ($intmes >= 0 && $intmes < 12){
            return $arraymeses[$intmes];
        }else{
            return "";
        }
    }
    
    public static function crearlogpeticion($sufijo, $linea){
        $now = new \DateTime();
        $name = $now->format("d-m-Y") . "-" . $sufijo . ".txt";
        $ruta = "../logs/" . $name;
        if (!file_exists($ruta)){
            $fp = fopen($ruta, "wb");
            fwrite($fp,"");
            fclose($fp);
        }else{
            // se mira el tamaño del fichero
            $tam = Utils::filesize_formatted($ruta);
            if ($tam >= 5){
                // si es de 5 megas se crea uno nuevo
                // se busca si existe un fichero
                $indice = 1;
                $rutacp = "../logs/" . $now->format("d-m-Y") . "-" . $indice . "-" . $sufijo  . ".txt";
                while(file_exists($rutacp) && $indice < 10){
                    $indice += 1;
                    $rutacp = "../logs/" . $now->format("d-m-Y") . "-" . $indice . "-" . $sufijo  . ".txt";
                }
                rename($ruta, $rutacp);
                $fp = fopen($ruta, "wb");
                fwrite($fp,"");
                fclose($fp);
            }
        }
        $fp = fopen($ruta, "a");
        $linea = $linea . ";";
        $linea .= "\t\n";
        fwrite($fp, $linea);
        fclose($fp);
    }
    
    public static function filesize_formatted($file){
        $bytes = filesize($file);
        return $bytes / 1048576;
    }
}