<?php

namespace IncidenciaBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use IncidenciaBundle\Form\incidenciaminType;
use IncidenciaBundle\Entity\incidencia;
use Symfony\Component\BrowserKit\Response;

class SoporteController extends Controller
{
    public function indexAction(Request $request)
    {
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        if ($business && $usuario != NULL && $business->getId() == $usuario->getBusiness()->getId() ){
            $style = $business->getStyle();
            if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
                
                $incidencias = $em->getRepository("IncidenciaBundle:incidencia")
                        ->findIncidenciasadministrador($usuario->getId());
                
                return $this->render('IncidenciaBundle:Soporte:index.html.twig', 
                        array("usuario" => $usuario,
                            "business" => $business,
                            'style'=>$style,
                            "incidencias" => $incidencias));
            }
        }
        return $this->redirectToRoute("public_panel-index-user");
    }
    
    public function editAction(Request $request, $id)
    {
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        if ($business && $usuario != NULL && $business->getId() == $usuario->getBusiness()->getId() ){
            $style = $business->getStyle();
            if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
                if ($id == NULL){
                    $id = -1;
                }
                
                $incidencia = $em->getRepository("IncidenciaBundle:incidencia")
                        ->find($id);
                if ($incidencia == NULL || $incidencia->getAdministrador()->getId() != $usuario->getId()){
                    $incidencia = new incidencia();
                    $incidencia->setAdministrador($usuario);
                }
                $form = $this->createForm(incidenciaminType::class, $incidencia, 
                        array("attr" => array("disabled" => FALSE)));
                if ($request->getMethod() == "POST"){
                    $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) {
                        $em->persist($incidencia);
                        $em->flush();
                        
                        $ruta = $incidencia->getRuta();
                        foreach ($_FILES as $n => $key) {
                            if($key['error'] == UPLOAD_ERR_OK ){                        
                                $name = $key['name'];
                                $ext = pathinfo($name, PATHINFO_EXTENSION);
                                mt_srand (time());
                                $nombretemporal = $incidencia->getId() .  "-documento" ;
                                $rand = rand(1, 1000);
                                $namefinal = $nombretemporal . "-" . $rand . "." . $ext;
                                $temporal = $key['tmp_name']; //Obtenemos el nombre del archivo temporal
                                if ($key['type'] == 'image/png' || 
                                    $key['type'] == 'image/jpg' || 
                                    $key['type'] == 'image/jpeg'){
                                    move_uploaded_file($temporal, $ruta . $namefinal);
                                    $incidencia->removeUpload();
                                    $incidencia->setPathdocumento($namefinal);
                                    $em->persist($incidencia);
                                    $em->flush();
                                }
                            }else{
                                // $key['error']; //Si no se cargo mostramos el error
                            }
                        }
                        
                        return $this->redirectToRoute("soporte");
                    }
                }
                return $this->render('IncidenciaBundle:Soporte:edit.html.twig', 
                        array("usuario" => $usuario,
                            "business" => $business,
                            'style'=>$style,
                            "incidencia" => $incidencia,
                            "form" =>$form->createView()));
            }
        }
        return $this->redirectToRoute("public_panel-index-user");
    }
    
    public function imagenAction($id){
        $em = $this->getDoctrine()->getManager();
        if($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
            $incidencia = $em->getRepository("IncidenciaBundle:incidencia")
                        ->find($id);
            if ($incidencia != NULL && $incidencia->getPathdocumento() != NULL){
                $ruta= $incidencia->getRuta() . $incidencia->getPathdocumento();
                if (file_exists($ruta)){
                    $headers = array('Content-Type' => "image/png",
                        'Content-Disposition' => 'inline; '
                        . 'filename="'.$ruta.'"');

                    $file =  readfile($ruta);
                    return new Response($file, 200, $headers); 
                }
            }
        }
        $response = new Response(json_encode(array()));
        return $response;
    }
}
