<?php

namespace IncidenciaBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * order
 *
 * @ORM\Table(name="incidencia")
 * @ORM\Entity(repositoryClass="IncidenciaBundle\Repository\incidenciaRepository")
 */
class incidencia
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
    
    /**
     * @var client
     *
     * @ORM\ManyToOne(targetEntity="UsuarioBundle\Entity\administrador")
     */
    private $administrador;

    /**
     * @var string
     *
     * @ORM\Column(name="brevedescripcion", type="string", nullable=true)
     */
    private $brevedescripcion;

    /**
     * @var text
     *
     * @ORM\Column(name="respuestaadministracion", type="text", nullable=true)
     */
    private $respuestaadministracion;

    /**
     * @var text
     * 1 --> Dominios
     * 2 --> Alojamiento
     * 3 --> Facturación
     * @ORM\Column(name="tipo", type="integer")
     */
    private $tipo;

    /**
     * @var text
     *
     * @ORM\Column(name="descripcion", type="text", nullable=true)
     */
    private $descripcion;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="createdAt", type="datetime")
     */
    private $createdAt;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="fecharesuelta", type="datetime", nullable=true)
     */
    private $fecharesuelta;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="resuelta", type="boolean", nullable=true)
     */
    private $resuelta; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="eliminada", type="boolean", nullable=true)
     */
    private $eliminada; 

    /**
     * @var string
     *
     * @ORM\Column(name="pathdocumento", type="string", nullable=true)
     */
    private $pathdocumento;
    
    public function getRuta(){
        return "./../data/soporte/";
    }
    
    public function removeUpload(){
        if ($this->getPathdocumento()){
            $file = $this->getRuta() . $this->getPathdocumento();
            if (file_exists($file)){
                unlink($file);
            }
        }
    }
    
    public function getTextotipo(){
        $texto = "";
        switch ($this->getTipo()){
            case 1:
                $texto = "Dominios";
                break;
            case 2:
                $texto = "Alojamiento";
                break;
            case 3:
                $texto = "Facturación";
                break;
        }
        return $texto;
    }
    
    public function __toString() {
        return $this->getBrevedescripcion();
    }
    
    public function getTextoresuelta(){
        if ($this->getResuelta() == false){
            return "NO";
        }else{
            $texto = "SI";
            if ($this->getFecharesuelta() != NULL){
                $texto .= " - " . $this->getFecharesuelta()->format("d/m/Y H:i");
            }
            return $texto;
        }
    }
    
    public function __construct() {
        $this->createdAt = new \DateTime();
        $this->resuelta = FALSE;
        $this->eliminada = FALSE;
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set brevedescripcion
     *
     * @param string $brevedescripcion
     *
     * @return incidencia
     */
    public function setBrevedescripcion($brevedescripcion)
    {
        $this->brevedescripcion = $brevedescripcion;

        return $this;
    }

    /**
     * Get brevedescripcion
     *
     * @return string
     */
    public function getBrevedescripcion()
    {
        return $this->brevedescripcion;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     *
     * @return incidencia
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string
     */
    public function getDescripcion($length = null)
    {
        if ($length < strlen($this->descripcion)){
            return substr($this->descripcion, 0, 50);
        }
        return $this->descripcion;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     *
     * @return incidencia
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set fecharesuelta
     *
     * @param \DateTime $fecharesuelta
     *
     * @return incidencia
     */
    public function setFecharesuelta($fecharesuelta)
    {
        $this->fecharesuelta = $fecharesuelta;

        return $this;
    }

    /**
     * Get fecharesuelta
     *
     * @return \DateTime
     */
    public function getFecharesuelta()
    {
        return $this->fecharesuelta;
    }

    /**
     * Set resuelta
     *
     * @param boolean $resuelta
     *
     * @return incidencia
     */
    public function setResuelta($resuelta)
    {
        $this->resuelta = $resuelta;

        return $this;
    }

    /**
     * Get resuelta
     *
     * @return boolean
     */
    public function getResuelta()
    {
        return $this->resuelta;
    }

    /**
     * Set administrador
     *
     * @param \UsuarioBundle\Entity\administrador $administrador
     *
     * @return incidencia
     */
    public function setAdministrador(\UsuarioBundle\Entity\administrador $administrador = null)
    {
        $this->administrador = $administrador;

        return $this;
    }

    /**
     * Get administrador
     *
     * @return \UsuarioBundle\Entity\administrador
     */
    public function getAdministrador()
    {
        return $this->administrador;
    }

    /**
     * Set eliminada
     *
     * @param boolean $eliminada
     *
     * @return incidencia
     */
    public function setEliminada($eliminada)
    {
        $this->eliminada = $eliminada;

        return $this;
    }

    /**
     * Get eliminada
     *
     * @return boolean
     */
    public function getEliminada()
    {
        return $this->eliminada;
    }

    /**
     * Set respuestaadministracion
     *
     * @param string $respuestaadministracion
     *
     * @return incidencia
     */
    public function setRespuestaadministracion($respuestaadministracion)
    {
        $this->respuestaadministracion = $respuestaadministracion;

        return $this;
    }

    /**
     * Get respuestaadministracion
     *
     * @return string
     */
    public function getRespuestaadministracion()
    {
        return $this->respuestaadministracion;
    }

    /**
     * Set tipo
     *
     * @param integer $tipo
     *
     * @return incidencia
     */
    public function setTipo($tipo)
    {
        $this->tipo = $tipo;

        return $this;
    }

    /**
     * Get tipo
     *
     * @return integer
     */
    public function getTipo()
    {
        return $this->tipo;
    }

    /**
     * Set pathdocumento
     *
     * @param string $pathdocumento
     *
     * @return incidencia
     */
    public function setPathdocumento($pathdocumento)
    {
        $this->pathdocumento = $pathdocumento;

        return $this;
    }

    /**
     * Get pathdocumento
     *
     * @return string
     */
    public function getPathdocumento()
    {
        return $this->pathdocumento;
    }
}
