<?php

namespace LoginBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;

class LoginController extends Controller
{
    public function loginAction(Request $request){
        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true
                || $this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
            return $this->redirectToRoute("logout");
        }
        $authenticationUtils = $this->get('security.authentication_utils'); 
        // get the login error if there is one 
        $error = $authenticationUtils->getLastAuthenticationError(); 
        // last username entered by the user 
        $lastUsername = $authenticationUtils->getLastUsername();
        $host = $request->getHost();
        
        $em = $this->getDoctrine()->getManager(); 
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        $style = NULL;
        if ($business){
            $style = $business->getStyle();
        }
        return $this->render( 'LoginBundle:login:index.html.twig', array( 
            // last username entered by the user 
            'last_username' => $lastUsername, 
            'error' => $error, 
            "business" => $business,
            "style" => $style));
    }
}
