<?php

namespace PagoBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use PagoBundle\Entity\pago;
use CoreBundle\Entity\ApiRedsys;
use CoreBundle\Entity\Cipher;
use Symfony\Component\HttpFoundation\Response;


class StripeController extends Controller
{   
    public function indexAction(Request $request, $idpago)
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            $pago = $em->getRepository('PagoBundle:pago')->find($idpago);
            if ($pago != NULL){
                $business = $usuario->getBusiness();
                //integrar stripe
                // instalar --> composer require stripe/stripe-php
                // https://stripe.com/docs/libraries#php
                $importe = $pago->getTotal()*100;
                if($request->getMethod()=="POST"){
                    $idplan = $business->getIdplanactivostripe();
                    if($idplan > 0){
                        \Stripe\Stripe::setApiKey($business->getClavestripe());
                        $token = $_POST['stripeToken'];
                        $customer = \Stripe\Customer::create([
                            'email' => $usuario->getEmail(),
                            'source' => $token,
                        ]);
                        $subscription =  \Stripe\Subscription::create([
                          "customer" => $customer->id,
                          "items" => [
                            [
                              "plan" => $idplan,
                            ],
                          ]
                        ]);
                        
                        var_dump($subscription);
                        die();

                        //if ($subscription->paid == true) {   // hay que ver si llega aqui en un pago fallido
                            $pago->setDatepayment(new \DateTime());
                            $pago->setEstado(2);
                            $pago->setPaymentform(2);
                            $pago->setPagado(TRUE);
                            $em->persist($pago);
                            $usuario = $pago->getUsuario();
                            $fecha = new \DateTime();
                            $fecha->add(new \DateInterval('P30D'));
                            $usuario->setFechaexpiracion($fecha);
                            $usuario->setPlanactivo(1);
                            $em->persist($usuario);
                            $em->flush();


                            return $this->redirectToRoute('tpv_index');
                        //}
                    }else{
                        $error = '<br>Plan no definido';
                    }    
                }
                return $this->render('PagoBundle:pasarelapago:pagostripe.html.twig',
                        array( 'precio'=> $importe,
                                'volver'=>1,
                                'pago'=>$pago,
                                "usuario" => $usuario));
            } 
        }
        return $this->redirectToRoute('tpv_index');
    }
    
    
    
}
