<?php

namespace PagoBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use PagoBundle\Entity\pago;
use CoreBundle\Entity\ApiRedsys;
use Symfony\Component\HttpFoundation\Response;

class TPVController extends Controller
{   
    public function successAction(Request $request)
    {
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $business = $usuario->getBusiness();
        if($business){
            $style = $business->getStyle();
            return $this->render('PagoBundle:pasarelapago:stripesuccess.html.twig',
                                array(  
                                    'business'=>$business,
                                    "usuario" => $usuario,
                                    "style" => $style
                                ));
        }
        return $this->redirectToRoute("public_panel-index-user");
    }
    
    public function canceledAction(Request $request)
    {
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $business = $usuario->getBusiness();
        if($business){
            $style = $business->getStyle();
            return $this->render('PagoBundle:pasarelapago:stripecanceled.html.twig',
                                array(  
                                    'business'=>$business,
                                    "usuario" => $usuario,
                                    "style" => $style
                                ));
        }
        return $this->redirectToRoute("public_panel-index-user");
    }
    
    public function confirmarpedidoAction(Request $request)
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            $business = $usuario->getBusiness();
            if($business){
                $style = $business->getStyle();
                if ($request->getMethod() == "POST"){
                    $idplan = $request->request->get("idplan");
                    if ($idplan > 0){
                        $plan = $em->getRepository('AdministracionBundle:plan')->find($idplan);
                        if ($plan != NULL && $business->getId() == $plan->getBusiness()->getId()){
                            $host = $request->getHost();
                            $protocol = $request->getScheme();
                            $urlsuccess = $protocol . "://" . $host . $this->generateUrl("tpv_actualizar_success");
                            $urlcanceled = $protocol . "://" . $host . $this->generateUrl("tpv_actualizar_canceled");
                            return $this->render('PagoBundle:pasarelapago:confirmarpedido.html.twig',
                                array(  
                                    'business'=>$business,
                                    "usuario" => $usuario,
                                    "plan" => $plan,
                                    "style" => $style,
                                    "urlsuccess" => $urlsuccess,
                                    "urlcanceled" => $urlcanceled
                                ));
                        }
                    }
                }
                  
            }
        }elseif(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            return $this->redirectToRoute('business_index');
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function actualizarplanAction(Request $request)
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            $business = $usuario->getBusiness();
            if($business){
                $style = $business->getStyle();
                $planes = $em->getRepository('AdministracionBundle:plan')
                    ->findPlanes($business->getId());
                return $this->render('PagoBundle:pasarelapago:actualizarplan.html.twig',
                        array(  
                            'business'=>$business,
                            "usuario" => $usuario,
                            "planes" => $planes,
                            "style" => $style
                        ));  
            }
        }elseif(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            return $this->redirectToRoute('business_index');
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function cancelarsuscripcionAction(Request $request)
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $business = $usuario->getBusiness();
            if($business){
                if ($usuario->getEventostripe() != NULL){
                    $eventostripe = $usuario->getEventostripe();
                    \Stripe\Stripe::setApiKey($business->getClavestripe());
                    $sub = \Stripe\Subscription::retrieve($eventostripe->getStripesubscriptionid());
                    $sub->cancel();
                }
                return $this->render('PagoBundle:pasarelapago:cancelarsuscripcion.html.twig',
                        array(  
                            'business'=>$business,
                            "usuario" => $usuario
                        ));  
            }
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function indexAction()
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            if($usuario->getPlanactivo() && $usuario->getTienepermiso()){//va a una pantalla de inicio para ver la web etc
                return $this->redirectToRoute('public_panel-index-user');
            }else{
                return $this->redirectToRoute("tpv_actualizar_plan");
                /*$em = $this->getDoctrine()->getManager();
                $business = $usuario->getBusiness();
                if($business){
                    $style = $business->getStyle();
                    $planes = $em->getRepository('AdministracionBundle:plan')
                        ->findPlanes($business->getId());
                    if ($request->getMethod() == "POST"){
                        $idplan = $request->request->get("idplan");
                        if ($idplan > 0){
                            $plan = $em->getRepository('AdministracionBundle:plan')->find($idplan);
                            if ($plan != NULL && $business->getId() == $plan->getBusiness()->getId()){
                                $usuario->setPlanseleccionado($plan);
                                $usuario->setCondominio($plan->getCondominio());
                                $usuario->setNumeromaximoemails($plan->getNumeromaximoemails());
                                $usuario->setCrmeactivo($plan->getCrmeactivo());
                                $usuario->setTiendaactiva($plan->getTiendaactiva());
                                $em->persist($usuario);
                                $em->flush();

                                return $this->redirectToRoute("tpv_confirmar_pago");
                            }
                        }
                    }
                    return $this->render('PagoBundle:pasarelapago:index.html.twig',
                            array(  
                                'business'=>$business,
                                "usuario" => $usuario,
                                "planes" => $planes,
                                "style" => $style
                            ));  
                }*/
                
            }
        }elseif(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            return $this->redirectToRoute('business_index');
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function confirmarpagoAction(Request $request)
    {
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $scheme = $request->getScheme() . "://";
            if($usuario->getPlanactivo() && $usuario->getTienepermiso()){//va a una pantalla de inicio para ver la web etc
                return $this->redirectToRoute("public_panel-index-user");
            }else{
                $em = $this->getDoctrine()->getManager();
                $business = $usuario->getBusiness();
                if($business){
                    /*$style = $business->getStyle();
                    $pago = new pago();
                    $pago->setBusiness($business);
                    
                    if($usuario->getPlanseleccionado()){
                        $total = $usuario->getPlanseleccionado()->getTotalmensual();
                        $taxes = $usuario->getPlanseleccionado()->getTaxes();
                    }else{
                       return $this->redirectToRoute('login'); 
                    }
                    
                    $pago->setSubtotal($total);
                    $pago->setTotal($total);
                    $pago->setTotaldescuento($total);
                    $pago->setTaxes($taxes);
                    $pago->setDescuento(0);
                    $pago->setUsuario($usuario);
                    $pago->setDeliveryName('Plan renove');
                    $em->persist($pago);
                    $em->flush();
                    
                    $redsysdefine = false;
                    $paypaldefine = ($business->getUsuariopaypal()!=NULL?true:false);
                    $stripedefine = ($usuario->getPlanseleccionado()->getIdplanstripe()!=NULL?true:false);
                    $params = $signature = NULL;
                    if($business->getFucvalid()!=NULL && $business->getKc()){
                        $redsysdefine = true;
                        $redsys = new ApiRedsys();
                        $amount = ($pago->getTotal()) * 100;

                        $url = $scheme . $usuario->getURLRegistro() . $this->generateUrl('pago_respuesta'); 
                        $urlOK = $scheme . $usuario->getURLRegistro()  . $this->generateUrl('renove_thanks');
                        $urlKO = $scheme . $usuario->getURLRegistro()  . $this->generateUrl('pago_incorrecto');
                        $order = $pago->getId();
                        if($order < 1000){//menos de 4 digitos
                            $order = str_pad($order, 4, "0", STR_PAD_LEFT); 
                        }

                        // Se rellenan los campos
                        $redsys->setParameter("DS_MERCHANT_AMOUNT", $amount);
                        $redsys->setParameter("DS_MERCHANT_ORDER", strval($order));
                        $redsys->setParameter("DS_MERCHANT_MERCHANTCODE", $business->getFucvalid());
                        $redsys->setParameter("DS_MERCHANT_CURRENCY", $business->getMoneda());
                        $redsys->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $business->getTrans());
                        $redsys->setParameter("DS_MERCHANT_TERMINAL", $business->getTerminal());
                        $redsys->setParameter("DS_MERCHANT_MERCHANTURL", $url);
                        $redsys->setParameter("DS_MERCHANT_URLOK", $urlOK);
                        $redsys->setParameter("DS_MERCHANT_URLKO", $urlKO);
                        $kc = $business->getKc();//Clave recuperada de CANALES
                        $params = $redsys->createMerchantParameters();
                        $signature = $redsys->createMerchantSignature($kc);
                    }
                    $importe = $pago->getTotal()*100;
                    return $this->render('PagoBundle:pasarelapago:seleccionpasarela.html.twig',
                            array(  'pago'=>$pago, 
                                    'business'=>$business,
                                    'params' => $params,
                                    'signature' => $signature,
                                    'redsysdefine' => $redsysdefine,
                                    'stripedefine' => $stripedefine,
                                    'paypaldefine' => $paypaldefine,
                                    "scheme" => $scheme,
                                    "style" => $style,
                                    "precio" => $importe,
                                    "usuario" => $usuario
                            ));  */
                }
            }
        }elseif(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            return $this->redirectToRoute('business_index');
        }
        return $this->redirectToRoute('login');
    }
    
    public function redsysprocessAction(Request $request){
        $em = $this->getDoctrine()->getManager();
        $overdomain = $request->getHost();
        $business = $em->getRepository('PagoBundle:business')->findOneBy(array('urlregistro'=>$overdomain));
        if ($business && $request->getMethod() == "POST"){
            $datos = $request->request->get("Ds_MerchantParameters");
            $redsys = new ApiRedsys();
            $decod = $redsys->decodeMerchantParameters($datos);
            $this->crearlogpeticion("REDSYS" . $decod);
            
            $kc = NULL;
            if ($business->getTpvproduction()){
                $kc = $business->getTpvkeyproduction();
            }else{
                $kc = $business->getTpvkcdevelopment();
            }

            $redsys->createMerchantSignatureNotif($kc,$datos);
            $pago = $em->getRepository("PagoBundle:pago")->findOneBy(array('id' => strval($redsys->getParameter('Ds_Order'))));
            if($redsys->getParameter('Ds_Response') == "0000" && $pago != NULL && $pago->getUsuario()->getBusiness()->getId() == $business->getId()){
                $pago->setAuthorizationcode($redsys->getParameter('Ds_AuthorisationCode'));
                $pago->setDatepayment(new \DateTime());
                $pago->setEstado(2);
                $pago->setPaymentform(2);
                $pago->setPagado(TRUE);
                $em->persist($pago);
                $usuario = $pago->getUsuario();
                $fecha = new \DateTime();
                $fecha->add(new \DateInterval('P30D'));
                $usuario->setFechaexpiracion($fecha);
                $usuario->setPlanactivo(1);
                $em->persist($usuario);
                $em->flush();

                $this->sendOrderMail($pago, $pago->getUsuario()->getEmail(),$business->getEmail() , $business->getUrlregistro());
            }else{
                $pago->setEstado(3);
                $pago->setPaymentform(2);
                $pago->setPagado(FALSE);
                $em->persist($pago);
                $em->flush();
            }
            
        }
        return new Response('ok', 200);
    }
    
    
    
    public function errorAction(Request $request)
    {   if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $user = $this->get('security.token_storage')->getToken()->getUser();

            return $this->render('PagoBundle:pasarelapago:error.html.twig',
                array(
                    "usuario" => $usuario,
                    ));
        }
        return $this->redirectToRoute('login');

    }
    
    
    public function paypalAction(Request $request){
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            
            return $this->render('PagoBundle:pasarelapago:mediopago.html.twig',array('business'=>$business,'medio'=>2));
        }
        return $this->redirectToRoute('login');
    }
    
    public function redsysAction(Request $request){
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            
        }
        return $this->redirectToRoute('login');
    }
    
    public function thanksAction(Request $request)
    {   
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            
            return $this->render('PagoBundle:pasarelapago:message.html.twig',
                array("usuario" => $usuario));
        }
        return $this->redirectToRoute('login');    
    }
    
    
    public function paypalnotifyAction(Request $request){
        
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        $business = $em->getRepository('PagoBundle:business')->findOneBy(array('urlregistro'=>$host));
        
        if($business && $request->getMethod() == 'POST'){
            $raw_post_data = file_get_contents('php://input');
            $this->crearlogpeticion($raw_post_data);
            // Los separamos en un array
            $raw_post_array = explode('&',$raw_post_data);
            // Separamos cada uno en un array de variable y valor
            $myPost = array();
            foreach($raw_post_array as $keyval){
                $keyval = explode("=",$keyval);
                if(count($keyval) == 2){
                    $myPost[$keyval[0]] = urldecode($keyval[1]);
                }
            }

            // Nuestro string debe comenzar con cmd=_notify-validate
            $req = 'cmd=_notify-validate';
            if(function_exists('get_magic_quotes_gpc')){
                $get_magic_quotes_exists = true;
            }
            foreach($myPost as $key => $value){
                // Cada valor se trata con urlencode para poder pasarlo por GET
                if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) {
                    $value = urlencode(stripslashes($value));
                } else {
                    $value = urlencode($value);
                }
                //Añadimos cada variable y cada valor
                $req .= "&$key=$value";
            }
            if($business->getEstadopaypal() == 2){//produccion
                $ch = curl_init('https://ipnpb.paypal.com/cgi-bin/webscr'); 
            }else{//desarrollo
                $ch = curl_init('https://www.sandbox.paypal.com/cgi-bin/webscr');   // Esta URL debe variar dependiendo si usamos SandBox o no. Si lo usamos, se queda así.
            }
            //        // Si no usamos SandBox, debemos usar esta otra linea en su lugar.
            curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
            curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));

            if( !($res = curl_exec($ch)) ) {
                // Ooops, error. Deberiamos guardarlo en algún log o base de datos para examinarlo después.
                curl_close($ch);
                exit;
            }
            curl_close($ch);
            if (strcmp ($res, "VERIFIED") == 0) {
                /**
                 * A partir de aqui, deberiamos hacer otras comprobaciones rutinarias antes de continuar. Son opcionales, pero recomiendo al menos las dos primeras. Por ejemplo:
                 *
                 * * Comprobar que $_POST["payment_status"] tenga el valor "Completed", que nos confirma el pago como completado.
                 * * Comprobar que no hemos tratado antes la misma id de transacción (txd_id)
                 * * Comprobar que el email al que va dirigido el pago sea nuestro email principal de PayPal
                 * * Comprobar que la cantidad y la divisa son correctas
                 */

                // Después de las comprobaciones, toca el procesamiento de los datos.

                /**
                 * En este punto tratamos la información.
                 * Podemos hacer con ella muchas cosas:
                 *
                 * * Guardarla en una base de datos.
                 * * Guardar cada linea del pedido en una linea diferente en la base de datos.
                 * * Guardar un log.
                 * * Restar las cantidades de los artículos del stock.
                 * * Enviar un mensaje de confirmcaión al cliente.
                 * * Enviar un mensaje al encargado de pedidos para que lo prepare.
                 * * Comprobar mediante complejas operaciones matemáticas si el cliente es el número un millon y notificarle de que ha ganado dos noches de hotel en Torrevieja.
                 * * ¡Imaginación!
                 */

                $this->crearlogpeticion("VERIFICADO");
                //$item_name = $_POST['item_name'];
                $item_number = intval($_POST['item_number1']);

                $this->crearlogpeticion("item_number1: " . $item_number);
                $payment_status = $_POST['payment_status'];
                //$payment_amount = $_POST['mc_gross'];
                //$payment_currency = $_POST['mc_currency'];
                $txn_id = $_POST['txn_id'];
                //$receiver_email = $_POST['receiver_email'];
                //$payer_email = $_POST['payer_email'];
                //$verify_sign = $_POST['verify_sign'];

                // Se busca el pedido con el $itemnumber
                $pago = $em->getRepository('PagoBundle:pago')->findOneBy(array('number' => strval($item_number)));
                if ($pago && $pago->getAuthorizationcode() == NULL){
                    $statuspayment = 1;
                    if ($payment_status == "Completed" || $payment_status == "Processed"){
                        $statuspayment = 2;
                        $pago->setPagado(TRUE);
                        $usuario = $pago->getUsuario();
                        $fecha = new \DateTime();
                        $fecha->add(new \DateInterval('P30D'));
                        $usuario->setFechaexpiracion($fecha);
                        $usuario->setPlanactivo(1);
                        $em->persist($usuario);
                    }else if ($payment_status == "Denied" || $payment_status == "Expired"  
                            || $payment_status == "Failed"){
                        $statuspayment = 3;
                        $pago->setPagado(FALSE);
                    }
                    $pago->setEstado($statuspayment);
                    $pago->setDatepayment(new \DateTime());
                    $pago->setAuthorizationcode($txn_id);
                    $pago->setPaymentform(1);
                    $em->persist($pago);
                    $em->flush();

                    if ($statuspayment == 2){
                        $emailnegocio = $business->getEmail();
                        $emailuser = $pago->getUsuario()->getEmail();
                        $this->sendOrderMail($pago, $emailuser,$emailnegocio, $business->getUrlregistro());
                    }
                }
            } else if (strcmp ($res, "INVALID") == 0) {
                // El estado que devuelve es INVALIDO, la información no ha sido enviada por PayPal. Deberías guardarla en un log para comprobarlo después
                echo "The response from IPN was: <b>" .$res ."</b>";
                $this->crearlogpeticion("INVALIDO:" . $res);
            }
        }
    
    }
    
    
    public function crearlogpeticion($linea){
        $now = new \DateTime();
        $name = $now->format("d-m-Y") . "paypal.txt";
        $ruta = "../logs/" . $name;
        if (!file_exists($ruta)){
            $fp = fopen($ruta, "wb");
            fwrite($fp,"");
            fclose($fp);
        }else{
            // se mira el tamaño del fichero
            $tam = $this->filesize_formatted($ruta);
            if ($tam >= 5){
                // si es de 5 megas se crea uno nuevo
                // se busca si existe un fichero
                $indice = 1;
                $rutacp = "../logs/" . $now->format("d-m-Y") . "-" . $indice . "paypal.txt";
                while(file_exists($rutacp) && $indice < 10){
                    $indice += 1;
                    $rutacp = "../logs/" . $now->format("d-m-Y") . "-" . $indice . "paypal.txt";
                }
                rename($ruta, $rutacp);
                $fp = fopen($ruta, "wb");
                fwrite($fp,"");
                fclose($fp);
            }
        }
        $fp = fopen($ruta, "a");
        $linea = $linea . ";";
        $linea .= "\t\n";
        fwrite($fp, $linea);
        fclose($fp);
    }
    
    public function filesize_formatted($file){
        $bytes = filesize($file);
        return $bytes / 1048576;
    }
    public function sendOrderMail($pago, $email,$emailnegocio, $host){
        if(filter_var($email, FILTER_VALIDATE_EMAIL)) {
            $message = \Swift_Message::newInstance()
                ->setSubject('Renovación correcta')
                ->setFrom($emailnegocio)
                ->setTo($email)
                ->setBody(
                    $this->renderView(
                        'PagoBundle:pasarelapago:mailPagoCompleto.html.twig',
                        array('pago' => $pago, "host" => $host)
                    ),
                    'text/html'
                );
            $kernel = $this->get('kernel');
            $devMode = $kernel->isDebug();
            if ($devMode == false){
                $this->get('mailer')->send($message);
            }
        }
    }
        
       
    
}
