<?php

namespace PagoBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use CoreBundle\Entity\Utils;
use Symfony\Component\HttpFoundation\Response;
use CoreBundle\Entity\eventwebhook;
use PagoBundle\Entity\eventostripe;
use CoreBundle\Entity\Domainutils;

class WebhookController extends Controller
{   
    public function stripeWebhookAction(Request $request)
    {
        $sig_header = NULL;
        if (isset($_SERVER['HTTP_STRIPE_SIGNATURE'])){
            $sig_header = $_SERVER['HTTP_STRIPE_SIGNATURE'];
        }
        
        $payload = $request->getContent();
        $kernel = $this->get('kernel');
        $isdebug = $kernel->isDebug();
        if ($isdebug == true){
            $payload = $this->getPayload();
        }
        Utils::crearlogpeticion("stripeWebhook", $payload);
        $data = json_decode($payload, true);
       
        if ($data !== null){
            $em = $this->getDoctrine()->getManager(); 
            $eventwebhook = new eventwebhook();
            $eventwebhook->setPayload($payload);
            switch ($eventwebhook->getType()) {
                case 'customer.subscription.deleted':
                    $stripeSubscriptionId = $eventwebhook->getSuscriptionid();
                    
                    $administradores = $em->getRepository('UsuarioBundle:administrador')
                            ->findSuscripcion($stripeSubscriptionId);
                    foreach ($administradores as $a) {
                        $business = $a->getBusiness();
                        if ($business != NULL){
                            $event = $this->getEvent($payload, $business, $sig_header);
                            if ($event){
                                $es = $a->getEventostripe();
                                $plan = NULL;
                                if ($es != NULL){
                                    $plan = $es->getPlan();
                                }

                                $eventostripe = new eventostripe();
                                $eventostripe->setBusiness($business);
                                $eventostripe->setUsuario($a);
                                $eventostripe->setPlan($plan);
                                $eventostripe->setPayload($payload);
                                $eventostripe->setEvent($event->type);
                                $eventostripe->setStripesubscriptionid($stripeSubscriptionId);
                                $em->persist($eventostripe);
                                $em->flush();

                                $a->setEventostripe(NULL);
                                $em->persist($a);
                                $em->flush();
                                
                                if ($a->getAplicacionactiva()){
                                    // Se desactiva la aplicacion
                                    list($errorcode, $errormessage, $return) = Domainutils::desactivaraplicacion($a);
                                    if ($errorcode == 0){
                                        $desactivada = boolval($return["desactivada"]);
                                        if ($desactivada == TRUE){
                                            $a->setAplicacionactiva(FALSE);
                                        }
                                        $em->persist($a);
                                        $em->flush();
                                    }
                                }
                            }
                        }
                    }
                    break;
                case 'invoice.payment_succeeded':
                    $email = $eventwebhook->getUseremail();
                    if ($email != NULL){
                        $administrador = $em->getRepository("UsuarioBundle:administrador")
                                ->findAdministrador($email);
                        if ($administrador != NULL){
                            $business = $administrador->getBusiness();
                            if ($business != NULL){
                                $event = $this->getEvent($payload, $business, $sig_header);
                                if ($event){
                                    $stripeSubscriptionId = $event->data->object->subscription;
                                    $period_start = NULL;
                                    $period_end = NULL;

                                    $amount = floatval($event->data->object->amount_paid) / 100;

                                    foreach ($event->data->object->lines->data as $line) {
                                        //var_dump($line->plan);
                                        $idplan = $line->plan->id;
                                        $period_start = $line->period->start;
                                        $period_end = $line->period->end;
                                        // Se busca el plan
                                        $plan = $em->getRepository('AdministracionBundle:plan')
                                                ->findPlan($business->getId(), $idplan);
                                        if ($plan != NULL){
                                            break;
                                        }
                                    }

                                    $start = new \DateTime();
                                    $start->setTimestamp($period_start);
                                    $end = new \DateTime();
                                    $end->setTimestamp($period_end);

                                    if ($plan != NULL){
                                        $eventostripe = new eventostripe();
                                        $eventostripe->setBusiness($business);
                                        $eventostripe->setUsuario($administrador);
                                        $eventostripe->setPlan($plan);
                                        $eventostripe->setPayload($payload);
                                        $eventostripe->setEvent($event->type);
                                        $eventostripe->setStripesubscriptionid($stripeSubscriptionId);
                                        $eventostripe->setPeriodstart($start);
                                        $eventostripe->setPeriodend($end);
                                        $eventostripe->setAmount($amount);

                                        $eventostripe->setCondominio($plan->getCondominio());
                                        $eventostripe->setTiendaactiva($plan->getTiendaactiva());
                                        $eventostripe->setNumeromaximoemails($plan->getNumeromaximoemails());
                                        $eventostripe->setCrmeactivo($plan->getCrmeactivo());
                                        $eventostripe->setTextoservicio($plan->getTextoservicio());
                                        $eventostripe->setStandardcreatuaplicacion($plan->getStandardcreatuaplicacion());
                                        $em->persist($eventostripe);
                                        $em->flush();

                                        if ($administrador->getEventostripe() != NULL){
                                            $eventostripe = $administrador->getEventostripe();
                                            \Stripe\Stripe::setApiKey($business->getClavestripe());
                                            $sub = \Stripe\Subscription::retrieve($eventostripe->getStripesubscriptionid());
                                            $sub->cancel();
                                        }

                                        $administrador->setCondominio($plan->getCondominio());
                                        $administrador->setTiendaactiva($plan->getTiendaactiva());
                                        $administrador->setNumeromaximoemails($plan->getNumeromaximoemails());
                                        $administrador->setCrmeactivo($plan->getCrmeactivo());
                                        $administrador->setTextoservicio($plan->getTextoservicio());
                                        $administrador->setStandardcreatuaplicacion($plan->getStandardcreatuaplicacion());
                                        $administrador->setFechaexpiracion($end);
                                        $administrador->setPlanactivo(TRUE);
                                        $administrador->setPlanseleccionado($plan);
                                        $administrador->setEventostripe($eventostripe);
                                        $em->persist($administrador);
                                        $em->flush();
                                        
                                        if ($administrador->getStandardcreatuaplicacion()){
                                            if ($administrador->getAplicacioncreada() 
                                                    && $administrador->getIdapp() > 0){
                                                if ($administrador->getAplicacionactiva()){
                                                    // se actualiza el plan de creatuaplicacion
                                                    list($errorcode, $errormessage, $return) = Domainutils::actualizarfechaexpiracion($administrador, $end);
                                                }else{
                                                    list($errorcode, $errormessage, $return) = Domainutils::activaraplicacion($administrador, $end);
                                                    if ($errorcode == 0){
                                                        $actualizada = boolval($return["actualizada"]);
                                                        if ($actualizada){
                                                            $administrador->setAplicacionactiva(TRUE);
                                                            $em->persist($administrador);
                                                            $em->flush();
                                                        }
                                                    }
                                                }
                                            }else{
                                                // se crea la aplicacion
                                                list($errorcode, $errormessage, $return) = Domainutils::crearaplicacion($administrador, NULL, NULL, "");
                                                if ($errorcode == 0){
                                                    $idapp = $return["idapp"];
                                                    $usuarioapp = $return["usuarioapp"];
                                                    $administrador->setIdapp($idapp);
                                                    $administrador->setAplicacioncreada(TRUE);
                                                    $administrador->setAplicacionactiva(TRUE);
                                                    $administrador->setUsuarioapp($usuarioapp);
                                                    $em->persist($administrador);
                                                    $em->flush();
                                                }
                                            }
                                        }else if ($administrador->getAplicacionactiva()){
                                            // Se desactiva la aplicacion
                                            list($errorcode, $errormessage, $return) = Domainutils::desactivaraplicacion($administrador);
                                            if ($errorcode == 0){
                                                $desactivada = boolval($return["desactivada"]);
                                                if ($desactivada == TRUE){
                                                    $administrador->setAplicacionactiva(FALSE);
                                                }
                                                $em->persist($administrador);
                                                $em->flush();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    break;
                case 'invoice.payment_failed':
                    break;
            }
        }
        return new Response('', 200, array('Content-Type' => 'text/html'));
    }
    
    public function getEvent($payload, $business, $sig_header){
        $event = null;
        $endpoint_secret = $business->getWebhookstripe();
        try {
            $event = \Stripe\Webhook::constructEvent(
                $payload, $sig_header, $endpoint_secret, 300
            );
        } catch(\UnexpectedValueException $e) {
            Utils::crearlogpeticion("stripeWebhook", "invalid payload");
        } catch(\Stripe\Error\SignatureVerification $e) {
            Utils::crearlogpeticion("stripeWebhook", "Invalid signature");
        }
        return $event;
    }
    
    public function getPayload(){
        $payload = '{
  "id": "evt_1EV1WUJWpzXTeUB57w4Sfrm1",
  "object": "event",
  "api_version": "2018-11-08",
  "created": 1556652110,
  "data": {
    "object": {
      "id": "in_1EV1WTJWpzXTeUB570RbAe2J",
      "object": "invoice",
      "account_country": "ES",
      "account_name": "Grupo Winecta Transformación Digital S.L.",
      "amount_due": 995,
      "amount_paid": 995,
      "amount_remaining": 0,
      "application_fee": null,
      "attempt_count": 0,
      "attempted": true,
      "auto_advance": false,
      "billing": "charge_automatically",
      "billing_reason": "subscription_create",
      "charge": "ch_1EV1WSJWpzXTeUB5lXqz3jmh",
      "created": 1556652109,
      "currency": "eur",
      "custom_fields": null,
      "customer": "cus_EyzVmOpIfGskD4",
      "customer_address": null,
      "customer_email": "rubensr@winecta.com",
      "customer_name": null,
      "customer_phone": null,
      "customer_shipping": null,
      "customer_tax_exempt": "none",
      "customer_tax_ids": [

      ],
      "date": 1556652109,
      "default_payment_method": null,
      "default_source": null,
      "default_tax_rates": [

      ],
      "description": null,
      "discount": null,
      "due_date": null,
      "ending_balance": 0,
      "finalized_at": 1556652110,
      "footer": null,
      "hosted_invoice_url": "https://pay.stripe.com/invoice/invst_jR4lxy11eUQSnOf7UpuA16drXj",
      "invoice_pdf": "https://pay.stripe.com/invoice/invst_jR4lxy11eUQSnOf7UpuA16drXj/pdf",
      "lines": {
        "object": "list",
        "data": [
          {
            "id": "sli_a87b311def1855",
            "object": "line_item",
            "amount": 995,
            "currency": "eur",
            "description": "1 × LanzaTuPáginaWeb (at €9.95 / day)",
            "discountable": true,
            "livemode": false,
            "metadata": {
            },
            "period": {
              "end": 1556738509,
              "start": 1556652109
            },
            "plan": {
              "id": "plan_Eui6BqKPU02ure",
              "object": "plan",
              "active": true,
              "aggregate_usage": null,
              "amount": 995,
              "billing_scheme": "per_unit",
              "created": 1555664785,
              "currency": "eur",
              "interval": "day",
              "interval_count": 1,
              "livemode": false,
              "metadata": {
              },
              "nickname": "LanzaTuPáginaWeb Diario",
              "product": "prod_Eui58D8gQlyhvR",
              "tiers": null,
              "tiers_mode": null,
              "transform_usage": null,
              "trial_period_days": null,
              "usage_type": "licensed"
            },
            "proration": false,
            "quantity": 1,
            "subscription": "sub_EyzVUX4mud5cSb",
            "subscription_item": "si_EyzVs4YTcsXRuO",
            "tax_amounts": [

            ],
            "tax_rates": [

            ],
            "type": "subscription"
          }
        ],
        "has_more": false,
        "total_count": 1,
        "url": "/v1/invoices/in_1EV1WTJWpzXTeUB570RbAe2J/lines"
      },
      "livemode": false,
      "metadata": {
      },
      "next_payment_attempt": null,
      "number": "CB39A7D1-0001",
      "paid": true,
      "payment_intent": "pi_1EV1WUJWpzXTeUB5i09JuCwq",
      "period_end": 1556652109,
      "period_start": 1556652109,
      "post_payment_credit_notes_amount": 0,
      "pre_payment_credit_notes_amount": 0,
      "receipt_number": null,
      "starting_balance": 0,
      "statement_descriptor": null,
      "status": "paid",
      "status_transitions": {
        "finalized_at": 1556652110,
        "marked_uncollectible_at": null,
        "paid_at": 1556652110,
        "voided_at": null
      },
      "subscription": "sub_EyzVUX4mud5cSb",
      "subtotal": 995,
      "tax": null,
      "tax_percent": null,
      "total": 995,
      "total_tax_amounts": [

      ],
      "webhooks_delivered_at": null
    }
  },
  "livemode": false,
  "pending_webhooks": 1,
  "request": {
    "id": null,
    "idempotency_key": null
  },
  "type": "invoice.payment_succeeded"
}';
        return $payload;
    }
}
