<?php

namespace PagoBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * business
 *
 * @ORM\Table(name="business")
 * @ORM\Entity(repositoryClass="PagoBundle\Repository\businessRepository")
 */
class business
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="nif", type="string", length=255, nullable=true)
     */
    private $nif;

    /**
     * @var string
     *
     * @ORM\Column(name="urlsubdominios", type="string", length=255, nullable=true)
     */
    private $urlsubdominios;

    /**
     * @var boolean
     *
     * @ORM\Column(name="reservadominiosinpago", type="boolean")
     */
    private $reservadominiosinpago;

    /**
     * @var string
     *
     * @ORM\Column(name="urlcrearweb", type="string", length=255, nullable=true)
     */
    private $urlcrearweb;

    /**
     * @var string
     *
     * @ORM\Column(name="urlapiweb", type="string", length=255, nullable=true)
     */
    private $urlapiweb;

    /**
     * @var string
     *
     * @ORM\Column(name="urlcrearapp", type="string", length=255, nullable=true)
     */
    private $urlcrearapp;

    /**
     * @var string
     *
     * @ORM\Column(name="urlloginapp", type="string", length=255, nullable=true)
     */
    private $urlloginapp;

    /**
     * @var string
     *
     * @ORM\Column(name="urlcentroayuda", type="string", length=255, nullable=true)
     */
    private $urlcentroayuda;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre", type="string", length=255)
     */
    private $nombre;

    /**
     * @var string
     *
     * @ORM\Column(name="terminal", type="string", length=255, nullable=true)
     */
    private $terminal;    
    
    /**
     * @var string
     *
     * @ORM\Column(name="tpvversion", type="string", nullable=true)
     */
    private $tpvversion;

    /**
     * @var boolean
     *
     * @ORM\Column(name="tpvproduction", type="boolean")
     */
    private $tpvproduction;

    /**
     * @var string
     *
     * @ORM\Column(name="fuc", type="string", length=255, nullable=true)
     */
    private $fuc;
    
    /**
     * @var string
     *
     * @ORM\Column(name="fucdevelopment", type="string", length=255, nullable=true)
     */
    private $fucdevelopment;

    /**
     * @var string
     *
     * @ORM\Column(name="tpvkeyproduction", type="string", nullable=true)
     */
    private $tpvkcproduction;

    /**
     * @var string
     *
     * @ORM\Column(name="tpvkeydevelopment", type="string", nullable=true)
     */
    private $tpvkcdevelopment;
    
    /**
     * @var string
     *
     * @ORM\Column(name="urlpaypal", type="string", nullable=true)
     */
    private $urlpaypal; // prod --> https://www.paypal.com/cgi-bin/webscr , des-> https://www.sandbox.paypal.com/cgi-bin/webscr
    
    /**
     * @var string
     *
     * @ORM\Column(name="usuariopaypal", type="string", nullable=true)
     */
    private $usuariopaypal;
    
    /**
     * @var integer
     * 1 --> dev
     * 2 --> prod
     * @ORM\Column(name="estadopaypal", type="integer", nullable=true)
     */
    private $estadopaypal;
    
    /**
     * @var string
     *
     * @ORM\Column(name="currency", type="string", nullable=true)
     */
    private $currency;
    
    /**
     * @var integer
     * 1 --> dev
     * 2 --> prod
     * @ORM\Column(name="estadostripe", type="integer", nullable=true)
     */
    private $estadostripe;
    
    /**
     * @var string
     *
     * @ORM\Column(name="claveteststripe", type="string", nullable=true)
     */
    private $claveteststripe;
    
    /**
     * @var string
     *
     * @ORM\Column(name="claveproduccionstripe", type="string", nullable=true)
     */
    private $claveproduccionstripe;
    
    /**
     * @var string
     *
     * @ORM\Column(name="webhookstripe", type="string", nullable=true)
     */
    private $webhookstripe;

    /**
     * @var style
     *
     * @ORM\ManyToOne(targetEntity="StyleBundle\Entity\style")
     */
    private $style;

    /**
     * @var string
     *
     * @ORM\Column(name="moneda", type="string", length=255, nullable=true)
     */
    private $moneda;
    
    /**
     * @var string
     *
     * @ORM\Column(name="trans", type="string", length=255, nullable=true)
     */
    private $trans;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="eliminado", type="boolean")
     */
    private $eliminado;
    
    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=255, nullable=true)
     */
    private $email;
    
    /**
     * @var string
     *
     * @ORM\Column(name="urlregistro", type="string", length=255, nullable=true)
     */
    private $urlregistro;
    
    /**
     * @var string
     *
     * @ORM\Column(name="mensajeregistro", type="string", nullable=true)
     */
    private $mensajeregistro;
    
    /**
     * @var string
     *
     * @ORM\Column(name="mensajestep1", type="string", nullable=true)
     */
    private $mensajestep1;
    
    /**
     * @var integer
     * @ORM\Column(name="contadorsubdominios", type="integer")
     */
    private $contadorsubdominios;

    /**
     * @var string
     *
     * @ORM\Column(name="politicaprivacidad", type="text", nullable=true)
     */
    private $politicaprivacidad;

    /**
     * @var string
     *
     * @ORM\Column(name="enlacepoliticaprivacidad", type="string", nullable=true)
     */
    private $enlacepoliticaprivacidad;

    /**
     * @var string
     *
     * @ORM\Column(name="serverplan", type="string", length=255, nullable=true)
     */
    private $serverplan;

    /**
     * @var boolean
     *
     * @ORM\Column(name="tienetienda", type="boolean")
     */
    private $tienetienda;

    /**
     * @var string
     *
     * @ORM\Column(name="inicializaciongoogle", type="text", nullable=true)
     */
    private $inicializaciongoogle;

    /**
     * @var string
     *
     * @ORM\Column(name="conversiongoogle", type="text", nullable=true)
     */
    private $conversiongoogle;

    /**
     * @var string
     *
     * @ORM\Column(name="pathimagenemail", type="string", length=255, nullable=true)
     */
    private $pathimagenemail;

    /**
     * @var string
     *
     * @ORM\Column(name="condicionesemail", type="text", nullable=true)
     */
    private $condicionesemail;

    /**
     * @var string
     *
     * @ORM\Column(name="password", type="string", length=255, nullable=true)
     */
    private $password;

    /**
     * @var string
     *
     * @ORM\Column(name="smtphost", type="string", length=255, nullable=true)
     */
    private $smtphost;

    /**
     * @var string
     *
     * @ORM\Column(name="smtpport", type="string", length=255, nullable=true)
     */
    private $smtpport;

    /**
     * @var string
     *
     * @ORM\Column(name="smtpsecurity", type="string", length=255, nullable=true)
     */
    private $smtpsecurity;

    /**
     * @var string
     *
     * @ORM\Column(name="fontstyle", type="text", nullable=true)
     */
    private $fontstyle;

    /**
     * @var string
     *
     * @ORM\Column(name="favicon", type="text", nullable=true)
     */
    private $favicon;

    /**
     * @var string
     *
     * @ORM\Column(name="namefont", type="string", length=255, nullable=true)
     */
    private $namefont;

    /**
     * @var string
     *
     * @ORM\Column(name="folderemail", type="string", length=255, nullable=true)
     */
    private $folderemail;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntobienvenida", type="string", length=255, nullable=true)
     */
    private $asuntobienvenida;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntoguia", type="string", length=255, nullable=true)
     */
    private $asuntoguia;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntorecordatorio5", type="string", length=255, nullable=true)
     */
    private $asuntorecordatorio5;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntorecordatorio10", type="string", length=255, nullable=true)
     */
    private $asuntorecordatorio10;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntorecordatorio15", type="string", length=255, nullable=true)
     */
    private $asuntorecordatorio15;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntofinalizada", type="string", length=255, nullable=true)
     */
    private $asuntofinalizada;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntopassword", type="string", length=255, nullable=true)
     */
    private $asuntopassword;

    /**
     * @var string
     *
     * @ORM\Column(name="asuntocompra", type="string", length=255, nullable=true)
     */
    private $asuntocompra;
    
    /**
     * @var integer
     * @ORM\Column(name="mesestest", type="integer", nullable=true)
     */
    private $mesestest;

    /**
     * @var string
     *
     * @ORM\Column(name="cabeceralogin", type="text", nullable=true)
     */
    private $cabeceralogin;
    
    public function encryptarPassword() {
        if ($this->getPassword()){
            $this->setPassword($this->encrypt($this->getPassword()));
        }else{
            $this->setPassword("");
        }
    }
    
    public function desencryptarPassword() {
        if ($this->getPassword() != NULL){
            return $this->decrypt($this->getPassword());
        }else{
            return "";
        }
    }
    
    static function encrypt($string) {
        $output = false;
        $encrypt_method = "AES-256-CBC";
        $secret_key = "fe67d68ee1e09b47acd8810b880d537034c10c15344433a992b9c79002666844";
        $secret_iv = "fdd3345455fffgffffhkkyoife67d68ee1e09b47acd8810b880d537034c10c15344433a992b9c79002666844";

        $key = hash("sha256", $secret_key);
        $iv = substr(hash("sha256", $secret_iv), 0, 16);
        $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
        $output = base64_encode($output);
        return $output;
    }

    static function decrypt($string) {
        $output = "";
        if ($string != NULL && strlen($string) > 0){
            $output = false;
            $encrypt_method = "AES-256-CBC";
            $secret_key = "fe67d68ee1e09b47acd8810b880d537034c10c15344433a992b9c79002666844";
            $secret_iv = "fdd3345455fffgffffhkkyoife67d68ee1e09b47acd8810b880d537034c10c15344433a992b9c79002666844";

            $key = hash("sha256", $secret_key);
            $iv = substr(hash("sha256", $secret_iv), 0, 16);
            $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
        }
        return $output;
    }
    
    public function getRuta(){
        return "./../data/business/";
    }
    
    public function removeUpload(){
        if ($this->getPathimagenemail()){
            $file = $this->getRuta() . $this->getPathimagenemail();
            if (file_exists($file)){
                unlink($file);
            }
        }
    }

    public function poneronclickgoogle(){
        if ($this->getInicializaciongoogle() != NULL && $this->getConversiongoogle() != NULL){
            return TRUE;
        }else{
            return FALSE;
        }
    }
    
    public function getClavestripe(){
        $value = "";
        if($this->getEstadostripe() == 1){
            $value = $this->getClaveteststripe();
        }else if($this->getEstadostripe() == 2){
            $value = $this->getClaveproduccionstripe();
        }
        return $value;
    }
    
    public function actualizarurlpaypal(){
        if ($this->getEstadopaypal() == 1){
            $this->setUrlpaypal("https://www.sandbox.paypal.com/cgi-bin/webscr");
        }else if ($this->getEstadopaypal() == 2){
            $this->setUrlpaypal("https://www.paypal.com/cgi-bin/webscr");
        }else{
            $this->setUrlpaypal(NULL);
        }             
    }
    
    public function getUrlTPV(){
        $url = "https://sis.redsys.es/sis/realizarPago";
        if($this->getTpvproduction()==0){
            $url = "https://sis-t.redsys.es:25443/sis/realizarPago";
        }
        return $url;
    }
    
    public function getTPVproductionStr(){
        $value = "DEV";
        if($this->getTpvproduction()==1){
            $value = "PROD";
        }
        return $value;
    }
    
    public function __toString() {
        if ($this->nombre != NULL){
            return $this->nombre;
        }else{
            return "Business";
        }
    }
    
    public function __construct() {
        $this->urlpaypal = "https://www.sandbox.paypal.com/cgi-bin/webscr";
        $this->eliminado = false;
        $this->tpvkcdevelopment= "";
        $this->fucdevelopment= "";
        $this->tpvversion ="HMAC_SHA256_V1";
        $this->terminal = 001;
        $this->moneda = "978";
        $this->trans = "0";  
        $this->terminal = "1";
        $this->tpvproduction = false;
        $this->contadorsubdominios = 0;
        $this->tienetienda = false;
        $this->reservadominiosinpago = false;
    }
    
    public function getKc(){
        if($this->getTpvproduction()==0){
            return $this->getTpvkcdevelopment();
        }else{
            return $this->getTpvkcproduction();
        }
    }
    public function getFucvalid(){
       if($this->getTpvproduction()==0){
            return $this->getFucdevelopment();
        }else{
            return $this->getFuc();
        } 
    }

    public function getMonedaStr(){
        if($this->currency == 'EUR'){
            return "€";
        }elseif($this->currency == 'USD'){
            return "$";
        }elseif($this->currency == 'GBP'){
            return "£";
        }elseif($this->currency == 'CAD'){
            return "C$";
        }elseif($this->currency == 'CZK'){
            return "Kč";
        }elseif($this->currency == 'DKK'){
            return "kr";
        }elseif($this->currency == 'HKD'){
            return "HK$";
        }elseif($this->currency == 'MXN'){
            return "$	";
        }elseif($this->currency == 'NOK'){
            return "Kr";
        }elseif($this->currency == 'NZD'){
            return "$";
        }elseif($this->currency == 'PHP'){
            return "₱";
        }elseif($this->currency == 'PLN'){
            return "zł";
        }elseif($this->currency == 'SGD'){
            return "S$	";
        }elseif($this->currency == 'SEK'){
            return "kr";
        }elseif($this->currency == 'CHF'){
            return "Fr";
        }elseif($this->currency == 'THB'){
            return "฿";
        }
    }

    public function getEstadopaypalStr(){
        $estado = "DEV";
        if($this->getEstadopaypal()==2){
            $estado = "PROD";
        }
        return $estado;
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set nif
     *
     * @param string $nif
     *
     * @return business
     */
    public function setNif($nif)
    {
        $this->nif = $nif;

        return $this;
    }

    /**
     * Get nif
     *
     * @return string
     */
    public function getNif()
    {
        return $this->nif;
    }

    /**
     * Set nombre
     *
     * @param string $nombre
     *
     * @return business
     */
    public function setNombre($nombre)
    {
        $this->nombre = $nombre;

        return $this;
    }

    /**
     * Get nombre
     *
     * @return string
     */
    public function getNombre()
    {
        return $this->nombre;
    }

    /**
     * Set terminal
     *
     * @param string $terminal
     *
     * @return business
     */
    public function setTerminal($terminal)
    {
        $this->terminal = $terminal;

        return $this;
    }

    /**
     * Get terminal
     *
     * @return string
     */
    public function getTerminal()
    {
        return $this->terminal;
    }

    /**
     * Set tpvversion
     *
     * @param string $tpvversion
     *
     * @return business
     */
    public function setTpvversion($tpvversion)
    {
        $this->tpvversion = $tpvversion;

        return $this;
    }

    /**
     * Get tpvversion
     *
     * @return string
     */
    public function getTpvversion()
    {
        return $this->tpvversion;
    }

    /**
     * Set tpvproduction
     *
     * @param boolean $tpvproduction
     *
     * @return business
     */
    public function setTpvproduction($tpvproduction)
    {
        $this->tpvproduction = $tpvproduction;

        return $this;
    }

    /**
     * Get tpvproduction
     *
     * @return boolean
     */
    public function getTpvproduction()
    {
        return $this->tpvproduction;
    }

    /**
     * Set fuc
     *
     * @param string $fuc
     *
     * @return business
     */
    public function setFuc($fuc)
    {
        $this->fuc = $fuc;

        return $this;
    }

    /**
     * Get fuc
     *
     * @return string
     */
    public function getFuc()
    {
        return $this->fuc;
    }

    /**
     * Set fucdevelopment
     *
     * @param string $fucdevelopment
     *
     * @return business
     */
    public function setFucdevelopment($fucdevelopment)
    {
        $this->fucdevelopment = $fucdevelopment;

        return $this;
    }

    /**
     * Get fucdevelopment
     *
     * @return string
     */
    public function getFucdevelopment()
    {
        return $this->fucdevelopment;
    }

    /**
     * Set tpvkcproduction
     *
     * @param string $tpvkcproduction
     *
     * @return business
     */
    public function setTpvkcproduction($tpvkcproduction)
    {
        $this->tpvkcproduction = $tpvkcproduction;

        return $this;
    }

    /**
     * Get tpvkcproduction
     *
     * @return string
     */
    public function getTpvkcproduction()
    {
        return $this->tpvkcproduction;
    }

    /**
     * Set tpvkcdevelopment
     *
     * @param string $tpvkcdevelopment
     *
     * @return business
     */
    public function setTpvkcdevelopment($tpvkcdevelopment)
    {
        $this->tpvkcdevelopment = $tpvkcdevelopment;

        return $this;
    }

    /**
     * Get tpvkcdevelopment
     *
     * @return string
     */
    public function getTpvkcdevelopment()
    {
        return $this->tpvkcdevelopment;
    }

    /**
     * Set urlpaypal
     *
     * @param string $urlpaypal
     *
     * @return business
     */
    public function setUrlpaypal($urlpaypal)
    {
        $this->urlpaypal = $urlpaypal;

        return $this;
    }

    /**
     * Get urlpaypal
     *
     * @return string
     */
    public function getUrlpaypal()
    {
        return $this->urlpaypal;
    }

    /**
     * Set usuariopaypal
     *
     * @param string $usuariopaypal
     *
     * @return business
     */
    public function setUsuariopaypal($usuariopaypal)
    {
        $this->usuariopaypal = $usuariopaypal;

        return $this;
    }

    /**
     * Get usuariopaypal
     *
     * @return string
     */
    public function getUsuariopaypal()
    {
        return $this->usuariopaypal;
    }

    /**
     * Set estadopaypal
     *
     * @param integer $estadopaypal
     *
     * @return business
     */
    public function setEstadopaypal($estadopaypal)
    {
        $this->estadopaypal = $estadopaypal;

        return $this;
    }

    /**
     * Get estadopaypal
     *
     * @return integer
     */
    public function getEstadopaypal()
    {
        return $this->estadopaypal;
    }

    /**
     * Set currency
     *
     * @param string $currency
     *
     * @return business
     */
    public function setCurrency($currency)
    {
        $this->currency = $currency;

        return $this;
    }

    /**
     * Get currency
     *
     * @return string
     */
    public function getCurrency()
    {
        return $this->currency;
    }

    /**
     * Set moneda
     *
     * @param string $moneda
     *
     * @return business
     */
    public function setMoneda($moneda)
    {
        $this->moneda = $moneda;

        return $this;
    }

    /**
     * Get moneda
     *
     * @return string
     */
    public function getMoneda()
    {
        return $this->moneda;
    }

    /**
     * Set trans
     *
     * @param string $trans
     *
     * @return business
     */
    public function setTrans($trans)
    {
        $this->trans = $trans;

        return $this;
    }

    /**
     * Get trans
     *
     * @return string
     */
    public function getTrans()
    {
        return $this->trans;
    }

    /**
     * Set importerenovacion
     *
     * @param float $importerenovacion
     *
     * @return business
     */
    public function setImporterenovacion($importerenovacion)
    {
        $this->importerenovacion = $importerenovacion;

        return $this;
    }

    /**
     * Get importerenovacion
     *
     * @return float
     */
    public function getImporterenovacion()
    {
        return $this->importerenovacion;
    }

    /**
     * Set eliminado
     *
     * @param boolean $eliminado
     *
     * @return business
     */
    public function setEliminado($eliminado)
    {
        $this->eliminado = $eliminado;

        return $this;
    }

    /**
     * Get eliminado
     *
     * @return boolean
     */
    public function getEliminado()
    {
        return $this->eliminado;
    }

    /**
     * Set email
     *
     * @param string $email
     *
     * @return business
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set urlregistro
     *
     * @param string $urlregistro
     *
     * @return business
     */
    public function setUrlregistro($urlregistro)
    {
        $this->urlregistro = $urlregistro;

        return $this;
    }

    /**
     * Get urlregistro
     *
     * @return string
     */
    public function getUrlregistro()
    {
        return $this->urlregistro;
    }

    /**
     * Set style
     *
     * @param \StyleBundle\Entity\style $style
     *
     * @return business
     */
    public function setStyle(\StyleBundle\Entity\style $style = null)
    {
        $this->style = $style;

        return $this;
    }

    /**
     * Get style
     *
     * @return \StyleBundle\Entity\style
     */
    public function getStyle()
    {
        return $this->style;
    }

   

    /**
     * Set mensajeregistro
     *
     * @param string $mensajeregistro
     *
     * @return business
     */
    public function setMensajeregistro($mensajeregistro)
    {
        $this->mensajeregistro = $mensajeregistro;

        return $this;
    }

    /**
     * Get mensajeregistro
     *
     * @return string
     */
    public function getMensajeregistro()
    {
        return $this->mensajeregistro;
    }

    /**
     * Set urlsubdominios
     *
     * @param string $urlsubdominios
     *
     * @return business
     */
    public function setUrlsubdominios($urlsubdominios)
    {
        $this->urlsubdominios = $urlsubdominios;

        return $this;
    }

    /**
     * Get urlsubdominios
     *
     * @return string
     */
    public function getUrlsubdominios()
    {
        return $this->urlsubdominios;
    }

    /**
     * Set contadorsubdominios
     *
     * @param integer $contadorsubdominios
     *
     * @return business
     */
    public function setContadorsubdominios($contadorsubdominios)
    {
        $this->contadorsubdominios = $contadorsubdominios;

        return $this;
    }

    /**
     * Get contadorsubdominios
     *
     * @return integer
     */
    public function getContadorsubdominios()
    {
        return $this->contadorsubdominios;
    }

    /**
     * Set urlcrearweb
     *
     * @param string $urlcrearweb
     *
     * @return business
     */
    public function setUrlcrearweb($urlcrearweb)
    {
        $this->urlcrearweb = $urlcrearweb;

        return $this;
    }

    /**
     * Get urlcrearweb
     *
     * @return string
     */
    public function getUrlcrearweb()
    {
        return $this->urlcrearweb;
    }

    /**
     * Set estadostripe
     *
     * @param integer $estadostripe
     *
     * @return business
     */
    public function setEstadostripe($estadostripe)
    {
        $this->estadostripe = $estadostripe;

        return $this;
    }

    /**
     * Get estadostripe
     *
     * @return integer
     */
    public function getEstadostripe()
    {
        return $this->estadostripe;
    }

    /**
     * Set claveteststripe
     *
     * @param string $claveteststripe
     *
     * @return business
     */
    public function setClaveteststripe($claveteststripe)
    {
        $this->claveteststripe = $claveteststripe;

        return $this;
    }

    /**
     * Get claveteststripe
     *
     * @return string
     */
    public function getClaveteststripe()
    {
        return $this->claveteststripe;
    }

    /**
     * Set claveproduccionstripe
     *
     * @param string $claveproduccionstripe
     *
     * @return business
     */
    public function setClaveproduccionstripe($claveproduccionstripe)
    {
        $this->claveproduccionstripe = $claveproduccionstripe;

        return $this;
    }

    /**
     * Get claveproduccionstripe
     *
     * @return string
     */
    public function getClaveproduccionstripe()
    {
        return $this->claveproduccionstripe;
    }

    /**
     * Set politicaprivacidad
     *
     * @param string $politicaprivacidad
     *
     * @return business
     */
    public function setPoliticaprivacidad($politicaprivacidad)
    {
        $this->politicaprivacidad = $politicaprivacidad;

        return $this;
    }

    /**
     * Get politicaprivacidad
     *
     * @return string
     */
    public function getPoliticaprivacidad()
    {
        return $this->politicaprivacidad;
    }

    /**
     * Set serverplan
     *
     * @param string $serverplan
     *
     * @return business
     */
    public function setServerplan($serverplan)
    {
        $this->serverplan = $serverplan;

        return $this;
    }

    /**
     * Get serverplan
     *
     * @return string
     */
    public function getServerplan()
    {
        return $this->serverplan;
    }

    /**
     * Set urlcentroayuda
     *
     * @param string $urlcentroayuda
     *
     * @return business
     */
    public function setUrlcentroayuda($urlcentroayuda)
    {
        $this->urlcentroayuda = $urlcentroayuda;

        return $this;
    }

    /**
     * Get urlcentroayuda
     *
     * @return string
     */
    public function getUrlcentroayuda()
    {
        return $this->urlcentroayuda;
    }

    /**
     * Set webhookstripe
     *
     * @param string $webhookstripe
     *
     * @return business
     */
    public function setWebhookstripe($webhookstripe)
    {
        $this->webhookstripe = $webhookstripe;

        return $this;
    }

    /**
     * Get webhookstripe
     *
     * @return string
     */
    public function getWebhookstripe()
    {
        return $this->webhookstripe;
    }

    /**
     * Set enlacepoliticaprivacidad
     *
     * @param string $enlacepoliticaprivacidad
     *
     * @return business
     */
    public function setEnlacepoliticaprivacidad($enlacepoliticaprivacidad)
    {
        $this->enlacepoliticaprivacidad = $enlacepoliticaprivacidad;

        return $this;
    }

    /**
     * Get enlacepoliticaprivacidad
     *
     * @return string
     */
    public function getEnlacepoliticaprivacidad()
    {
        return $this->enlacepoliticaprivacidad;
    }

    /**
     * Set tienetienda
     *
     * @param boolean $tienetienda
     *
     * @return business
     */
    public function setTienetienda($tienetienda)
    {
        $this->tienetienda = $tienetienda;

        return $this;
    }

    /**
     * Get tienetienda
     *
     * @return boolean
     */
    public function getTienetienda()
    {
        return $this->tienetienda;
    }

    /**
     * Set urlcrearapp
     *
     * @param string $urlcrearapp
     *
     * @return business
     */
    public function setUrlcrearapp($urlcrearapp)
    {
        $this->urlcrearapp = $urlcrearapp;

        return $this;
    }

    /**
     * Get urlcrearapp
     *
     * @return string
     */
    public function getUrlcrearapp()
    {
        return $this->urlcrearapp;
    }

    /**
     * Set urlloginapp
     *
     * @param string $urlloginapp
     *
     * @return business
     */
    public function setUrlloginapp($urlloginapp)
    {
        $this->urlloginapp = $urlloginapp;

        return $this;
    }

    /**
     * Get urlloginapp
     *
     * @return string
     */
    public function getUrlloginapp()
    {
        return $this->urlloginapp;
    }

    /**
     * Set urlapiweb
     *
     * @param string $urlapiweb
     *
     * @return business
     */
    public function setUrlapiweb($urlapiweb)
    {
        $this->urlapiweb = $urlapiweb;

        return $this;
    }

    /**
     * Get urlapiweb
     *
     * @return string
     */
    public function getUrlapiweb()
    {
        return $this->urlapiweb;
    }

    /**
     * Set mensajestep1
     *
     * @param string $mensajestep1
     *
     * @return business
     */
    public function setMensajestep1($mensajestep1)
    {
        $this->mensajestep1 = $mensajestep1;

        return $this;
    }

    /**
     * Get mensajestep1
     *
     * @return string
     */
    public function getMensajestep1()
    {
        return $this->mensajestep1;
    }

    /**
     * Set inicializaciongoogle
     *
     * @param string $inicializaciongoogle
     *
     * @return business
     */
    public function setInicializaciongoogle($inicializaciongoogle)
    {
        $this->inicializaciongoogle = $inicializaciongoogle;

        return $this;
    }

    /**
     * Get inicializaciongoogle
     *
     * @return string
     */
    public function getInicializaciongoogle()
    {
        return $this->inicializaciongoogle;
    }

    /**
     * Set conversiongoogle
     *
     * @param string $conversiongoogle
     *
     * @return business
     */
    public function setConversiongoogle($conversiongoogle)
    {
        $this->conversiongoogle = $conversiongoogle;

        return $this;
    }

    /**
     * Get conversiongoogle
     *
     * @return string
     */
    public function getConversiongoogle()
    {
        return $this->conversiongoogle;
    }

    /**
     * Set condicionesemail
     *
     * @param string $condicionesemail
     *
     * @return business
     */
    public function setCondicionesemail($condicionesemail)
    {
        $this->condicionesemail = $condicionesemail;

        return $this;
    }

    /**
     * Get condicionesemail
     *
     * @return string
     */
    public function getCondicionesemail()
    {
        return $this->condicionesemail;
    }

    /**
     * Set pathimagenemail
     *
     * @param string $pathimagenemail
     *
     * @return business
     */
    public function setPathimagenemail($pathimagenemail)
    {
        $this->pathimagenemail = $pathimagenemail;

        return $this;
    }

    /**
     * Get pathimagenemail
     *
     * @return string
     */
    public function getPathimagenemail()
    {
        return $this->pathimagenemail;
    }

    /**
     * Set password
     *
     * @param string $password
     *
     * @return business
     */
    public function setPassword($password)
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Get password
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * Set smtphost
     *
     * @param string $smtphost
     *
     * @return business
     */
    public function setSmtphost($smtphost)
    {
        $this->smtphost = $smtphost;

        return $this;
    }

    /**
     * Get smtphost
     *
     * @return string
     */
    public function getSmtphost()
    {
        return $this->smtphost;
    }

    /**
     * Set smtpport
     *
     * @param string $smtpport
     *
     * @return business
     */
    public function setSmtpport($smtpport)
    {
        $this->smtpport = $smtpport;

        return $this;
    }

    /**
     * Get smtpport
     *
     * @return string
     */
    public function getSmtpport()
    {
        return $this->smtpport;
    }

    /**
     * Set smtpsecurity
     *
     * @param string $smtpsecurity
     *
     * @return business
     */
    public function setSmtpsecurity($smtpsecurity)
    {
        $this->smtpsecurity = $smtpsecurity;

        return $this;
    }

    /**
     * Get smtpsecurity
     *
     * @return string
     */
    public function getSmtpsecurity()
    {
        return $this->smtpsecurity;
    }

    /**
     * Set fontstyle
     *
     * @param string $fontstyle
     *
     * @return business
     */
    public function setFontstyle($fontstyle)
    {
        $this->fontstyle = $fontstyle;

        return $this;
    }

    /**
     * Get fontstyle
     *
     * @return string
     */
    public function getFontstyle()
    {
        return $this->fontstyle;
    }

    /**
     * Set namefont
     *
     * @param string $namefont
     *
     * @return business
     */
    public function setNamefont($namefont)
    {
        $this->namefont = $namefont;

        return $this;
    }

    /**
     * Get namefont
     *
     * @return string
     */
    public function getNamefont()
    {
        return $this->namefont;
    }

    /**
     * Set folderemail
     *
     * @param string $folderemail
     *
     * @return business
     */
    public function setFolderemail($folderemail)
    {
        $this->folderemail = $folderemail;

        return $this;
    }

    /**
     * Get folderemail
     *
     * @return string
     */
    public function getFolderemail()
    {
        return $this->folderemail;
    }

    /**
     * Set asuntobienvenida
     *
     * @param string $asuntobienvenida
     *
     * @return business
     */
    public function setAsuntobienvenida($asuntobienvenida)
    {
        $this->asuntobienvenida = $asuntobienvenida;

        return $this;
    }

    /**
     * Get asuntobienvenida
     *
     * @return string
     */
    public function getAsuntobienvenida()
    {
        return $this->asuntobienvenida;
    }

    /**
     * Set asuntoguia
     *
     * @param string $asuntoguia
     *
     * @return business
     */
    public function setAsuntoguia($asuntoguia)
    {
        $this->asuntoguia = $asuntoguia;

        return $this;
    }

    /**
     * Get asuntoguia
     *
     * @return string
     */
    public function getAsuntoguia()
    {
        return $this->asuntoguia;
    }

    /**
     * Set asuntorecordatorio5
     *
     * @param string $asuntorecordatorio5
     *
     * @return business
     */
    public function setAsuntorecordatorio5($asuntorecordatorio5)
    {
        $this->asuntorecordatorio5 = $asuntorecordatorio5;

        return $this;
    }

    /**
     * Get asuntorecordatorio5
     *
     * @return string
     */
    public function getAsuntorecordatorio5()
    {
        return $this->asuntorecordatorio5;
    }

    /**
     * Set asuntorecordatorio10
     *
     * @param string $asuntorecordatorio10
     *
     * @return business
     */
    public function setAsuntorecordatorio10($asuntorecordatorio10)
    {
        $this->asuntorecordatorio10 = $asuntorecordatorio10;

        return $this;
    }

    /**
     * Get asuntorecordatorio10
     *
     * @return string
     */
    public function getAsuntorecordatorio10()
    {
        return $this->asuntorecordatorio10;
    }

    /**
     * Set asuntorecordatorio15
     *
     * @param string $asuntorecordatorio15
     *
     * @return business
     */
    public function setAsuntorecordatorio15($asuntorecordatorio15)
    {
        $this->asuntorecordatorio15 = $asuntorecordatorio15;

        return $this;
    }

    /**
     * Get asuntorecordatorio15
     *
     * @return string
     */
    public function getAsuntorecordatorio15()
    {
        return $this->asuntorecordatorio15;
    }

    /**
     * Set asuntopassword
     *
     * @param string $asuntopassword
     *
     * @return business
     */
    public function setAsuntopassword($asuntopassword)
    {
        $this->asuntopassword = $asuntopassword;

        return $this;
    }

    /**
     * Get asuntopassword
     *
     * @return string
     */
    public function getAsuntopassword()
    {
        return $this->asuntopassword;
    }

    /**
     * Set asuntocompra
     *
     * @param string $asuntocompra
     *
     * @return business
     */
    public function setAsuntocompra($asuntocompra)
    {
        $this->asuntocompra = $asuntocompra;

        return $this;
    }

    /**
     * Get asuntocompra
     *
     * @return string
     */
    public function getAsuntocompra()
    {
        return $this->asuntocompra;
    }

    /**
     * Set asuntofinalizada
     *
     * @param string $asuntofinalizada
     *
     * @return business
     */
    public function setAsuntofinalizada($asuntofinalizada)
    {
        $this->asuntofinalizada = $asuntofinalizada;

        return $this;
    }

    /**
     * Get asuntofinalizada
     *
     * @return string
     */
    public function getAsuntofinalizada()
    {
        return $this->asuntofinalizada;
    }

    /**
     * Set mesestest
     *
     * @param integer $mesestest
     *
     * @return business
     */
    public function setMesestest($mesestest)
    {
        $this->mesestest = $mesestest;

        return $this;
    }

    /**
     * Get mesestest
     *
     * @return integer
     */
    public function getMesestest()
    {
        return $this->mesestest;
    }

    /**
     * Set reservadominiosinpago
     *
     * @param boolean $reservadominiosinpago
     *
     * @return business
     */
    public function setReservadominiosinpago($reservadominiosinpago)
    {
        $this->reservadominiosinpago = $reservadominiosinpago;

        return $this;
    }

    /**
     * Get reservadominiosinpago
     *
     * @return boolean
     */
    public function getReservadominiosinpago()
    {
        return $this->reservadominiosinpago;
    }

    /**
     * Set favicon
     *
     * @param string $favicon
     *
     * @return business
     */
    public function setFavicon($favicon)
    {
        $this->favicon = $favicon;

        return $this;
    }

    /**
     * Get favicon
     *
     * @return string
     */
    public function getFavicon()
    {
        return $this->favicon;
    }

    /**
     * Set cabeceralogin
     *
     * @param string $cabeceralogin
     *
     * @return business
     */
    public function setCabeceralogin($cabeceralogin)
    {
        $this->cabeceralogin = $cabeceralogin;

        return $this;
    }

    /**
     * Get cabeceralogin
     *
     * @return string
     */
    public function getCabeceralogin()
    {
        return $this->cabeceralogin;
    }
}
