<?php

namespace PagoBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * order
 *
 * @ORM\Table(name="eventostripe")
 * @ORM\Entity(repositoryClass="PagoBundle\Repository\eventostripeRepository")
 */
class eventostripe
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
    
    /**
     * @var client
     *
     * @ORM\ManyToOne(targetEntity="UsuarioBundle\Entity\usuario")
     */
    private $usuario;

    /**
     * @var business
     *
     * @ORM\ManyToOne(targetEntity="PagoBundle\Entity\business")
     */
    private $business;

    /**
     * @var plan
     *
     * @ORM\ManyToOne(targetEntity="AdministracionBundle\Entity\plan")
     */
    private $plan;

    /**
     * @var float
     *
     * @ORM\Column(name="payload", type="text", nullable=true)
     */
    private $payload;

    /**
     * @var string
     *
     * @ORM\Column(name="event", type="string", nullable=true)
     */
    private $event;

    /**
     * @var string
     *
     * @ORM\Column(name="stripesubscriptionid", type="string", nullable=true)
     */
    private $stripesubscriptionid;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="periodstart", type="datetime", nullable=true)
     */
    private $periodstart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="periodend", type="datetime", nullable=true)
     */
    private $periodend;
    
    /**
     * @var float
     *
     * @ORM\Column(name="amount", type="float", nullable=true)
     */
    private $amount;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="createdAt", type="datetime")
     */
    private $createdAt;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="condominio", type="boolean", nullable=true)
     */
    private $condominio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="tiendaactiva", type="boolean", nullable=true)
     */
    private $tiendaactiva; 
    
    /**
     * @var integer
     *
     * @ORM\Column(name="numeromaximoemails", type="integer", nullable=true)
     */
    private $numeromaximoemails; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="crmeactivo", type="boolean", nullable=true)
     */
    private $crmeactivo; 
    
    /**
     * @var integer
     *
     * @ORM\Column(name="textoservicio", type="string", nullable=true, length=255, nullable=true)
     */
    private $textoservicio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="standardcreatuaplicacion", type="boolean")
     */
    private $standardcreatuaplicacion; 

    /**
     * @var string
     *
     * @ORM\Column(name="pathfactura", type="string", nullable=true)
     */
    private $pathfactura;
    
    public function getTextoevento(){
        $texto = "";
        if ($this->getEvent() == "invoice.payment_succeeded"){
            $texto = "Se ha renovado la suscripción";
        }else if ($this->getEvent() == "customer.subscription.deleted"){
            $texto = "Se ha borrado la suscripción";
        }
        return $texto;
    }

    public function __construct() {
        $this->createdAt = new \DateTime();
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set payload
     *
     * @param string $payload
     *
     * @return eventostripe
     */
    public function setPayload($payload)
    {
        $this->payload = $payload;

        return $this;
    }

    /**
     * Get payload
     *
     * @return string
     */
    public function getPayload()
    {
        return $this->payload;
    }

    /**
     * Set event
     *
     * @param string $event
     *
     * @return eventostripe
     */
    public function setEvent($event)
    {
        $this->event = $event;

        return $this;
    }

    /**
     * Get event
     *
     * @return string
     */
    public function getEvent()
    {
        return $this->event;
    }

    /**
     * Set stripesubscriptionid
     *
     * @param string $stripesubscriptionid
     *
     * @return eventostripe
     */
    public function setStripesubscriptionid($stripesubscriptionid)
    {
        $this->stripesubscriptionid = $stripesubscriptionid;

        return $this;
    }

    /**
     * Get stripesubscriptionid
     *
     * @return string
     */
    public function getStripesubscriptionid()
    {
        return $this->stripesubscriptionid;
    }

    /**
     * Set periodstart
     *
     * @param \DateTime $periodstart
     *
     * @return eventostripe
     */
    public function setPeriodstart($periodstart)
    {
        $this->periodstart = $periodstart;

        return $this;
    }

    /**
     * Get periodstart
     *
     * @return \DateTime
     */
    public function getPeriodstart()
    {
        return $this->periodstart;
    }

    /**
     * Set periodend
     *
     * @param \DateTime $periodend
     *
     * @return eventostripe
     */
    public function setPeriodend($periodend)
    {
        $this->periodend = $periodend;

        return $this;
    }

    /**
     * Get periodend
     *
     * @return \DateTime
     */
    public function getPeriodend()
    {
        return $this->periodend;
    }

    /**
     * Set amount
     *
     * @param float $amount
     *
     * @return eventostripe
     */
    public function setAmount($amount)
    {
        $this->amount = $amount;

        return $this;
    }

    /**
     * Get amount
     *
     * @return float
     */
    public function getAmount()
    {
        return $this->amount;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     *
     * @return eventostripe
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set usuario
     *
     * @param \UsuarioBundle\Entity\usuario $usuario
     *
     * @return eventostripe
     */
    public function setUsuario(\UsuarioBundle\Entity\usuario $usuario = null)
    {
        $this->usuario = $usuario;

        return $this;
    }

    /**
     * Get usuario
     *
     * @return \UsuarioBundle\Entity\usuario
     */
    public function getUsuario()
    {
        return $this->usuario;
    }

    /**
     * Set business
     *
     * @param \PagoBundle\Entity\business $business
     *
     * @return eventostripe
     */
    public function setBusiness(\PagoBundle\Entity\business $business = null)
    {
        $this->business = $business;

        return $this;
    }

    /**
     * Get business
     *
     * @return \PagoBundle\Entity\business
     */
    public function getBusiness()
    {
        return $this->business;
    }

    /**
     * Set plan
     *
     * @param \AdministracionBundle\Entity\plan $plan
     *
     * @return eventostripe
     */
    public function setPlan(\AdministracionBundle\Entity\plan $plan = null)
    {
        $this->plan = $plan;

        return $this;
    }

    /**
     * Get plan
     *
     * @return \AdministracionBundle\Entity\plan
     */
    public function getPlan()
    {
        return $this->plan;
    }

    /**
     * Set condominio
     *
     * @param boolean $condominio
     *
     * @return eventostripe
     */
    public function setCondominio($condominio)
    {
        $this->condominio = $condominio;

        return $this;
    }

    /**
     * Get condominio
     *
     * @return boolean
     */
    public function getCondominio()
    {
        return $this->condominio;
    }

    /**
     * Set tiendaactiva
     *
     * @param boolean $tiendaactiva
     *
     * @return eventostripe
     */
    public function setTiendaactiva($tiendaactiva)
    {
        $this->tiendaactiva = $tiendaactiva;

        return $this;
    }

    /**
     * Get tiendaactiva
     *
     * @return boolean
     */
    public function getTiendaactiva()
    {
        return $this->tiendaactiva;
    }

    /**
     * Set numeromaximoemails
     *
     * @param integer $numeromaximoemails
     *
     * @return eventostripe
     */
    public function setNumeromaximoemails($numeromaximoemails)
    {
        $this->numeromaximoemails = $numeromaximoemails;

        return $this;
    }

    /**
     * Get numeromaximoemails
     *
     * @return integer
     */
    public function getNumeromaximoemails()
    {
        return $this->numeromaximoemails;
    }

    /**
     * Set crmeactivo
     *
     * @param boolean $crmeactivo
     *
     * @return eventostripe
     */
    public function setCrmeactivo($crmeactivo)
    {
        $this->crmeactivo = $crmeactivo;

        return $this;
    }

    /**
     * Get crmeactivo
     *
     * @return boolean
     */
    public function getCrmeactivo()
    {
        return $this->crmeactivo;
    }

    /**
     * Set textoservicio
     *
     * @param string $textoservicio
     *
     * @return eventostripe
     */
    public function setTextoservicio($textoservicio)
    {
        $this->textoservicio = $textoservicio;

        return $this;
    }

    /**
     * Get textoservicio
     *
     * @return string
     */
    public function getTextoservicio()
    {
        return $this->textoservicio;
    }

    /**
     * Set standardcreatuaplicacion
     *
     * @param boolean $standardcreatuaplicacion
     *
     * @return eventostripe
     */
    public function setStandardcreatuaplicacion($standardcreatuaplicacion)
    {
        $this->standardcreatuaplicacion = $standardcreatuaplicacion;

        return $this;
    }

    /**
     * Get standardcreatuaplicacion
     *
     * @return boolean
     */
    public function getStandardcreatuaplicacion()
    {
        return $this->standardcreatuaplicacion;
    }

    /**
     * Set pathfactura
     *
     * @param string $pathfactura
     *
     * @return eventostripe
     */
    public function setPathfactura($pathfactura)
    {
        $this->pathfactura = $pathfactura;

        return $this;
    }

    /**
     * Get pathfactura
     *
     * @return string
     */
    public function getPathfactura()
    {
        return $this->pathfactura;
    }
}
