<?php

namespace PagoBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * order
 *
 * @ORM\Table(name="pago")
 * @ORM\Entity(repositoryClass="PagoBundle\Repository\pagoRepository")
 */
class pago
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
    
    /**
     * @var client
     *
     * @ORM\ManyToOne(targetEntity="UsuarioBundle\Entity\usuario")
     */
    private $usuario;

    /**
     * @var business
     *
     * @ORM\ManyToOne(targetEntity="PagoBundle\Entity\business")
     */
    private $business;

    /**
     * @var float
     *
     * @ORM\Column(name="subtotal", type="float")
     */
    private $subtotal;

    /**
     * @var float
     *
     * @ORM\Column(name="taxes", type="float")
     */
    private $taxes;

    /**
     * @var float
     *
     * @ORM\Column(name="descuento", type="float")
     */
    private $descuento;

    /**
     * @var float
     *
     * @ORM\Column(name="total", type="float")
     */
    private $total;

    /**
     * @var float
     *
     * @ORM\Column(name="totaldescuento", type="float")
     */
    private $totaldescuento;

    /**
     * @var Boolean
     *
     * @ORM\Column(name="pagado", type="boolean")
     */
    private $pagado;

    /**
     * @var integer
     * 1 --> Pedido guardado
     * 2 --> Pago aceptado
     * 3 --> Pago rechazado
     * 4 --> Pago anulado
     * @ORM\Column(name="estado", type="integer")
     */
    private $estado;
    
    /**
     * @var string
     *
     * @ORM\Column(name="authorizationcode", type="string", length=255, nullable=true)
     */
    private $authorizationcode;
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="datepayment", type="datetime", nullable=true)
     */
    private $datepayment;

    /**
     * @var int
     *
     * @ORM\Column(name="eliminado", type="integer")
     */
    private $eliminado;    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="updatedAt", type="datetime", nullable=true)
     */
    private $updatedAt;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="createdAt", type="datetime")
     */
    private $createdAt;

    /**
     * @var string
     *
     * @ORM\Column(name="deliveryName", type="string", length=255, nullable=true)
     */
    private $deliveryName;
    
    /**
     * @var integer
     * 0 --> Sin forma de pago
     * 1 --> Paypal
     * 2 --> Redsys
     * 3 --> Transferencia bancaria
     * @ORM\Column(name="paymentform", type="integer")
     */
    private $paymentform;
    
    public function getNamepaymentform(){
        $s = "";
        if ($this->getPaymentform() == 1){
            $s = "Paypal";
        }else if ($this->getPaymentform() == 2){
            $s = "Redsys";
        }else if ($this->getPaymentform() == 3){
            $s = "Transferencia bancaria";
        }
            
        return $s;
    }
    
    public function getTextoestado(){
        $t = "";
        if ($this->getStatus() == 1){
            $t = "Inicio de pago guardado";
        }else if ($this->getStatus() == 2){
            $t = "Pago aceptado";
        }else if ($this->getStatus() == 3){
            $t = "Pago rechazado";
        }else if ($this->getStatus() == 4){
            $t = "Pago anulado";
        }
        return $t;
    }

    public function __construct() {
        $this->pagado = false;
        $this->estado = 1;
        $this->updatedAt = new \DateTime();
        $this->createdAt = new \DateTime();
        $this->total = 0;
        $this->totaldescuento = 0;
        $this->taxes = 0;
        $this->subtotal = 0;
        $this->eliminado = 0;
        $this->estado = 1;
        $this->paymentform = 0;
    }

   

    

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set orderNumber
     *
     * @param integer $orderNumber
     *
     * @return order
     */
    public function setOrderNumber($orderNumber)
    {
        $this->orderNumber = $orderNumber;

        return $this;
    }

    /**
     * Get orderNumber
     *
     * @return integer
     */
    public function getOrderNumber()
    {
        return $this->orderNumber;
    }

    /**
     * Set subtotal
     *
     * @param float $subtotal
     *
     * @return order
     */
    public function setSubtotal($subtotal)
    {
        $this->subtotal = $subtotal;

        return $this;
    }

    /**
     * Get subtotal
     *
     * @return float
     */
    public function getSubtotal()
    {
        return $this->subtotal;
    }

    /**
     * Set taxes
     *
     * @param float $taxes
     *
     * @return order
     */
    public function setTaxes($taxes)
    {
        $this->taxes = $taxes;

        return $this;
    }

    /**
     * Get taxes
     *
     * @return float
     */
    public function getTaxes()
    {
        return $this->taxes;
    }

    /**
     * Set descuento
     *
     * @param float $descuento
     *
     * @return order
     */
    public function setDescuento($descuento)
    {
        $this->descuento = $descuento;

        return $this;
    }

    /**
     * Get descuento
     *
     * @return float
     */
    public function getDescuento()
    {
        return $this->descuento;
    }

    /**
     * Set total
     *
     * @param float $total
     *
     * @return order
     */
    public function setTotal($total)
    {
        $this->total = $total;

        return $this;
    }

    /**
     * Get total
     *
     * @return float
     */
    public function getTotal()
    {
        return $this->total;
    }

    /**
     * Set totaldescuento
     *
     * @param float $totaldescuento
     *
     * @return order
     */
    public function setTotaldescuento($totaldescuento)
    {
        $this->totaldescuento = $totaldescuento;

        return $this;
    }

    /**
     * Get totaldescuento
     *
     * @return float
     */
    public function getTotaldescuento()
    {
        return $this->totaldescuento;
    }

    /**
     * Set pagado
     *
     * @param boolean $pagado
     *
     * @return order
     */
    public function setPagado($pagado)
    {
        $this->pagado = $pagado;

        return $this;
    }

    /**
     * Get pagado
     *
     * @return boolean
     */
    public function getPagado()
    {
        return $this->pagado;
    }

    /**
     * Set estado
     *
     * @param integer $estado
     *
     * @return order
     */
    public function setEstado($estado)
    {
        $this->estado = $estado;

        return $this;
    }

    /**
     * Get estado
     *
     * @return integer
     */
    public function getEstado()
    {
        return $this->estado;
    }

    /**
     * Set authorizationcode
     *
     * @param string $authorizationcode
     *
     * @return order
     */
    public function setAuthorizationcode($authorizationcode)
    {
        $this->authorizationcode = $authorizationcode;

        return $this;
    }

    /**
     * Get authorizationcode
     *
     * @return string
     */
    public function getAuthorizationcode()
    {
        return $this->authorizationcode;
    }

    /**
     * Set datepayment
     *
     * @param \DateTime $datepayment
     *
     * @return order
     */
    public function setDatepayment($datepayment)
    {
        $this->datepayment = $datepayment;

        return $this;
    }

    /**
     * Get datepayment
     *
     * @return \DateTime
     */
    public function getDatepayment()
    {
        return $this->datepayment;
    }

    /**
     * Set eliminado
     *
     * @param integer $eliminado
     *
     * @return order
     */
    public function setEliminado($eliminado)
    {
        $this->eliminado = $eliminado;

        return $this;
    }

    /**
     * Get eliminado
     *
     * @return integer
     */
    public function getEliminado()
    {
        return $this->eliminado;
    }

    /**
     * Set updatedAt
     *
     * @param \DateTime $updatedAt
     *
     * @return order
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * Get updatedAt
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     *
     * @return order
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set paymentform
     *
     * @param integer $paymentform
     *
     * @return order
     */
    public function setPaymentform($paymentform)
    {
        $this->paymentform = $paymentform;

        return $this;
    }

    /**
     * Get paymentform
     *
     * @return integer
     */
    public function getPaymentform()
    {
        return $this->paymentform;
    }

    /**
     * Set usuario
     *
     * @param \UsuarioBundle\Entity\usuario $usuario
     *
     * @return order
     */
    public function setUsuario(\UsuarioBundle\Entity\usuario $usuario = null)
    {
        $this->usuario = $usuario;

        return $this;
    }

    /**
     * Get usuario
     *
     * @return \UsuarioBundle\Entity\usuario
     */
    public function getUsuario()
    {
        return $this->usuario;
    }

    /**
     * Set business
     *
     * @param \PagoBundle\Entity\business $business
     *
     * @return order
     */
    public function setBusiness(\PagoBundle\Entity\business $business = null)
    {
        $this->business = $business;

        return $this;
    }

    /**
     * Get business
     *
     * @return \PagoBundle\Entity\business
     */
    public function getBusiness()
    {
        return $this->business;
    }

    /**
     * Set number
     *
     * @param integer $number
     *
     * @return order
     */
    public function setNumber($number)
    {
        $this->number = $number;

        return $this;
    }

    /**
     * Get number
     *
     * @return integer
     */
    public function getNumber()
    {
        return $this->number;
    }

    /**
     * Set deliveryName
     *
     * @param string $deliveryName
     *
     * @return pago
     */
    public function setDeliveryName($deliveryName)
    {
        $this->deliveryName = $deliveryName;

        return $this;
    }

    /**
     * Get deliveryName
     *
     * @return string
     */
    public function getDeliveryName()
    {
        return $this->deliveryName;
    }
}
