<?php

namespace PublicBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

class envioemailCommand extends ContainerAwareCommand {
    protected function configure()
    {
        $this->setName('envio:email');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $em = $this->getContainer()->get('doctrine')->getEntityManager();
        $usuario = $em->getRepository('UsuarioBundle:administrador')->find(133);
        if ($usuario != NULL){
            $business = $usuario->getBusiness();
            $style = $business->getStyle();
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/1bienvenida.html.twig";
            $subject = strip_tags($business->getAsuntobienvenida());    
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/3mailrecordatoria5dias.html.twig";
            $subject = strip_tags($business->getAsuntorecordatorio5());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/4mailrecordatoria10dias.html.twig";
            $subject = strip_tags($business->getAsuntorecordatorio10());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/5mailrecordatoria15dias.html.twig";
            $subject = strip_tags($business->getAsuntorecordatorio15());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/6mailrecordatoriafinalizada.html.twig";
            $subject = strip_tags($business->getAsuntofinalizada());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail/" . $business->getFolderemail() .":7mailcontrasena.html.twig";
            $subject = strip_tags($business->getAsuntopassword());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:" . $business->getFolderemail() ."/9recordatoriocompraprueba.html.twig";
            $subject = strip_tags($business->getAsuntocompra());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
            
            $template = "PublicBundle:mail:activarregistro.html.twig";
            $subject = strip_tags($business->getMensajeregistro());
            $this->sendEmail($business, $style, $usuario, $template, $subject);
        }
    }
    
    public function sendEmail($business, $style, $usuario, $template, $subject, $enlace = NULL){
        $url = "https://" . $business->getUrlregistro();
        $body = $this->getApplication()->getKernel()->getContainer()->get('templating')
                ->render($template, array(
                                    "business" => $business, 
                                    "style" => $style,
                                    "url" => $url,
                                    "usuario" => $usuario,
                                    "enlace" => $url));

        $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                            ->setUsername($business->getEmail())
                            ->setPassword($business->desencryptarPassword());

        $mailer = \Swift_Mailer::newInstance($transport);
        $message = \Swift_Message::newInstance($subject)
                    ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                    ->setTo($usuario->getEmail())
                    ->setBody($body, 'text/html');
        $mailer->send($message);
    }
}
