<?php

namespace PublicBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use CoreBundle\Entity\Cipher;

class recordatoriocompraCommand extends ContainerAwareCommand {
    protected function configure()
    {
        $this->setName('recordatorio:compra');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $em = $this->getContainer()->get('doctrine')->getEntityManager();
        $usuarios = $em->getRepository('UsuarioBundle:administrador')->findComprainicial();
        $fecha = new \DateTime();
        foreach ($usuarios as $usuario) {
            echo $usuario . "\n";
            $business = $usuario->getBusiness();
            if ($business != NULL){
                $post = array("action" => "compraprueba");
                $params = ['passopen' => $usuario->desencriptarpassword(),
                            "email" => $usuario->getEmail() . "",
                            "fecha" => $fecha->format("d/m/Y")];
                $post["params"] = $params;

                $url = $business->getUrlapiweb();

                $myjson = json_encode($post);
                $data_string = Cipher::crypt($myjson);
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string); 
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                    'Content-Type: application/json',                                                                                
                    'Content-Length: ' . strlen($data_string))                                                                       
                ); 
                $response = curl_exec($ch); 
                curl_close($ch);
                $responsejson = json_decode($response, true);
                
                var_dump($responsejson);
                echo "\n\n";
                if (isset($responsejson["return"]["realizada"])){
                    $realizada = boolval($responsejson["return"]["realizada"]);
                    if ($realizada == false && $usuario->getFechaenviocompra() == false){
                        $usuario->setFechaenviocompra(new \DateTime());
                        $em->persist($usuario);
                        $em->flush();

                        $template = "PublicBundle:mail:" . $business->getFolderemail() ."/9recordatoriocompraprueba.html.twig";
                        $subject = strip_tags($business->getAsuntocompra());
                        $style = $business->getStyle();
                        $url = "https://" . $business->getUrlregistro();
                        $body = $this->getApplication()->getKernel()->getContainer()->get('templating')
                                ->render($template, array(
                                                    "business" => $business, 
                                                    "style" => $style,
                                                    "url" => $url,
                                                    "usuario" => $usuario));

                        $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                            ->setUsername($business->getEmail())
                                            ->setPassword($business->desencryptarPassword());

                        $mailer = \Swift_Mailer::newInstance($transport);
                        $message = \Swift_Message::newInstance($subject)
                                    ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                    ->setTo($usuario->getEmail())
                                    ->setBody($body, 'text/html');
                        $mailer->send($message);
                    }else if ($realizada){
                        $usuario->setComprarealizada(TRUE);
                        $em->persist($usuario);
                        $em->flush();
                    }
                }
            }
            /*$diaexpiracion = $usuario->getFechaexpiracion();
            $email = $usuario->getEmail();
            $business = $usuario->getBusiness();
            if(filter_var($email, FILTER_VALIDATE_EMAIL) && $business != NULL 
                    && $business->getFolderemail() != NULL && $diaexpiracion != NULL) {
                $style = $business->getStyle();
                $hoy = new \DateTime();
                $interval = $diaexpiracion->diff($hoy);
                $dias = intval($interval->format('%a'));
                $template = NULL;
                $subject = NULL;
                
                echo $diaexpiracion->format("d/m/Y") . " " . $dias . "\n";
                if ($dias == 5 && $usuario->getRecordatorio1() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/3mailrecordatoria5dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio5());
                    
                    $usuario->setRecordatorio1(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias == 10 && $usuario->getRecordatorio2() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/4mailrecordatoria10dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio10());

                    $usuario->setRecordatorio2(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias == 15 && $usuario->getRecordatorio3() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/5mailrecordatoria15dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio10());

                    $usuario->setRecordatorio3(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias <= 0){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/6mailrecordatoriafinalizada.html.twig";
                    $subject = strip_tags($business->getAsuntofinalizada());

                    $usuario->setRecordatorioexpirado(true);
                    $em->persist($usuario);
                    $em->flush();
                }
                
                if ($template != NULL && $subject != NULL){
                    $url = "https://" . $business->getUrlregistro();
                    $body = $this->getApplication()->getKernel()->getContainer()->get('templating')
                            ->render($template, array(
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url,
                                                "usuario" => $usuario));
                    
                    $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                        ->setUsername($business->getEmail())
                                        ->setPassword($business->desencryptarPassword());
                    
                    $mailer = \Swift_Mailer::newInstance($transport);
                    $message = \Swift_Message::newInstance($subject)
                                ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                ->setTo($usuario->getEmail())
                                ->setBody($body, 'text/html');
                    $mailer->send($message);
                }
            }*/
        }
        $text = "" . count($usuarios);
        $output->writeln($text);
    }
}
