<?php

namespace PublicBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

class recordatorioperiodopruebaCommand extends ContainerAwareCommand {
    protected function configure()
    {
        $this->setName('recordatorio:periodoprueba');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $em = $this->getContainer()->get('doctrine')->getEntityManager();
        $usuarios = $em->getRepository('UsuarioBundle:administrador')->findPeriodoprueba();
        foreach ($usuarios as $usuario) {
            $diaexpiracion = $usuario->getFechaexpiracion();
            $email = $usuario->getEmail();
            $business = $usuario->getBusiness();
            if(filter_var($email, FILTER_VALIDATE_EMAIL) && $business != NULL 
                    && $business->getFolderemail() != NULL && $diaexpiracion != NULL) {
                $style = $business->getStyle();
                $hoy = new \DateTime();
                $interval = $diaexpiracion->diff($hoy);
                $dias = intval($interval->format('%a'));
                $template = NULL;
                $subject = NULL;
                
                echo $diaexpiracion->format("d/m/Y") . " " . $dias . "\n";
                if ($dias == 5 && $usuario->getRecordatorio1() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/3mailrecordatoria5dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio5());
                    
                    $usuario->setRecordatorio1(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias == 10 && $usuario->getRecordatorio2() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/4mailrecordatoria10dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio10());

                    $usuario->setRecordatorio2(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias == 15 && $usuario->getRecordatorio3() == false){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/5mailrecordatoria15dias.html.twig";
                    $subject = strip_tags($business->getAsuntorecordatorio15());

                    $usuario->setRecordatorio3(true);
                    $em->persist($usuario);
                    $em->flush();
                }else if ($dias <= 0){
                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/6mailrecordatoriafinalizada.html.twig";
                    $subject = strip_tags($business->getAsuntofinalizada());

                    $usuario->setRecordatorioexpirado(true);
                    $em->persist($usuario);
                    $em->flush();
                }
                
                if ($template != NULL && $subject != NULL){
                    $url = "https://" . $business->getUrlregistro();
                    $body = $this->getApplication()->getKernel()->getContainer()->get('templating')
                            ->render($template, array(
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url,
                                                "usuario" => $usuario));
                    
                    $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                        ->setUsername($business->getEmail())
                                        ->setPassword($business->desencryptarPassword());
                    
                    $mailer = \Swift_Mailer::newInstance($transport);
                    $message = \Swift_Message::newInstance($subject)
                                ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                ->setTo($usuario->getEmail())
                                ->setBody($body, 'text/html');
                    $mailer->send($message);
                }
            }
        }
        $text = "" . count($usuarios);
        $output->writeln($text);
    }
}
