<?php

namespace RegistroBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use UsuarioBundle\Entity\administrador;
use UsuarioBundle\Form\usuarioType;
use WebBundle\Entity\web;
use Symfony\Component\Filesystem\Filesystem;
use CoreBundle\Entity\Cipher;
use WebBundle\Entity\briefing;
use CoreBundle\Entity\Utils;
use WebBundle\Form\briefingInformacionType;
use UsuarioBundle\Form\usuariopassType;
use CoreBundle\Entity\Domainutils;

class RegistroController extends Controller
{
    public function recuperarpasscodAction(Request $request, $md5)
    {
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        
        $error = NULL;
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        if ($business){
            $style = $business->getStyle();
            if($style){
                $usuario = $em->getRepository('UsuarioBundle:administrador')
                        ->findOneBy(array('codigorecuperacion'=>$md5));
                if ($usuario != NULL){
                    $form = $this->createForm(usuariopassType::class, $usuario,  array());
                    if($request->getMethod() == 'POST'){
                        $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) {
                            $usuario->setSalt(md5(time()));
                            $encoder = $this->get('security.encoder_factory')->getEncoder($usuario);
                            $passwordCodificado = $encoder->encodePassword($usuario->getPassword(), $usuario->getSalt());
                            $usuario->setPassword($passwordCodificado);
                            $usuario->setCodigorecuperacion(NULL);
                            $em->persist($usuario);
                            $em->flush();
                            return $this->redirectToRoute("login");
                        }else{
                            $error = "Error al introducir la nueva contraseña";
                        }
                    }
                    return $this->render('RegistroBundle:registro:recuperarpasscod.html.twig', 
                            array("style" => $style, "business" => $business, 
                                "usuario" => $usuario,
                                "form" => $form->createView(),
                                "error" => $error));
                }
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function recuperarpassAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        $style = NULL;
        $error = NULL;
        $protocol = $request->getScheme();
        $url = $protocol . "://" . $host;
        if ($business){
            $style = $business->getStyle();
            if($style){
                if ($request->getMethod() == "POST"){
                    $email = $request->request->get("email");
                    // Se comprueba si existe un usuario en la base de datos
                    $usuario = $em->getRepository('UsuarioBundle:administrador')
                                ->findOneBy(array('email'=> $email ));
                    if ($usuario != NULL){
                        $codigorecuperacion = md5(microtime());
                        $existe = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigorecuperacion'=>$codigorecuperacion));
                        while($existe){
                            $codigorecuperacion = md5(microtime());
                            $existe = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigorecuperacion'=>$codigorecuperacion));
                        }
                        $usuario->setCodigorecuperacion($codigorecuperacion);
                        $em->persist($usuario);
                        $em->flush();
                        $enl = $this->generateUrl("registro_recuperar_pass_cod", 
                                    array("md5" => $usuario->getCodigorecuperacion()));
                        $enlace = $url . $enl;

                        $kernel = $this->get('kernel');
                        $devMode = $kernel->isDebug();
                        if ($devMode == FALSE){
                            $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                    ->setUsername($business->getEmail())
                                    ->setPassword($business->desencryptarPassword());
                            $body = NULL;
                            $titulopersonal = NULL;
                            if ($business->getFolderemail() != NULL){
                                $body = $this->renderView("PublicBundle:mail/" . $business->getFolderemail() .":7mailcontrasena.html.twig", 
                                    array("enlace" => $enlace, 
                                        "business" => $business, 
                                        "style" => $style,
                                        "usuario" => $usuario,
                                        "url" => $url));
                                $titulopersonal = strip_tags($business->getAsuntopassword());
                            }else{
                                $body = $this->renderView("PublicBundle:mail:recuperarpassmail.html.twig", 
                                    array("enlace" => $enlace, 
                                        "business" => $business, 
                                        "style" => $style,
                                        "usuario" => $usuario,
                                        "url" => $url));
                                $titulopersonal = $business->getMensajeregistro();
                            }
                            $mailer = \Swift_Mailer::newInstance($transport);
                            $message = \Swift_Message::newInstance($titulopersonal)
                                        ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                        ->setTo($usuario->getEmail())
                                        ->setBody($body, 'text/html');
                            $mailer->send($message);
                            
                            return $this->render('RegistroBundle:registro:recuperarpassenviado.html.twig', 
                                array("style" => $style, "business" => $business, 
                                    "email" => $usuario->getEmail()));
                        }else{
                            return $this->render("PublicBundle:mail:recuperarpassmail.html.twig", 
                                array("enlace" => $enlace, 
                                    "business" => $business, 
                                    "style" => $style,
                                    "usuario" => $usuario,
                                    "url" => $url));
                        }
                    }else{
                        $error = "Lo sentimos el usuarios no existe";
                    }
                }
                return $this->render('RegistroBundle:registro:recuperarpass.html.twig', 
                        array("style" => $style, "business" => $business, 
                            "error" => $error));
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function politicaprivacidadAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        $style = NULL;
        if ($business){
            $style = $business->getStyle();
            if($style){
                return $this->render('RegistroBundle:registro:politicaprivacidad.html.twig', 
                        array("style" => $style, "business" => $business));
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function paso1Action(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $usuario = new administrador();
        $host = $request->getHost();
        $protocol = $request->getScheme();
        $url = $protocol . "://" . $host;
        
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        $style = NULL;
        if ($business){
            $style = $business->getStyle();
            if($style){
                $form = $this->createForm(usuarioType::class, 
                        $usuario, 
                        array("attr" => array("disabled" => false, 'paso1'=>true)));
                if($request->getMethod() == 'POST' && $request->request->get("recaptcha_response")){
                    $recaptcha_url = 'https://www.google.com/recaptcha/api/siteverify';
                    $recaptcha_secret = '6LdGP80ZAAAAAJlemU1voSZ6dFiAi8-ywjrLePEd';
                    $recaptcha_response = $request->request->get("recaptcha_response");

                    // Make and decode POST request:
                    $recaptcha = file_get_contents($recaptcha_url . '?secret=' . $recaptcha_secret . '&response=' . $recaptcha_response);
                    $recaptchadecode = json_decode($recaptcha);
                    // Take action based on the score returned:
                    if ($recaptchadecode->score >= 0.5) {
                        $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) {
                            if(filter_var($usuario->getEmail(), FILTER_VALIDATE_EMAIL)) {
                                $existe = $em->getRepository('UsuarioBundle:administrador')
                                        ->findOneBy(array('email'=>$usuario->getEmail()));
                                if ($usuario->getEmail() != NULL && $existe == NULL){
                                    if ($business->getMesestest() != NULL){
                                        $date = new \DateTime();
                                        $date->add(new \DateInterval('P' . $business->getMesestest() . 'M'));
                                        $usuario->setFechaexpiracion($date);
                                    }
                                    $usuario->setBusiness($business);
                                    $usuario->setNombre("");
                                    $usuario->setSalt(md5(time()));
                                    $usuario->setActivo(0);
                                    $encoder = $this->get('security.encoder_factory')->getEncoder($usuario);
                                    $passwordCodificado = $encoder->encodePassword(md5(time()), $usuario->getSalt());
                                    $usuario->setPassword($passwordCodificado);
                                    $codigoverificcion = md5(microtime());
                                    $existe = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigoverificacion'=>$codigoverificcion));
                                    while($existe){
                                        $codigoverificcion = md5(microtime());
                                        $existe = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigoverificacion'=>$codigoverificcion));
                                    }
                                    $usuario->setCodigoverificacion($codigoverificcion);
                                    $em->persist($usuario);
                                    $em->flush();

                                    $enl = $this->generateUrl("registro_verificacion", 
                                            array("md5" => $usuario->getCodigoverificacion()));
                                    $enlace = $url . $enl;

                                    $body = $this->renderView("PublicBundle:mail:activarregistro.html.twig", 
                                            array("enlace" => $enlace, 
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url));

                                    $kernel = $this->get('kernel');
                                    $devMode = $kernel->isDebug();
                                    if ($devMode == FALSE){
                                        $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                                ->setUsername($business->getEmail())
                                                ->setPassword($business->desencryptarPassword());

                                        $titulopersonal = $business->getMensajeregistro();
                                        $mailer = \Swift_Mailer::newInstance($transport);
                                        $message = \Swift_Message::newInstance($titulopersonal)
                                                    ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                                    ->setTo($usuario->getEmail())
                                                    ->setBody($body, 'text/html');
                                        $mailer->send($message);
                                    }else{
                                        return $this->render("PublicBundle:mail:activarregistro.html.twig", 
                                            array("enlace" => $enlace, 
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url));
                                    }
                                    return $this->render('RegistroBundle:registro:registroverificacion.html.twig',
                                        array('email'=> $usuario->getEmail(), 
                                            "style" => $style,
                                            "business" => $business));
                                }
                            }
                        }
                    } else {
                        
                    }
                }    
                $url = $request->getUri();
                return $this->render('RegistroBundle:registro:registropaso1.html.twig', 
                        array('form'=>$form->createView(), 'usuario'=>$usuario, 
                            "style" => $style, "business" => $business, "url" => $url));
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function verifyAction($md5){
         if($md5){
             $em = $this->getDoctrine()->getManager();
             $usuario = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigoverificacion'=>$md5));
             if($usuario){
                 $em->persist($usuario);
                 $em->flush();
                 return $this->redirectToRoute('registro_paso3',array('md5'=>$md5));
             }
         }
         return $this->redirectToRoute('login');
    }
    
    public function paso3Action($md5,Request $request){
        if($md5){
            $host = $request->getHost();
            $em = $this->getDoctrine()->getManager();
            $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
            $style = NULL;
            if ($business){
                $style = $business->getStyle();
                $usuario = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigoverificacion'=>$md5));
                if($usuario){
                    $form = $this->createForm(usuarioType::class, $usuario,
                            array("attr" => array("disabled" => false,'paso3'=>true,'password'=>true)));
                    if($request->getMethod() == 'POST'){
                       $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) { 
                            $usuario->setSalt(md5(time()));
                            $encoder = $this->get('security.encoder_factory')->getEncoder($usuario);
                            $pass = $usuario->getPassword();
                            $passwordCodificado = $encoder->encodePassword($usuario->getPassword(), $usuario->getSalt());
                            //$usuario->setNombre($form["nombre"]->getData());
                            $usuario->setPassword($passwordCodificado);

                            $token64 = Cipher::crypt($pass); //guardar en base64 a menos que se declara variable como binary en bd
                            $usuario->setPasscifrada($token64);
                            $em->persist($usuario);
                            $em->flush();

                            return $this->redirectToRoute('registro_paso4',array('md5'=>$md5));
                         }
                    }
                    $url = $request->getUri();
                    return $this->render('RegistroBundle:registro:registropaso3.html.twig',
                        array("form" => $form->createView(), "md5" => $md5, 
                            "style" => $style, 
                            "business" => $business,
                            "url" => $url
                            ));

                }
            }
        }     
        return $this->redirectToRoute('login');
    } 
    
     
    
    public function paso4Action($md5,Request $request){
        if($md5){
            $em = $this->getDoctrine()->getManager();
            $usuario = $em->getRepository('UsuarioBundle:administrador')->findOneBy(array('codigoverificacion'=>$md5));
            if($usuario){
                $host = $request->getHost();
                $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
                if($business){
                    $style = $business->getStyle();
                    $idcategoria = null;
                    $form = $this->createForm(usuarioType::class,$usuario,array("attr" => array("disabled" => false,'paso4'=>true)));
                    if($request->getMethod() == 'POST'){
                       $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) { 
                            $em->persist($usuario);
                            $em->flush();
                            return $this->redirectToRoute('registro_paso5',array('md5'=>$md5));
                         }
                    }
                    return $this->render('RegistroBundle:registro:registropaso4.html.twig',
                        array("form" => $form->createView(), "md5" => $md5,'idcategory' => $idcategoria,
                            "style" => $style, "business" => $business
                            ));
                }
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function paso5Action($md5,Request $request){
        if($md5){
            $em = $this->getDoctrine()->getManager();
            $usuario = $em->getRepository('UsuarioBundle:administrador')
                    ->findOneBy(array('codigoverificacion'=>$md5));
            $host = $request->getHost();
            
            $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
            if($usuario && $business){
                $style = $business->getStyle();
                $planes = $em->getRepository('AdministracionBundle:plan')
                        ->findPlanes($business->getId());
                if($request->getMethod() == 'POST'){
                    $idplan = $request->request->get("idplan");
                    if ($idplan > 0){
                        $plan = $em->getRepository('AdministracionBundle:plan')->find($idplan);
                        if ($plan != NULL && $business->getId() == $plan->getBusiness()->getId()){
                            $usuario->setPlanseleccionado($plan);
                            $usuario->setCondominio($plan->getCondominio());
                            $usuario->setNumeromaximoemails($plan->getNumeromaximoemails());
                            $usuario->setCrmeactivo($plan->getCrmeactivo());
                            $usuario->setTiendaactiva($plan->getTiendaactiva());
                            $usuario->setTextoservicio($plan->getTextoservicio());
                            $usuario->setStandardcreatuaplicacion($plan->getStandardcreatuaplicacion());
                            $em->persist($usuario);
                            $em->flush();
                            return $this->redirectToRoute("registro_paso6", array("md5" => $md5));
                        }
                    }
                }
                return $this->render('RegistroBundle:registro:registropaso5.html.twig',
                    array("md5" => $md5, 
                        "style" => $style, 
                        "business" => $business,
                        "planes" => $planes
                        ));
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function paso6Action($md5,Request $request){
        if($md5){
            $em = $this->getDoctrine()->getManager();
            $usuario = $em->getRepository('UsuarioBundle:administrador')
                    ->findOneBy(array('codigoverificacion'=>$md5));
            $host = $request->getHost();
            $protocol = $request->getScheme();
            $url = $protocol . "://" . $host;
            $errormessage = "";
            $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
            if($usuario && $business){
                $plan = $usuario->getPlanseleccionado();
                $app = false;
                if ($plan != NULL & $plan->getStandardcreatuaplicacion()){
                    $app = true;
                }
                $style = $business->getStyle();
                $form = $this->createForm(usuarioType::class, $usuario,
                                array("attr" => array("disabled" => false,
                                        'paso5'=>true,
                                        "app" =>$app,
                                        'idbusiness'=>$business->getId())));
                if($request->getMethod() == 'POST'){
                   $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) { 
                        $briefing = $em->getRepository("WebBundle:briefing")->findOneBy(array("administrador" => $usuario->getId()));
                        $nombreempresa = $request->request->get('nombreempresa');
                        if ($briefing == NULL){
                            $briefing = new briefing();
                            $briefing->setAdministrador($usuario);
                            $usuario->setBriefing($briefing);
                            $em->persist($usuario);
                        }
                        $briefing->setNombre($nombreempresa);
                        $briefing->setCategory($usuario->getCategory());
                        $briefing->setSubcategory($usuario->getSubcategory());
                        $em->persist($briefing);
                        $em->flush();
                        // Se comrpueba si existe su imagen
                        $fs = new Filesystem();
                        $ruta = $briefing->getDir();
                        try {
                            $fs->mkdir($ruta, 0755);
                        } catch (IOExceptionInterface $e) {

                        }
                        foreach ($_FILES as $n => $key) {
                            if($key['error'] == UPLOAD_ERR_OK ){                        
                                $name = $key['name'];
                                $ext = pathinfo($name, PATHINFO_EXTENSION);
                                mt_srand (time());
                                $nombretemporal =  $usuario->getId() ;
                                $rand = rand(1, 1000);
                                if ($n == "logo"){
                                    $nombretemporal = $nombretemporal . "-" . $rand . "-logo";
                                }else if ($n == "banner"){
                                    $nombretemporal = $nombretemporal . "-" . $rand . "-banner";
                                }
                                $namefinal = $nombretemporal . "." . $ext;
                                $temporal = $key['tmp_name']; //Obtenemos el nombre del archivo temporal
                                if ($key['type'] == 'image/png' || 
                                    $key['type'] == 'image/jpg' || 
                                    $key['type'] == 'image/jpeg'){
                                    move_uploaded_file($temporal, $ruta . $namefinal);
                                    if ($n == "logo"){
                                        $briefing->removeUploadpathlogo();
                                        $briefing->setPathlogo($namefinal);
                                    }else if ($n == "banner"){
                                        $briefing->removeUploadpathbanner();
                                        $briefing->setPathbanner($namefinal);
                                    }
                                }
                            }else{
                                // $key['error']; //Si no se cargo mostramos el error
                            }
                        }
                        $em->persist($briefing);
                        $usuario->setPlanactivo(0);
                        $usuario->setActivo(1);
                        $em->persist($usuario);
                        $em->flush();
                        
                        $kernel = $this->get('kernel');
                        $isdebug = $kernel->isDebug();
                        $passopen = Cipher::decrypt($usuario->getPasscifrada());
                        $post = ['passopen' => $passopen,
                                 "usuario" => $usuario->getEmail() . ""];
                        $myjson = json_encode($post);
                        $jsonencrypt = Cipher::crypt($myjson);
                        $errorcode = 0;
                        list($pathbanner, $pathlogo, $briefing) = $this->getPath($em, $briefing);
                        if ($isdebug == false){
                            list($usuario, $errorcode, $errortext) = Domainutils::crearsubdominioenweb($em, $usuario, $isdebug);
                            Domainutils::editarinformacion($em, $usuario, $briefing, $pathbanner, $pathlogo, $isdebug, $protocol);
                        }
                        
                        if ($plan != NULL && $plan->getStandardcreatuaplicacion()){
                            list($errorcode, $errormessage, $return) = Domainutils::crearaplicacion($usuario, $pathbanner, $pathlogo, $protocol);
                            if ($errorcode == 0){
                                $idapp = $return["idapp"];
                                $usuarioapp = $return["usuarioapp"];
                                $usuario->setIdapp($idapp);
                                $usuario->setAplicacioncreada(TRUE);
                                $usuario->setAplicacionactiva(TRUE);
                                $usuario->setUsuarioapp($usuarioapp);
                                $em->persist($usuario);
                                $em->flush();
                            }
                        }
                        if ($errorcode == 0 ){
                            $kernel = $this->get('kernel');
                            $devMode = $kernel->isDebug();
                            if ($devMode == FALSE){
                                $transport =  \Swift_SmtpTransport::newInstance($business->getSmtphost(), $business->getSmtpport(),$business->getSmtpsecurity())
                                        ->setUsername($business->getEmail())
                                        ->setPassword($business->desencryptarPassword());
                                $body = $this->renderView("PublicBundle:mail:nuevoregistro.html.twig", 
                                            array("business" => $business, 
                                                    "style" => $style,
                                                    "url" => $url,
                                                    "usuario" => $usuario));
                                $titulopersonal = "Nuevo registro en " . $business;
                                $mailer = \Swift_Mailer::newInstance($transport);
                                $message = \Swift_Message::newInstance($titulopersonal)
                                            ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                            ->setTo($business->getEmail())
                                            ->setBody($body, 'text/html');
                                $mailer->send($message);
                                
                                if ($business->getFolderemail() != NULL 
                                        && filter_var($usuario->getEmail(), FILTER_VALIDATE_EMAIL) ){
                                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/1bienvenida.html.twig";
                                    
                                    $body = $this->renderView($template, array(
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url,
                                                "usuario" => $usuario));
                                    $mailer = \Swift_Mailer::newInstance($transport);
                                    $message = \Swift_Message::newInstance(strip_tags($business->getAsuntobienvenida()))
                                                ->setFrom(array($business->getEmail() => "no-reply " . $business->getNombre()))
                                                ->setTo($usuario->getEmail())
                                                ->setBody($body, 'text/html');
                                    $mailer->send($message);
                                    
                                    $usuario->setFechabienvenida(new \DateTime());
                                    $em->persist($usuario);
                                    $em->flush();
                                }
                            }else{
                                if ($business->getFolderemail() != NULL){
                                    $template = "PublicBundle:mail:" . $business->getFolderemail() ."/1bienvenida.html.twig";
                                    
                                    return $this->render($template, array(
                                                "business" => $business, 
                                                "style" => $style,
                                                "url" => $url,
                                                "usuario" => $usuario));
                                }
                            }
                            return $this->redirectToRoute('autologin', array('code'=>urlencode($jsonencrypt)));
                        }
                     }
                }
                return $this->render('RegistroBundle:registro:registropaso6.html.twig',
                    array("form" => $form->createView(), 
                        "md5" => $md5, 
                        "style" => $style, 
                        "business" => $business,
                        "plan" => $plan,
                        "errormessage" => $errormessage
                        ));
                
            }
        }
        return $this->redirectToRoute('login');
    }
    
    public function getPath($em, $briefing){
        $pathbanner = "";
        $pathlogo = "";
        
        if ($briefing->getCodigotemporal() == NULL){
            $briefing->setCodigotemporal(md5(time()));
            $em->persist($briefing);
            $em->flush();
        }
        
        if ($briefing->getPathbanner()){
            $pathbanner = $this->generateUrl("public_imagen_exterior", 
                    array("idbriefing" => $briefing->getId(),
                        "tipo" => 2,
                        "name" => $briefing->getPathbanner(),
                        "codigo" => $briefing->getCodigotemporal()));
        }
        if ($briefing->getPathlogo()){
            $pathlogo = $this->generateUrl("public_imagen_exterior", 
                    array("idbriefing" => $briefing->getId(),
                        "tipo" => 1,
                        "name" => $briefing->getPathlogo(),
                        "codigo" => $briefing->getCodigotemporal()));
        }
        return array($pathbanner, $pathlogo, $briefing);
    }
    
    public function autologinAction(Request $request, $code)
    {
        $host = $request->getHost();
        $em = $this->getDoctrine()->getManager();
        
        if ($code == NULL){
            $code = $request->query->get("code");
        }
        
        $jsonencrypt = urldecode($code);
        
        $jsondecrypt = Cipher::decrypt($jsonencrypt);
        $arrayjson = json_decode($jsondecrypt,true);
        $email = $arrayjson["usuario"];
        $pass = $arrayjson["passopen"];
        $authenticationUtils = $this->get('security.authentication_utils'); 
        // get the login error if there is one 
        $error = $authenticationUtils->getLastAuthenticationError(); 
        // last username entered by the user 
        $lastUsername = $authenticationUtils->getLastUsername();
        
        return $this->render('LoginBundle:login:autologin.html.twig', 
                array(  "email" => $email,
                        "pass" => $pass, 
                        'last_username' => $lastUsername, 
                        'error' => $error));
    }
    
    public function informacionnegocioAction(Request $request){
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            $em = $this->getDoctrine()->getManager();
            $briefing = $em->getRepository("WebBundle:briefing")->findOneBy(array("administrador" => $usuario->getId()));
            if ($briefing == NULL){
                $briefing = new briefing();
                $briefing->setAdministrador($usuario);
                $usuario->setBriefing($briefing);
            }
            $idcategory = -1;
            $listadosubcategoria = NULL;
            if ($briefing->getCategory()){
                $idcategory = $briefing->getCategory()->getId();
                $listadosubcategoria = $em->getRepository('CoreBundle:subcategory')->findBy(array('category'=>$briefing->getCategory(),'deleted'=>0));
            }
            
            $form = $this->createForm(briefingInformacionType::class, $briefing, 
                    array("attr" => array("disabled" => false, 
                          "idcategory" => $idcategory,
                          "tiendaactiva" => $usuario->getTiendaactiva() )));
            if ($request->getMethod() == "POST"){
                $form->handleRequest($request);
                
                if ($form->isSubmitted() && $form->isValid()) {
                    $idsubcategory = $request->request->get('subcategory');
                    $subcategoria = $em->getRepository('CoreBundle:subcategory')->find($idsubcategory);
                    if($subcategoria){
                        $briefing->setSubcategory($subcategoria);
                    }
                    $em->persist($briefing);
                    $em->persist($usuario);
                    $em->flush();
                    // Se comrpueba si existe su imagen
                    $fs = new Filesystem();
                    $ruta = $briefing->getDir();
                    try {
                        $fs->mkdir($ruta, 0755);
                    } catch (IOExceptionInterface $e) {

                    }
                    foreach ($_FILES as $n => $key) {
                        if($key['error'] == UPLOAD_ERR_OK ){                        
                            $name = $key['name'];
                            $ext = pathinfo($name, PATHINFO_EXTENSION);
                            mt_srand (time());
                            $nombretemporal =  $usuario->getId() ;
                            $rand = rand(1, 1000);
                            if ($n == "logo"){
                                $nombretemporal = $nombretemporal . "-" . $rand . "-logo";
                            }else if ($n == "banner"){
                                $nombretemporal = $nombretemporal . "-" . $rand . "-banner";
                            }
                            $namefinal = $nombretemporal . "." . $ext;
                            $temporal = $key['tmp_name']; //Obtenemos el nombre del archivo temporal
                            if ($key['type'] == 'image/png' || 
                                $key['type'] == 'image/jpg' || 
                                $key['type'] == 'image/jpeg'){
                                move_uploaded_file($temporal, $ruta . $namefinal);
                                if ($n == "logo"){
                                    $briefing->removeUploadpathlogo();
                                    $briefing->setPathlogo($namefinal);
                                }else if ($n == "banner"){
                                    $briefing->removeUploadpathbanner();
                                    $briefing->setPathbanner($namefinal);
                                }
                            }
                        }else{
                            // $key['error']; //Si no se cargo mostramos el error
                        }
                    }
                    $briefing->setEditado(TRUE);
                    $em->persist($briefing);
                    $em->persist($usuario);
                    $em->flush();
                    
                    $kernel = $this->get('kernel');
                    $isdebug = $kernel->isDebug();
                    if ($isdebug == false){
                        list($usuario, $errorcode, $errortext) = Domainutils::crearsubdominioenweb($em, $usuario, $isdebug);
                        list($pathbanner, $pathlogo, $briefing) = $this->getPath($em, $briefing);
                        Domainutils::editarinformacion($em, $usuario, $briefing, $pathbanner, $pathlogo, $isdebug);
                    }
                    
                    return $this->redirectToRoute('public_panel-index-user');
                }
            }
            $style = NULL;
            if($usuario->getBusiness() && $usuario->getBusiness()->getStyle()){
                $style = $usuario->getBusiness()->getStyle();
            }
            return $this->render('WebBundle:Public:informacionnegocio.html.twig', 
                    array("usuario" => $usuario, 
                        "form" => $form->createView(), 
                        "briefing" => $briefing,
                        'listadosubcategoria'=>$listadosubcategoria,
                        "style" => $style));
        }
        return $this->redirectToRoute('login');
    }
}
