<?php

namespace StyleBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Doctrine\ORM\Tools\Pagination\Paginator;
use StyleBundle\Entity\style;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Filesystem\Filesystem;
use StyleBundle\Form\styleType;
use Symfony\Component\HttpFoundation\Response;
use lessc;

class StyleController extends Controller
{
    public function indexAction(Request $request, $page)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            if ($page == NULL){
                $page = 1;
            }

            $em = $this->getDoctrine()->getManager();
            $styleQuery = $em->getRepository('StyleBundle:style')->findAllQuery();

            $pageSize = 20;
            $styles = $this->getPaginate($pageSize, $page, $styleQuery);
            $totalItems = count($styles);
            $pagescount = ceil($totalItems / $pageSize);
            return $this->render('StyleBundle:Style:stylelist.html.twig' ,
                                array(  "styles" => $styles,
                                        "totalItems" => $totalItems,
                                        "pagesCount" => $pagescount,
                                        "currentpage" => $page,
                                    )
                                );
        }
        return $this->redirectToRoute('login');
    }
    
    public function getPaginate($pageSize, $currentPage, $queryBuilder){
        if ($currentPage > 0){
            $queryBuilder->setFirstResult($pageSize * ($currentPage - 1))->setMaxResults($pageSize);
        }
        $paginator = new Paginator($queryBuilder, $fetchJoinCollection = true);
        return $paginator;
    }
    
    public function editAction(Request $request, $id)
    {
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $editar = true;
            if($id == NULL){
                $style = new style();
                $editar = false;
            }else{
                $style = $em->getRepository('StyleBundle:style')->find($id);
                if($style == NULL){
                    $style = new style();
                    $editar = false; 
                }
            }
            $form = $this->createForm(styleType::class, $style, 
                            array("attr" => array("disabled" => FALSE)));
            if($request->getMethod() == 'POST'){
                 $form->handleRequest($request);
                    if ($form->isSubmitted() && $form->isValid()) {
                        $fondomenu = $request->request->get('fondomenu');
                        $colortopmenu = $request->request->get('colortopmenu');
                        $colorlateralmenu = $request->request->get('colorlateralmenu');
                        $colorletrasmenu = $request->request->get('colorletrasmenu');
                        $colorletrasmenulateral = $request->request->get('colorletrasmenulateral');
                        $colorseparadoresmenu = $request->request->get('colorseparadoresmenu');
                        $colorcabeceramodal = $request->request->get('colorcabeceramodal');
                        $colortabfondo = $request->request->get('colortabfondo');
                        $colorbotonfondo = $request->request->get('colorbotonfondo');
                        $colorbotonletra = $request->request->get('colorbotonletra');
                        $colorfondopublic = $request->request->get('colorfondopublic');
                        $colorbotonpublic = $request->request->get('colorbotonpublic');
                        $colorletraspublic = $request->request->get('colorletraspublic');
                        $colorcabeceramodalpublic = $request->request->get('colorcabeceramodalpublic'); 
                        $pathlogin = $request->request->get('pathlogin');
                        $colorbotonpreviaedita = $request->request->get('colorbotonpreviaedita');
                        $colorbotonpublicacontinua = $request->request->get('colorbotonpublicacontinua');
                        $colorbotonarchivopublic = $request->request->get('colorbotonarchivo');
                        $colortextoavisopublic = $request->request->get('colortextoaviso');
                        $colorinputpublic = $request->request->get('colorinputpublic');
                        $colorfondoinputpublic = $request->request->get('colorfondoinputpublic');
                        $style->setColortextoavisopublic("#" . $colortextoavisopublic);
                        $style->setColorbotonarchivopublic("#" . $colorbotonarchivopublic);
                        $style->setColorbotonpublicacontinua("#" . $colorbotonpublicacontinua);
                        $style->setColorbotonpreviaedita("#" . $colorbotonpreviaedita);
                        $style->setColorlateralmenu("#" . $colorlateralmenu);
                        $style->setColortopmenu("#" . $colortopmenu);
                        $style->setColorbotonpublic("#" . $colorbotonpublic);
                        $style->setColorcabeceramodalpublic("#" . $colorcabeceramodalpublic);
                        $style->setColorfondopublic("#" . $colorfondopublic);
                        $style->setColorletraspublic("#" . $colorletraspublic);
                        $style->setFondomenu("#" . $fondomenu);
                        $style->setColorbotonfondo("#" . $colorbotonfondo);
                        $style->setColorbotonletra("#" . $colorbotonletra);
                        $style->setColorcabeceramodal("#" . $colorcabeceramodal);
                        $style->setColorletramenu("#" . $colorletrasmenu);
                        $style->setColorletramenulateral("#" . $colorletrasmenulateral);
                        $style->setColorseparadoresmenu("#" . $colorseparadoresmenu);
                        $style->setColortabfondo("#" . $colortabfondo);
                        $style->setColorinputpublic("#" . $colorinputpublic);
                        $style->setColorfondoinputpublic("#" . $colorfondoinputpublic);
                        $em->persist($style);
                        $em->flush();
                        
                        
                        
                        $fs = new Filesystem();
                        $dirlogo = $style->getDirlogo();
                        try {
                            $fs->mkdir($dirlogo, 0755);
                        } catch (IOExceptionInterface $e) {
                            echo "An error occurred while creating your directory at ".$e->getPath();
                        }
                        
                        if($_FILES['pathimagen']['error'] == UPLOAD_ERR_OK){
                            $name = $_FILES['pathimagen']['name'];
                            $ext = pathinfo($_FILES['pathimagen']['name'], PATHINFO_EXTENSION);
                            $name = "pathimagen-" . $style->getId() . "-" . rand(1, 100) . "." . $ext;

                            $temporal = $_FILES['pathimagen']['tmp_name']; //Obtenemos el nombre del archivo temporal
                            if ($_FILES['pathimagen']['type'] == 'image/png' || 
                                    $_FILES['pathimagen']['type'] == 'image/jpg' || 
                                    $_FILES['pathimagen']['type'] == 'image/jpeg'){
                                //move_uploaded_file($temporal, $dir . $name); //Movemos el archivo temporal a la ruta especificada
                                move_uploaded_file($temporal, $dirlogo . $name); 
                                $style->removeUpload();
                                $style->setPathimagen($name);
                                /*$tamano = getimagesize($dir. $name);
                                if (count($tamano) > 0){
                                    $style->setWidth($tamano[0]);
                                    $style->setHeight($tamano[1]);
                                }*/
                            }
                        }
                        
                        $fs = new Filesystem();
                        $dirlogin = $style->getDirlogin();
                        try {
                            $fs->mkdir($dirlogin, 0755);
                        } catch (IOExceptionInterface $e) {
                            echo "An error occurred while creating your directory at ".$e->getPath();
                        }
                
                        if($_FILES['pathlogin']['error'] == UPLOAD_ERR_OK){
                            $name = $_FILES['pathlogin']['name'];
                            $ext = pathinfo($_FILES['pathlogin']['name'], PATHINFO_EXTENSION);
                            $name = "pathlogin-" . $style->getId() . "-" . rand(1, 100) . "." . $ext;

                            $temporal = $_FILES['pathlogin']['tmp_name']; //Obtenemos el nombre del archivo temporal
                            if ($_FILES['pathlogin']['type'] == 'image/png' || 
                                    $_FILES['pathlogin']['type'] == 'image/jpg' || 
                                    $_FILES['pathlogin']['type'] == 'image/jpeg'){
                                move_uploaded_file($temporal, $dirlogin . $name); //Movemos el archivo temporal a la ruta especificada
                                $style->removeUploadlogin();
                                $style->setPathlogin($name);
                                
                            }
                        }
                        $em->persist($style);
                        $em->flush();
                        return $this->redirectToRoute('style_index');

                    }
            }
            return $this->render('StyleBundle:Style:styleedit.html.twig',array('form'=>$form->createView(),'style'=>$style
                                ));
        }
        return $this->redirectToRoute('login');
    }
    
    public function deleteAction($id){
        if(($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true)){
            $em = $this->getDoctrine()->getManager();
            $style = $em->getRepository('StyleBundle:style')->find($id);
            if($style){
                $style->setEliminado(1);
                $em->persist($style);
                $em->flush();
            }
        
            return $this->redirectToRoute('style_index');
        }
        return $this->redirectToRoute('login');    
    }
    
    public function getimageAction($id){
        $em = $this->getDoctrine()->getManager();
        $style = $em->getRepository('StyleBundle:style')->find($id);
        if ($style != NULL && $style->getPathimagen() != NULL){
            $ruta= $style->getDir() . $style->getPathimagen();
            if (file_exists($ruta)){
                $headers = array('Content-Type' => "image/png",
                    'Content-Disposition' => 'inline; '
                    . 'filename="'.$ruta.'"');

                $file =  readfile($ruta);
                return new Response($file, 200, $headers); 
            }
        }
        $response = new Response(json_encode(array()));
        return $response;
    }
    
    public function baseAction(Request $request){
        $host = $request->getHost();
        $em = $this->getDoctrine()->getManager(); 
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        $style = NULL;
        if ($business){
            $style = $business->getStyle();
        }
        $less = new lessc;
        $lessString = "";
        $usuario = false;
        if ($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            $usuario = true;
            $ruta = "../src/CoreBundle/Resources/public/css/backend.css";
        }elseif ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true) {
            $usuario = true;
            $ruta = "../src/CoreBundle/Resources/public/css/backendusuario.css";
        }else{
            $ruta = "../src/CoreBundle/Resources/public/css/login.css";
        } 
        if ($style){
            if (file_exists($ruta) && $style){
                $lessString = file_get_contents($ruta);
                // reemplazar en string {{fondomenu}}
                if($usuario){
                    $lessString = str_replace("{{fondomenu}}", $style->getFondomenu(), $lessString);
                    $lessString = str_replace("{{colorletramenu}}", $style->getColorletramenu(), $lessString);
                    $lessString = str_replace("{{colorletramenulateral}}", $style->getColorletramenulateral(), $lessString);
                    $lessString = str_replace("{{colorseparadoresmenu}}", $style->getColorseparadoresmenu(), $lessString);
                    $lessString = str_replace("{{colorcabeceramodal}}", $style->getColorcabeceramodal(), $lessString);
                    $lessString = str_replace("{{colortabfondo}}", $style->getColortabfondo(), $lessString);
                    $lessString = str_replace("{{colorbotonfondo}}", $style->getColorbotonfondo(), $lessString);
                    $lessString = str_replace("{{colorbotonletra}}", $style->getColorbotonletra(), $lessString);
                    $lessString = str_replace("{{colortopmenu}}", $style->getColortopmenu(), $lessString);
                    $lessString = str_replace("{{colorlateralmenu}}", $style->getColorlateralmenu(), $lessString);
                    $lessString = str_replace("{{colorbotonpreviaedita}}", $style->getColorbotonpreviaedita(), $lessString);
                    $lessString = str_replace("{{colorbotonpublicacontinua}}", $style->getColorbotonpublicacontinua(), $lessString);
                    $lessString = str_replace("{{pathimagenlogo}}", $style->getImagelogo(), $lessString);
                    $lessString = str_replace("{{colorfondopublic}}", $style->getColorfondopublic(), $lessString);
                    $lessString = str_replace("{{colorbotonpublic}}", $style->getColorbotonpublic(), $lessString);
                    $lessString = str_replace("{{colorletraspublic}}", $style->getColorletraspublic(), $lessString);
                    $lessString = str_replace("{{colorcabeceramodalpublic}}", $style->getColorcabeceramodalpublic(), $lessString);
                    $lessString = str_replace("{{pathimagenlogin}}", $style->getImagelogin(), $lessString);
                    $lessString = str_replace("{{colortextoavisopublic}}", $style->getColortextoavisopublic(), $lessString);
                    $lessString = str_replace("{{colorbotonarchivopublic}}", $style->getColorbotonarchivopublic(), $lessString);
                }else{
                    $lessString = str_replace("{{colorfondopublic}}", $style->getColorfondopublic(), $lessString);
                    $lessString = str_replace("{{colorbotonpublic}}", $style->getColorbotonpublic(), $lessString);
                    $lessString = str_replace("{{colorletraspublic}}", $style->getColorletraspublic(), $lessString);
                    $lessString = str_replace("{{colorcabeceramodalpublic}}", $style->getColorcabeceramodalpublic(), $lessString);
                    $lessString = str_replace("{{pathimagenlogin}}", $style->getImagelogin(), $lessString);
                    $lessString = str_replace("{{colortextoavisopublic}}", $style->getColortextoavisopublic(), $lessString);
                    $lessString = str_replace("{{colorbotonarchivopublic}}", $style->getColorbotonarchivopublic(), $lessString);
                    $lessString = str_replace("{{colorinputpublic}}", $style->getColorinputpublic(), $lessString);
                    $lessString = str_replace("{{colorfondoinputpublic}}", $style->getColorfondoinputpublic(), $lessString);

                }    
                $lessString = str_replace("{{pathimagenlogo}}", $style->getImagelogo(), $lessString);
                $lessString = str_replace("{{namefont}}", $business->getNamefont(), $lessString);
            } 
        }
        
        // Use the compile method to convert less to css
        $css = $less->compile($lessString);
        $response = new Response();
        $response->setContent($css);
        $response->setStatusCode(Response::HTTP_OK);
        $response->headers->set('Content-Type', 'text/css');
        return $response;
    }
    
    
}
