<?php

namespace UsuarioBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use CoreBundle\Entity\Cipher;

/**
 * administrador
 *
 * @ORM\Table(name="administrador")
 * @ORM\Entity(repositoryClass="UsuarioBundle\Repository\administradorRepository")
 */
class administrador extends usuario
{
    /**
     * @var 
     *
     * @ORM\ManyToOne(targetEntity="PagoBundle\Entity\business")
     */
    private $business;
    
    /**
     * @var subcategory
     *
     * @ORM\ManyToOne(targetEntity="CoreBundle\Entity\subcategory")
     */
    private $subcategory;
    
     /**
     * @var subcategory
     *
     * @ORM\ManyToOne(targetEntity="CoreBundle\Entity\category")
     */
    private $category;
    
    /**
     * @var string
     *
     * @ORM\Column(name="nombredeapp", type="string", length=255, nullable=true)
     */
    private $nombredeapp;
    
    /**
     * @var string
     *
     * @ORM\Column(name="usuarioapp", type="string", length=255, nullable=true)
     */
    private $usuarioapp;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="aplicacioncreada", type="boolean")
     */
    private $aplicacioncreada;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="aplicacionactiva", type="boolean")
     */
    private $aplicacionactiva;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="idapp", type="integer", nullable=true)
     */
    private $idapp;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="planactivo", type="boolean")
     */
    private $planactivo;
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="fechainformacion", type="datetime", nullable=true)
     */
    private $fechainformacion;
    
    /**
     * @var string
     *
     * @ORM\Column(name="passcifrada", type="string", length=255, nullable = true)
     */
    private $passcifrada;
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="fechaexpiracion", type="datetime")
     */
    private $fechaexpiracion;
    
    /**
     * @ORM\OneToOne(targetEntity="WebBundle\Entity\briefing")
     */
    protected $briefing;
    
    /**
     * @var Boolean
     *
     * @ORM\Column(name="publicada", type="boolean")
     */
    private $publicada;

    /**
     * @var string
     *
     * @ORM\Column(name="dominio", type="string", length=255, nullable=true)
     */
    private $dominio;

    /**
     * @var boolean
     *
     * @ORM\Column(name="dominiopropio", type="boolean")
     */
    private $dominiopropio;

    /**
     * @var string
     *
     * @ORM\Column(name="subdominio", type="string", length=255, nullable=true)
     */
    private $subdominio;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="fechasolicituddominio", type="datetime", nullable=true)
     */
    private $fechasolicituddominio;
    
    /**
     * @var bool
     *
     * @ORM\Column(name="dominioaceptado", type="boolean")
     */
    private $dominioaceptado;

    /**
     * @var bool
     *
     * @ORM\Column(name="subdominiocreado", type="boolean")
     */
    private $subdominiocreado;

    /**
     * @var bool
     *
     * @ORM\Column(name="plancreado", type="boolean")
     */
    private $plancreado;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="fechaplan", type="datetime", nullable=true)
     */
    private $fechaplan;
    
    /**
     * @var client
     *
     * @ORM\ManyToOne(targetEntity="AdministracionBundle\Entity\plan")
     */
    private $planseleccionado; 
    
    /**
     * @var eventostripe
     *
     * @ORM\ManyToOne(targetEntity="PagoBundle\Entity\eventostripe")
     */
    private $eventostripe; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="condominio", type="boolean")
     */
    private $condominio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="tiendaactiva", type="boolean")
     */
    private $tiendaactiva; 
    
    /**
     * @var integer
     *
     * @ORM\Column(name="numeromaximoemails", type="integer")
     */
    private $numeromaximoemails; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="crmeactivo", type="boolean")
     */
    private $crmeactivo;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cifnif", type="string", length=255, nullable=true)
     */
    private $cifnif;
    
    /**
     * @var string
     *
     * @ORM\Column(name="nombrefiscal", type="string", length=255, nullable=true)
     */
    private $nombrefiscal;
    
    /**
     * @var string
     *
     * @ORM\Column(name="direccionfiscal", type="string", length=255, nullable=true)
     */
    private $direccionfiscal;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cpfiscal", type="string", length=255, nullable=true)
     */
    private $cpfiscal;
    
    /**
     * @var string
     *
     * @ORM\Column(name="poblacionfiscal", type="string", length=255, nullable=true)
     */
    private $poblacionfiscal;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="textoservicio", type="string", nullable=true, length=255)
     */
    private $textoservicio; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="standardcreatuaplicacion", type="boolean")
     */
    private $standardcreatuaplicacion; 

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="fechabienvenida", type="datetime", nullable=true)
     */
    private $fechabienvenida;
    
    /**
     * @var bool
     *
     * @ORM\Column(name="recordatorio1", type="boolean")
     */
    private $recordatorio1;

    /**
     * @var bool
     *
     * @ORM\Column(name="recordatorio2", type="boolean")
     */
    private $recordatorio2;

    /**
     * @var bool
     *
     * @ORM\Column(name="recordatorio3", type="boolean")
     */
    private $recordatorio3;

    /**
     * @var bool
     *
     * @ORM\Column(name="recordatorioexpirado", type="boolean")
     */
    private $recordatorioexpirado;

    /**
     * @var bool
     *
     * @ORM\Column(name="comprarealizada", type="boolean")
     */
    private $comprarealizada;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="fechaenviocompra", type="datetime", nullable=true)
     */
    private $fechaenviocompra;
    
    public function desencriptarpassword(){
        if ($this->getPasscifrada() != NULL){
            return Cipher::decrypt($this->getPasscifrada());
        }else{
            return "";
        }
    }
    
    public function __construct() {
        parent::__construct();
        $fecha = new \DateTime();
        $fecha->add(new \DateInterval('P15D'));
        $this->setFechaexpiracion($fecha);
        $this->planactivo = 0;
        $this->publicada = false;   
        $this->condominio = false;
        $this->tiendaactiva = false;
        $this->numeromaximoemails = 0;
        $this->dominioaceptado = false;
        $this->dominiopropio = false;
        $this->subdominiocreado = false;
        $this->plancreado = false;
        $this->setRole('ROLE_USER');
        $this->crmeactivo = FALSE;
        $this->aplicacioncreada = FALSE;
        $this->standardcreatuaplicacion = FALSE;
        $this->aplicacionactiva = FALSE;
        $this->recordatorio1 = false;
        $this->recordatorio2 = false;
        $this->recordatorio3 = false;
        $this->recordatorioexpirado = false;
        $this->comprarealizada = false;
    }
    
    public function getUrlredirect(){
        $planactivo = false;
        if ($this->getFechaplan() != NULL){
            $dateplan = $this->getFechaplan();
            $dateplan->modify('+ 1 day');
            $now = new \DateTime();
            if ($dateplan < $now){
                $planactivo = TRUE;
            }
        }
        if ($this->dominio != NULL 
                && $this->getDominioaceptado() 
                && $this->getPlancreado()
                && $planactivo){
            return $this->getDominio();
        }
        return $this->getSubdominio();
    }

    public function getURLGenerica(){
        if ($this->getDomain()){
            return "http://" . $this->getDominio();
        }else{
            return "http://" . $this->getSubdominio();
        }
    }
    public function getURLCreatuweb(){
        if ($this->getDomain()){
            return "https://tuweb." . $this->getDominio();
        }else{
            return "https://tuweb" . $this->getSubdominio();
        }
    }
    
    public function getPlanactivostr(){
        $str = "No";
        if($this->getPlanactivo()){
            $str = "Sí";
        }
        return $str;
    }
    public function getURLRegistro(){
        $url = null;
        if($this->business){
            $url = $this->getBusiness()->getUrlregistro();
        }
        return $url;
    }
    
    public function getTienepermiso(){
        $tienepermiso = FALSE;
        $now = new \DateTime();
        $now->setTime(0, 0, 0);
        if($this->getFechaexpiracion() > $now){
            $tienepermiso = TRUE;
        }
        return $tienepermiso;
    }
    
    /**
     * Set business
     *
     * @param \PagoBundle\Entity\business $business
     *
     * @return usuario
     */
    public function setBusiness(\PagoBundle\Entity\business $business = null)
    {
        $this->business = $business;

        return $this;
    }

    /**
     * Get business
     *
     * @return \PagoBundle\Entity\business
     */
    public function getBusiness()
    {
        return $this->business;
    }
    
    /**
     * Set subcategory
     *
     * @param \CoreBundle\Entity\subcategory $subcategory
     *
     * @return usuario
     */
    public function setSubcategory(\CoreBundle\Entity\subcategory $subcategory = null)
    {
        $this->subcategory = $subcategory;

        return $this;
    }

    /**
     * Get subcategory
     *
     * @return \CoreBundle\Entity\subcategory
     */
    public function getSubcategory()
    {
        return $this->subcategory;
    }

    /**
     * Set category
     *
     * @param \CoreBundle\Entity\category $category
     *
     * @return usuario
     */
    public function setCategory(\CoreBundle\Entity\category $category = null)
    {
        $this->category = $category;

        return $this;
    }

    /**
     * Get category
     *
     * @return \CoreBundle\Entity\category
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Set planactivo
     *
     * @param boolean $planactivo
     *
     * @return administrador
     */
    public function setPlanactivo($planactivo)
    {
        $this->planactivo = $planactivo;

        return $this;
    }

    /**
     * Get planactivo
     *
     * @return boolean
     */
    public function getPlanactivo()
    {
        return $this->planactivo;
    }

    /**
     * Set fechainformacion
     *
     * @param \DateTime $fechainformacion
     *
     * @return administrador
     */
    public function setFechainformacion($fechainformacion)
    {
        $this->fechainformacion = $fechainformacion;

        return $this;
    }

    /**
     * Get fechainformacion
     *
     * @return \DateTime
     */
    public function getFechainformacion()
    {
        return $this->fechainformacion;
    }

    /**
     * Set passcifrada
     *
     * @param string $passcifrada
     *
     * @return administrador
     */
    public function setPasscifrada($passcifrada)
    {
        $this->passcifrada = $passcifrada;

        return $this;
    }

    /**
     * Get passcifrada
     *
     * @return string
     */
    public function getPasscifrada()
    {
        return $this->passcifrada;
    }

    /**
     * Set fechaexpiracion
     *
     * @param \DateTime $fechaexpiracion
     *
     * @return administrador
     */
    public function setFechaexpiracion($fechaexpiracion)
    {
        $this->fechaexpiracion = $fechaexpiracion;

        return $this;
    }

    /**
     * Get fechaexpiracion
     *
     * @return \DateTime
     */
    public function getFechaexpiracion()
    {
        return $this->fechaexpiracion;
    }

    /**
     * Set publicada
     *
     * @param boolean $publicada
     *
     * @return administrador
     */
    public function setPublicada($publicada)
    {
        $this->publicada = $publicada;

        return $this;
    }

    /**
     * Get publicada
     *
     * @return boolean
     */
    public function getPublicada()
    {
        return $this->publicada;
    }

    /**
     * Set condominio
     *
     * @param boolean $condominio
     *
     * @return administrador
     */
    public function setCondominio($condominio)
    {
        $this->condominio = $condominio;

        return $this;
    }

    /**
     * Get condominio
     *
     * @return boolean
     */
    public function getCondominio()
    {
        return $this->condominio;
    }

    /**
     * Set tiendaactiva
     *
     * @param boolean $tiendaactiva
     *
     * @return administrador
     */
    public function setTiendaactiva($tiendaactiva)
    {
        $this->tiendaactiva = $tiendaactiva;

        return $this;
    }

    /**
     * Get tiendaactiva
     *
     * @return boolean
     */
    public function getTiendaactiva()
    {
        return $this->tiendaactiva;
    }

    /**
     * Set numeromaximoemails
     *
     * @param integer $numeromaximoemails
     *
     * @return administrador
     */
    public function setNumeromaximoemails($numeromaximoemails)
    {
        $this->numeromaximoemails = $numeromaximoemails;

        return $this;
    }

    /**
     * Get numeromaximoemails
     *
     * @return integer
     */
    public function getNumeromaximoemails()
    {
        return $this->numeromaximoemails;
    }

    /**
     * Set briefing
     *
     * @param \WebBundle\Entity\briefing $briefing
     *
     * @return administrador
     */
    public function setBriefing(\WebBundle\Entity\briefing $briefing = null)
    {
        $this->briefing = $briefing;

        return $this;
    }

    /**
     * Get briefing
     *
     * @return \WebBundle\Entity\briefing
     */
    public function getBriefing()
    {
        return $this->briefing;
    }

    /**
     * Set planseleccionado
     *
     * @param \AdministracionBundle\Entity\plan $planseleccionado
     *
     * @return administrador
     */
    public function setPlanseleccionado(\AdministracionBundle\Entity\plan $planseleccionado = null)
    {
        $this->planseleccionado = $planseleccionado;

        return $this;
    }

    /**
     * Get planseleccionado
     *
     * @return \AdministracionBundle\Entity\plan
     */
    public function getPlanseleccionado()
    {
        return $this->planseleccionado;
    }

    /**
     * Set dominio
     *
     * @param string $dominio
     *
     * @return administrador
     */
    public function setDominio($dominio)
    {
        $this->dominio = $dominio;

        return $this;
    }

    /**
     * Set dominiopropio
     *
     * @param boolean $dominiopropio
     *
     * @return administrador
     */
    public function setDominiopropio($dominiopropio)
    {
        $this->dominiopropio = $dominiopropio;

        return $this;
    }

    /**
     * Get dominiopropio
     *
     * @return boolean
     */
    public function getDominiopropio()
    {
        return $this->dominiopropio;
    }

    /**
     * Set fechasolicituddominio
     *
     * @param \DateTime $fechasolicituddominio
     *
     * @return administrador
     */
    public function setFechasolicituddominio($fechasolicituddominio)
    {
        $this->fechasolicituddominio = $fechasolicituddominio;

        return $this;
    }

    /**
     * Get fechasolicituddominio
     *
     * @return \DateTime
     */
    public function getFechasolicituddominio()
    {
        return $this->fechasolicituddominio;
    }

    /**
     * Set dominioaceptado
     *
     * @param boolean $dominioaceptado
     *
     * @return administrador
     */
    public function setDominioaceptado($dominioaceptado)
    {
        $this->dominioaceptado = $dominioaceptado;

        return $this;
    }

    /**
     * Get dominioaceptado
     *
     * @return boolean
     */
    public function getDominioaceptado()
    {
        return $this->dominioaceptado;
    }

    /**
     * Set subdominiocreado
     *
     * @param boolean $subdominiocreado
     *
     * @return administrador
     */
    public function setSubdominiocreado($subdominiocreado)
    {
        $this->subdominiocreado = $subdominiocreado;

        return $this;
    }

    /**
     * Get subdominiocreado
     *
     * @return boolean
     */
    public function getSubdominiocreado()
    {
        return $this->subdominiocreado;
    }

    /**
     * Set plancreado
     *
     * @param boolean $plancreado
     *
     * @return administrador
     */
    public function setPlancreado($plancreado)
    {
        $this->plancreado = $plancreado;

        return $this;
    }

    /**
     * Get plancreado
     *
     * @return boolean
     */
    public function getPlancreado()
    {
        return $this->plancreado;
    }

    /**
     * Set fechaplan
     *
     * @param \DateTime $fechaplan
     *
     * @return administrador
     */
    public function setFechaplan($fechaplan)
    {
        $this->fechaplan = $fechaplan;

        return $this;
    }

    /**
     * Get fechaplan
     *
     * @return \DateTime
     */
    public function getFechaplan()
    {
        return $this->fechaplan;
    }

    /**
     * Set subdominio
     *
     * @param string $subdominio
     *
     * @return administrador
     */
    public function setSubdominio($subdominio)
    {
        $this->subdominio = $subdominio;

        return $this;
    }

    /**
     * Get subdominio
     *
     * @return string
     */
    public function getSubdominio()
    {
        return $this->subdominio;
    }

    /**
     * Get dominio
     *
     * @return string
     */
    public function getDominio()
    {
        return $this->dominio;
    }

    /**
     * Set cifnif
     *
     * @param string $cifnif
     *
     * @return administrador
     */
    public function setCifnif($cifnif)
    {
        $this->cifnif = $cifnif;

        return $this;
    }

    /**
     * Get cifnif
     *
     * @return string
     */
    public function getCifnif()
    {
        return $this->cifnif;
    }

    /**
     * Set nombrefiscal
     *
     * @param string $nombrefiscal
     *
     * @return administrador
     */
    public function setNombrefiscal($nombrefiscal)
    {
        $this->nombrefiscal = $nombrefiscal;

        return $this;
    }

    /**
     * Get nombrefiscal
     *
     * @return string
     */
    public function getNombrefiscal()
    {
        return $this->nombrefiscal;
    }

    /**
     * Set direccionfiscal
     *
     * @param string $direccionfiscal
     *
     * @return administrador
     */
    public function setDireccionfiscal($direccionfiscal)
    {
        $this->direccionfiscal = $direccionfiscal;

        return $this;
    }

    /**
     * Get direccionfiscal
     *
     * @return string
     */
    public function getDireccionfiscal()
    {
        return $this->direccionfiscal;
    }

    /**
     * Set cpfiscal
     *
     * @param string $cpfiscal
     *
     * @return administrador
     */
    public function setCpfiscal($cpfiscal)
    {
        $this->cpfiscal = $cpfiscal;

        return $this;
    }

    /**
     * Get cpfiscal
     *
     * @return string
     */
    public function getCpfiscal()
    {
        return $this->cpfiscal;
    }

    /**
     * Set poblacionfiscal
     *
     * @param string $poblacionfiscal
     *
     * @return administrador
     */
    public function setPoblacionfiscal($poblacionfiscal)
    {
        $this->poblacionfiscal = $poblacionfiscal;

        return $this;
    }

    /**
     * Get poblacionfiscal
     *
     * @return string
     */
    public function getPoblacionfiscal()
    {
        return $this->poblacionfiscal;
    }

    /**
     * Set crmeactivo
     *
     * @param boolean $crmeactivo
     *
     * @return administrador
     */
    public function setCrmeactivo($crmeactivo)
    {
        $this->crmeactivo = $crmeactivo;

        return $this;
    }

    /**
     * Get crmeactivo
     *
     * @return boolean
     */
    public function getCrmeactivo()
    {
        return $this->crmeactivo;
    }

    /**
     * Set textoservicio
     *
     * @param string $textoservicio
     *
     * @return administrador
     */
    public function setTextoservicio($textoservicio)
    {
        $this->textoservicio = $textoservicio;

        return $this;
    }

    /**
     * Get textoservicio
     *
     * @return string
     */
    public function getTextoservicio()
    {
        return $this->textoservicio;
    }

    /**
     * Set eventostripe
     *
     * @param \PagoBundle\Entity\eventostripe $eventostripe
     *
     * @return administrador
     */
    public function setEventostripe(\PagoBundle\Entity\eventostripe $eventostripe = null)
    {
        $this->eventostripe = $eventostripe;

        return $this;
    }

    /**
     * Get eventostripe
     *
     * @return \PagoBundle\Entity\eventostripe
     */
    public function getEventostripe()
    {
        return $this->eventostripe;
    }

    /**
     * Set nombredeapp
     *
     * @param string $nombredeapp
     *
     * @return administrador
     */
    public function setNombredeapp($nombredeapp)
    {
        $this->nombredeapp = $nombredeapp;

        return $this;
    }

    /**
     * Get nombredeapp
     *
     * @return string
     */
    public function getNombredeapp()
    {
        return $this->nombredeapp;
    }

    /**
     * Set aplicacioncreada
     *
     * @param boolean $aplicacioncreada
     *
     * @return administrador
     */
    public function setAplicacioncreada($aplicacioncreada)
    {
        $this->aplicacioncreada = $aplicacioncreada;

        return $this;
    }

    /**
     * Get aplicacioncreada
     *
     * @return boolean
     */
    public function getAplicacioncreada()
    {
        return $this->aplicacioncreada;
    }

    /**
     * Set idapp
     *
     * @param integer $idapp
     *
     * @return administrador
     */
    public function setIdapp($idapp)
    {
        $this->idapp = $idapp;

        return $this;
    }

    /**
     * Get idapp
     *
     * @return integer
     */
    public function getIdapp()
    {
        return $this->idapp;
    }

    /**
     * Set usuarioapp
     *
     * @param string $usuarioapp
     *
     * @return administrador
     */
    public function setUsuarioapp($usuarioapp)
    {
        $this->usuarioapp = $usuarioapp;

        return $this;
    }

    /**
     * Get usuarioapp
     *
     * @return string
     */
    public function getUsuarioapp()
    {
        return $this->usuarioapp;
    }

    /**
     * Set standardcreatuaplicacion
     *
     * @param boolean $standardcreatuaplicacion
     *
     * @return administrador
     */
    public function setStandardcreatuaplicacion($standardcreatuaplicacion)
    {
        $this->standardcreatuaplicacion = $standardcreatuaplicacion;

        return $this;
    }

    /**
     * Get standardcreatuaplicacion
     *
     * @return boolean
     */
    public function getStandardcreatuaplicacion()
    {
        return $this->standardcreatuaplicacion;
    }

    /**
     * Set aplicacionactiva
     *
     * @param boolean $aplicacionactiva
     *
     * @return administrador
     */
    public function setAplicacionactiva($aplicacionactiva)
    {
        $this->aplicacionactiva = $aplicacionactiva;

        return $this;
    }

    /**
     * Get aplicacionactiva
     *
     * @return boolean
     */
    public function getAplicacionactiva()
    {
        return $this->aplicacionactiva;
    }

    /**
     * Set fechabienvenida
     *
     * @param \DateTime $fechabienvenida
     *
     * @return administrador
     */
    public function setFechabienvenida($fechabienvenida)
    {
        $this->fechabienvenida = $fechabienvenida;

        return $this;
    }

    /**
     * Get fechabienvenida
     *
     * @return \DateTime
     */
    public function getFechabienvenida()
    {
        return $this->fechabienvenida;
    }

    /**
     * Set recordatorio1
     *
     * @param boolean $recordatorio1
     *
     * @return administrador
     */
    public function setRecordatorio1($recordatorio1)
    {
        $this->recordatorio1 = $recordatorio1;

        return $this;
    }

    /**
     * Get recordatorio1
     *
     * @return boolean
     */
    public function getRecordatorio1()
    {
        return $this->recordatorio1;
    }

    /**
     * Set recordatorio2
     *
     * @param boolean $recordatorio2
     *
     * @return administrador
     */
    public function setRecordatorio2($recordatorio2)
    {
        $this->recordatorio2 = $recordatorio2;

        return $this;
    }

    /**
     * Get recordatorio2
     *
     * @return boolean
     */
    public function getRecordatorio2()
    {
        return $this->recordatorio2;
    }

    /**
     * Set recordatorio3
     *
     * @param boolean $recordatorio3
     *
     * @return administrador
     */
    public function setRecordatorio3($recordatorio3)
    {
        $this->recordatorio3 = $recordatorio3;

        return $this;
    }

    /**
     * Get recordatorio3
     *
     * @return boolean
     */
    public function getRecordatorio3()
    {
        return $this->recordatorio3;
    }

    /**
     * Set recordatorioexpirado
     *
     * @param boolean $recordatorioexpirado
     *
     * @return administrador
     */
    public function setRecordatorioexpirado($recordatorioexpirado)
    {
        $this->recordatorioexpirado = $recordatorioexpirado;

        return $this;
    }

    /**
     * Get recordatorioexpirado
     *
     * @return boolean
     */
    public function getRecordatorioexpirado()
    {
        return $this->recordatorioexpirado;
    }

    /**
     * Set comprarealizada
     *
     * @param boolean $comprarealizada
     *
     * @return administrador
     */
    public function setComprarealizada($comprarealizada)
    {
        $this->comprarealizada = $comprarealizada;

        return $this;
    }

    /**
     * Get comprarealizada
     *
     * @return boolean
     */
    public function getComprarealizada()
    {
        return $this->comprarealizada;
    }

    /**
     * Set fechaenviocompra
     *
     * @param \DateTime $fechaenviocompra
     *
     * @return administrador
     */
    public function setFechaenviocompra($fechaenviocompra)
    {
        $this->fechaenviocompra = $fechaenviocompra;

        return $this;
    }

    /**
     * Get fechaenviocompra
     *
     * @return \DateTime
     */
    public function getFechaenviocompra()
    {
        return $this->fechaenviocompra;
    }
}
