<?php

namespace UsuarioBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\AdvancedUserInterface;

/**
 * usuario
 *
 * @ORM\Table(name="usuario")
 * @ORM\Entity(repositoryClass="UsuarioBundle\Repository\usuarioRepository")
 * @ORM\InheritanceType("JOINED")
 * @ORM\DiscriminatorColumn(name="tipo", type="string")
 * @ORM\MappedSuperclass()
 * @ORM\DiscriminatorMap({ "usuario" = "usuario", "administrador" = "administrador", "superadmin" = "superadmin"})
 */
class usuario implements AdvancedUserInterface
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre", type="string", length=255, nullable=true)
     */
    private $nombre;

    /**
     * @var string
     *
     * @ORM\Column(name="apellidos", type="string", length=255, nullable=true)
     */
    private $apellidos;
    
    /**
     * @var string
     *
     * @ORM\Column(name="telefono", type="string", length=255, nullable=true)
     */
    private $telefono;
    
    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=255, unique=true)
     */
    private $email;

    /**
     * @var string
     *
     * @ORM\Column(name="password", type="string", length=255)
     */
    private $password;

    /**
     * @var string
     *
     * @ORM\Column(name="role", type="string", length=255)
     */
    private $role;

    /**
     * @var string
     *
     * @ORM\Column(name="salt", type="string", length=255)
     */
    private $salt;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="date", type="datetime")
     */
    private $date;

    /**
     * @var Boolean
     *
     * @ORM\Column(name="activo", type="boolean")
     */
    private $activo;

    /**
     * @var Boolean
     *
     * @ORM\Column(name="bloqueado", type="boolean")
     */
    private $bloqueado;

    /**
     * @var Boolean
     *
     * @ORM\Column(name="expirado", type="boolean")
     */
    private $expirado;
    
    /**
     * @var string
     *
     * @ORM\Column(name="codigoverificacion", type="string", length=255,nullable=true)
     */
    private $codigoverificacion;
    
    /**
     * @var string
     *
     * @ORM\Column(name="codigorecuperacion", type="string", length=255,nullable=true)
     */
    private $codigorecuperacion;
    
    public function __toString() {
        return $this->getNombre() . " " . $this->getApellidos();
    }

    public function __construct() {
        $this->date = new \DateTime();
        $this->activo = 1;
        $this->bloqueado = 1;
        $this->expirado = 1;
    }

    /**
     * Get id
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    public function eraseCredentials() {
        
    }

    public function getPassword() {
        return $this->password;
    }

    public function getRoles() {
        return array($this->getRole());
    }

    public function getSalt() {
        return $this->salt;
    }

    public function getUsername() {
        return $this->getEmail();
    }

    public function isAccountNonExpired() {
        return $this->getExpirado();
    }

    public function isAccountNonLocked() {
        return $this->getBloqueado();
    }

    public function isCredentialsNonExpired() {
        return $this->getExpirado();
    }

    public function isEnabled() {
        return $this->getActivo();
    }

    /**
     * Set nombre
     *
     * @param string $nombre
     *
     * @return usuario
     */
    public function setNombre($nombre)
    {
        $this->nombre = $nombre;

        return $this;
    }

    /**
     * Get nombre
     *
     * @return string
     */
    public function getNombre()
    {
        return $this->nombre;
    }

    /**
     * Set apellidos
     *
     * @param string $apellidos
     *
     * @return usuario
     */
    public function setApellidos($apellidos)
    {
        $this->apellidos = $apellidos;

        return $this;
    }

    /**
     * Get apellidos
     *
     * @return string
     */
    public function getApellidos()
    {
        return $this->apellidos;
    }

    /**
     * Set telefono
     *
     * @param string $telefono
     *
     * @return usuario
     */
    public function setTelefono($telefono)
    {
        $this->telefono = $telefono;

        return $this;
    }

    /**
     * Get telefono
     *
     * @return string
     */
    public function getTelefono()
    {
        return $this->telefono;
    }

    /**
     * Set email
     *
     * @param string $email
     *
     * @return usuario
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set password
     *
     * @param string $password
     *
     * @return usuario
     */
    public function setPassword($password)
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Set role
     *
     * @param string $role
     *
     * @return usuario
     */
    public function setRole($role)
    {
        $this->role = $role;

        return $this;
    }

    /**
     * Get role
     *
     * @return string
     */
    public function getRole()
    {
        return $this->role;
    }

    /**
     * Set salt
     *
     * @param string $salt
     *
     * @return usuario
     */
    public function setSalt($salt)
    {
        $this->salt = $salt;

        return $this;
    }

    /**
     * Set date
     *
     * @param \DateTime $date
     *
     * @return usuario
     */
    public function setDate($date)
    {
        $this->date = $date;

        return $this;
    }

    /**
     * Get date
     *
     * @return \DateTime
     */
    public function getDate()
    {
        return $this->date;
    }

    /**
     * Set activo
     *
     * @param boolean $activo
     *
     * @return usuario
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get activo
     *
     * @return boolean
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Set bloqueado
     *
     * @param boolean $bloqueado
     *
     * @return usuario
     */
    public function setBloqueado($bloqueado)
    {
        $this->bloqueado = $bloqueado;

        return $this;
    }

    /**
     * Get bloqueado
     *
     * @return boolean
     */
    public function getBloqueado()
    {
        return $this->bloqueado;
    }

    /**
     * Set expirado
     *
     * @param boolean $expirado
     *
     * @return usuario
     */
    public function setExpirado($expirado)
    {
        $this->expirado = $expirado;

        return $this;
    }

    /**
     * Get expirado
     *
     * @return boolean
     */
    public function getExpirado()
    {
        return $this->expirado;
    }

    /**
     * Set codigoverificacion
     *
     * @param string $codigoverificacion
     *
     * @return usuario
     */
    public function setCodigoverificacion($codigoverificacion)
    {
        $this->codigoverificacion = $codigoverificacion;

        return $this;
    }

    /**
     * Get codigoverificacion
     *
     * @return string
     */
    public function getCodigoverificacion()
    {
        return $this->codigoverificacion;
    }

    /**
     * Set codigorecuperacion
     *
     * @param string $codigorecuperacion
     *
     * @return usuario
     */
    public function setCodigorecuperacion($codigorecuperacion)
    {
        $this->codigorecuperacion = $codigorecuperacion;

        return $this;
    }

    /**
     * Get codigorecuperacion
     *
     * @return string
     */
    public function getCodigorecuperacion()
    {
        return $this->codigorecuperacion;
    }
}
