<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace UsuarioBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Doctrine\ORM\EntityRepository;

class usuarioType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $where = "u.deleted = 0";
        if (isset($options["attr"]["idcategory"]) && $options["attr"]["idcategory"] > 0){
            $where .= " AND u.category = " . $options["attr"]["idcategory"];
        }
        if (isset($options["attr"]["paso3"])&&($options["attr"]["paso3"] == true)){    
            $builder->add('nombre', TextType::class, array(
                'label' => 'Nombre',
                "required" => true,
                "attr" => array('autocomplete' => 'disabled', "class" => "form-login form-login-solid required","placeholder"=>"Nombre"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('apellidos', TextType::class, array(
                'label' => 'Apellidos',
                "required" => true,
                "attr" => array('autocomplete' => 'disabled', "class" => "form-login form-login-solid required","placeholder"=>"Apellidos"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('cifnif', TextType::class, array(
                'label' => 'CIF / NIF',
                "required" => true,
                "attr" => array("class" => "form-control required","placeholder"=>"CIF/NIF"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('telefono', TextType::class, array(
                'label' => 'Teléfono',
                "required" => true,
                "attr" => array('autocomplete' => 'disabled', "class" => "form-login form-login-solid required","placeholder"=>"Teléfono"),
                "disabled" => $options["attr"]["disabled"]
            ));
            if ($options["attr"]["password"] == true){
                $builder->add('password', RepeatedType::class, array(
                    'type' => PasswordType::class,
                    'invalid_message' => 'Introduzca la contraseña',
                    'options' => array('attr' => array('class' => 'password-field')),
                    'required' => true,
                    'first_options'  => array('label' => 'Contraseña', "attr" => array("class" => "form-login form-login-solid required"  ,"placeholder"=>"Introduce la contraseña")),
                    'second_options' => array('label' => 'Repita contraseña', "attr" => array("class" => "form-login form-login-solid required"  ,"placeholder"=>"Repite la contraseña")),
                ));
            }else{
                $builder->add('password', RepeatedType::class, array(
                    'type' => PasswordType::class,
                    'invalid_message' => 'Introduzca la contraseña',
                    'options' => array('attr' => array('class' => 'password-field')),
                    'required' => false,
                    'first_options'  => array('label' => 'Contraseña', "attr" => array("class" => "form-login form-login-solid required")),
                    'second_options' => array('label' => 'Repita contraseña', "attr" => array("class" => "form-login form-login-solid required")),
                ));
            }
        }  
        if (isset($options["attr"]["paso1"])&&($options["attr"]["paso1"] == true)){ 
           $builder->add('email', EmailType::class, array(
               'label' => 'Email',
               "required" => true,
               "attr" => array("class" => "form-login form-login-solid required"),
               "disabled" => $options["attr"]["disabled"]
           ));
        }    

        if(isset($options["attr"]["paso4"])&&($options["attr"]["paso4"] == true)){
           $builder->add('category', EntityType::class, array(
               'class' => \CoreBundle\Entity\category::class,
               'query_builder' => function (EntityRepository $er) {
                   return $er->createQueryBuilder('u')->add('where', 'u.deleted = 0')
                       ->orderBy('u.name', 'ASC');
               },
               'label' => 'Selecciona el tipo de actividad',
               "attr" => array( "class" => "form-control required"),
               'required' => true,        
               'expanded' => false
           ))
           ->add('subcategory', EntityType::class, array(
               'class' => \CoreBundle\Entity\subcategory::class,
               'query_builder' => function (EntityRepository $er) use ($where) {
                   return $er->createQueryBuilder('u')->add('where', $where)
                       ->orderBy('u.name', 'ASC');
               },
               'label' => 'Selecciona el tipo de actividad',
               "attr" => array( "class" => "form-control required"),
               'required' => true,        
               'expanded' => false
           ));
        }
        if (isset($options["attr"]["paso5"]) && isset($options["attr"]["app"])
                && $options["attr"]["paso5"] == true 
                && $options["attr"]["app"] == true){ 
            $builder->add('nombredeapp', TextType::class, array(
               'label' => 'Nombre de la app',
               "required" => true,
               "attr" => array( "class" => "form-login form-login-solid required","placeholder"=>"Nombre de la app"),
               "disabled" => $options["attr"]["disabled"]
            ));
        }      
            
    }
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'UsuarioBundle\Entity\Usuario',
            "allow_extra_fields" => true
        ));
    }
    public function getName()
    {
        return 'usuario';
    }
}

