<?php

namespace UsuarioBundle\Repository;

/**
 * administradorRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class administradorRepository extends \Doctrine\ORM\EntityRepository
{
    public function findAdministrador($email){
        $em = $this->getEntityManager();
        return $em->createQueryBuilder()
            ->select('administrador')
            ->from('UsuarioBundle:administrador','administrador')
            ->where("administrador.email LIKE '$email'")
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
    }
    
    public function findSuscripcion($stripeSubscriptionId){
        $em = $this->getEntityManager();
        return $em->createQueryBuilder()
                ->select('administrador')
                ->from('UsuarioBundle:administrador','administrador')
                ->innerJoin("administrador.eventostripe", "eventostripe")
                ->where("eventostripe.stripesubscriptionid LIKE '$stripeSubscriptionId'")
                ->getQuery()
                ->getResult();
    }
    
    public function findAllusersQuery($idbusiness, $text, $activo){
        $em = $this->getEntityManager();
        $where = "administrador.activo = $activo";
        if ($idbusiness > 0){
            $where .= " AND administrador.business = " . $idbusiness;
        }
        if ($text != NULL && strlen($text) > 0){
            $vartexto = explode(" ", $text);
            if (count($vartexto) > 0){
                foreach ($vartexto as $t) {
                    $condicion = "administrador.nombre LIKE '%". $t . "%' ";
                    $condicion .= " OR administrador.apellidos LIKE '%". $t . "%' ";
                    $condicion .= " OR administrador.email LIKE '%". $t . "%' ";
                    $where .= " AND ($condicion)";
                }
            }
        }
        return $em->createQueryBuilder()
            ->select('administrador')
            ->from('UsuarioBundle:administrador','administrador')
            ->where($where)   
            ->getQuery();
    } 
    
    public function findRecordatorioPublicada() {
        $where = "administrador.publicada = 0 AND administrador.eliminado = 0 AND administrador.fechabienvenida is not null";
        $where .= " AND (administrador.recordatorio1 = 0 OR administrador.recordatorio2 = 0 OR administrador.recordatorio3 = 0)";
        $where .= " AND business.folderemail IS NOT NULL";
        $queryBuilder = $this->getEntityManager()
                ->getRepository('UsuarioBundle:administrador')
                ->createQueryBuilder('administrador')
                ->innerJoin("administrador.business", "business")
                ->where($where);
        return $queryBuilder->getQuery()->getResult();
    }
    
    public function findPeriodoprueba() {
        $where = "administrador.activo = 1 AND administrador.planactivo = 0 AND administrador.fechaexpiracion IS NOT NULL";
        $where .= " AND (administrador.recordatorio1 = 0 OR administrador.recordatorio2 = 0 OR administrador.recordatorio3 = 0 OR administrador.recordatorioexpirado = 0)";
        $where .= " AND business.folderemail IS NOT NULL";
        $date = new \DateTime();
        $where .= " AND administrador.fechaexpiracion >= '" . $date->format("Y-m-d") . " 00:00:00'";
        $queryBuilder = $this->getEntityManager()
                ->getRepository('UsuarioBundle:administrador')
                ->createQueryBuilder('administrador')
                ->innerJoin("administrador.business", "business")
                ->where($where);
        return $queryBuilder->getQuery()->getResult();
    }
    
    public function findComprainicial() {
        $where = "administrador.activo = 1 AND administrador.comprarealizada = 0";
        $where .= " AND business.folderemail IS NOT NULL";
        $queryBuilder = $this->getEntityManager()
                ->getRepository('UsuarioBundle:administrador')
                ->createQueryBuilder('administrador')
                ->innerJoin("administrador.business", "business")
                ->where($where);
        return $queryBuilder->getQuery()->getResult();
    }
}
