<?php

namespace WebBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use CoreBundle\Entity\Utils;
use Symfony\Component\Process\Process;
use Symfony\Component\Process\Exception\ProcessFailedException;

class DomainController extends Controller
{
    public function comprobardominioAction(Request $request){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $sepuederegistrar = false;
        $sepuedetransfer = false;
        $error = 2;
        $texto = "El dominio está registrado ya";
        
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true 
                && $usuario->getCondominio()){
            if ($request->getMethod() == "POST"){
                $dominio = $request->request->get("domain");
                if ($dominio != NULL && strlen($dominio) >0){
                    $dominio = Utils::limpiardominio($dominio);
                    
                    if (filter_var("http://" . $dominio, FILTER_VALIDATE_URL)){
                        list($error, $texto) = Utils::validarextension($dominio);
                        if ($error == 0){
                            $phpfolder = "php ";
                            $root = $phpfolder . $request->server->get('DOCUMENT_ROOT') . "/../apidominios/comprobardominio.php " . $dominio;
                            
                            $process = new Process($root);
                            $process->run();
                            if (!$process->isSuccessful()) {
                                throw new ProcessFailedException($process);
                            }
                            $response = $process->getOutput();
                            $array = json_decode($response);
                            if ($array){
                                foreach ($array as $key => $value) {
                                    if ($key == "domain"){
                                        foreach ($value as $key2 => $value2) {
                                            if ($key2 == "register"){
                                                $sepuederegistrar = boolval($value2);
                                            }
                                        }
                                    }
                                }
                                if ($sepuederegistrar == false){
                                    $error = 2;
                                    $texto = "El dominio está registrado ya";
                                }else{
                                    $error = 0;
                                    $texto = "";
                                }
                            }else{
                                $error = 3;
                                $texto = "Error en la petición al proveedor. " . $root;
                            }
                        }
                    }else{
                        $error = 1;
                        $texto = "Dominio no válido";
                    }
                }else{
                    $error = 1;
                    $texto = "Dominio no válido";
                }
            }else{
                $error = 2;
                $texto = "Error en la petición";
            }
        }
        if ($sepuederegistrar){
            $sepuederegistrar = 1;
        }else{
            $sepuederegistrar = 0;
        }
        if ($sepuedetransfer){
            $sepuedetransfer = 1;
        }else{
            $sepuedetransfer = 0;
        }
        
        return new Response(json_encode(array("sepuederegistrar" => $sepuederegistrar, 
            "sepuedetransfer" => $sepuedetransfer,
            "error" => $error, 
            "texto" => $texto)));
    }
}
