<?php

namespace WebBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use WebBundle\Entity\usermail;
use WebBundle\Form\usermailType;
use WebBundle\Form\usermailpassonlyType;
use CoreBundle\Entity\Domainutils;
use CoreBundle\Entity\Cipher;

class EmailController extends Controller
{
    public function emailsAction(){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $business = $usuario->getBusiness();
        if (($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)
            && ($usuario->getPlanactivo()== 1 || $usuario->getTienepermiso() ) 
            && $business ){
            // Se comprueba si el usuario ha editado la información
            $em = $this->getDoctrine()->getManager();
            if ($usuario->getDominioaceptado() != NULL){
                $style = $business->getStyle();
                $usermails = $em->getRepository('WebBundle:usermail')
                        ->findUseremails($usuario->getId());
                return $this->render('WebBundle:Email:emails.html.twig', 
                        array(  'usuario' => $usuario, 
                                'style'=>$style, 
                                "usermails" => $usermails));
            }
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function emailscrearAction(Request $request, $id){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $business = $usuario->getBusiness();
        if (($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)
            && ($usuario->getPlanactivo() == 1 || $usuario->getTienepermiso() ) 
            && $business ){
            
            $em = $this->getDoctrine()->getManager();
            $usermails = $em->getRepository('WebBundle:usermail')
                        ->findUseremails($usuario->getId());
            if ($usuario->getNumeromaximoemails() < count($usermails)){
                // Se comprueba si el usuario ha editado la información
                $briefing = $em->getRepository("WebBundle:briefing")->findOneBy(array("administrador" => $usuario));
                if ($briefing != NULL && $briefing->getEditado() == false){
                    return $this->redirectToRoute("public_informarcion_negocio");
                }
                $error = "";
                if ($usuario->getDominioaceptado()){
                    $style = $business->getStyle();
                    if ($id == NULL){
                        $id = -1;
                    }
                    $useremail = $em->getRepository("WebBundle:usermail")->find($id);
                    $nueva = false;
                    if ($useremail == NULL){
                        $useremail = new usermail();
                        $useremail->setUsuario($usuario);
                        $nueva = TRUE;
                    }
                    if ($nueva){
                        $form = $this->createForm(usermailType::class, $useremail);
                    }else{
                        $form = $this->createForm(usermailpassonlyType::class, $useremail);
                    }
                    if ($request->getMethod() == "POST"){
                        $form->handleRequest($request);
                        if ($form->isSubmitted() && $form->isValid()) {
                            $email = $useremail->getUsername() . "@" . $usuario->getDomain();
                            $kernel = $this->get('kernel');
                            $isdebug = $kernel->isDebug();
                            $code = 200;
                            if ($isdebug == false){
                                $documentroot = $request->server->get('DOCUMENT_ROOT');
                                if ($nueva){
                                    list($code, $error, $message) = Domainutils::crearemail($documentroot, $email, $useremail->getPassword());
                                }else{
                                    list($code, $error, $message) = Domainutils::actualizaremail($documentroot, $email, $useremail->getPassword());
                                }
                            }
                            if ($code == 200){
                                $passencode = Cipher::crypt($useremail->getPassword());
                                $useremail->setPassword($passencode);
                                $em->persist($useremail);
                                $em->flush();

                                return $this->redirectToRoute("public_emails");
                            }else{
                                if ($nueva){
                                    $error = "El email no ha podido crearse correctamente. "
                                            . "Asegúrate que no se ha creado anteriormente y "
                                            . "que la contraseña tiene una longitud mínima de 8. "
                                            . "Recuerda que tiene que contener caracteres, 1 número y algún símbolo.";
                                }else{
                                    $error = "La contraseña no ha podido actualizarse. "
                                            . "Asegúrate que tiene una longitud mínima de 8. "
                                            . "Recuerda que tiene que contener caracteres, 1 número y algún símbolo.";
                                }
                            }
                        }
                    }

                    return $this->render('WebBundle:Email:emailscrear.html.twig', 
                            array(  'usuario' => $usuario, 
                                    'style'=>$style, 
                                    "useremail" => $useremail,
                                    "nueva" => $nueva,
                                    "error" => $error,
                                    "form" => $form->createView()));
                }
            }
        }
        return $this->redirectToRoute("public_emails");
    }
    
    public function emailseliminarAction(Request $request, $id){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $business = $usuario->getBusiness();
        if (($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)
            && ($usuario->getPlanactivo()== 1 || $usuario->getTienepermiso() ) 
            && $business ){
            // Se comprueba si el usuario ha editado la información
            $em = $this->getDoctrine()->getManager();
            $error = "";
            if ($usuario->getDominioaceptado() != NULL){
                $useremail = $em->getRepository("WebBundle:usermail")->find($id);
                if ($useremail != NULL){
                    $email = $useremail->getUsername() . "@" . $usuario->getDomain();
                    $documentroot = $request->server->get('DOCUMENT_ROOT');
                    $code = 200;
                    $kernel = $this->get('kernel');
                    $isdebug = $kernel->isDebug();
                    if ($isdebug == false){
                        list($code, $error, $message) = Domainutils::eliminaremail($documentroot, $email);
                    }
                    if ($code == 200){
                        $em->remove($useremail);
                        $em->flush();
                    }
                }    
            }
        }
        return $this->redirectToRoute("public_emails");
    }
}
