<?php

namespace WebBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use CoreBundle\Entity\Cipher;
use Symfony\Component\HttpFoundation\Response;
use WebBundle\Entity\web;
use CoreBundle\Entity\Utils;
use CoreBundle\Entity\Domainutils;
use Symfony\Component\Process\Process;
use Symfony\Component\Process\Exception\ProcessFailedException;

class PublicController extends Controller
{
    public function accesoAction(Request $request){
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
            return $this->redirectToRoute("public_panel-index-user");
        }else if ($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN') === true){
            return $this->redirectToRoute("business_index");
        }
        return $this->redirectToRoute('logout');
    }
    
    public function mypanelAction(Request $request){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        $em = $this->getDoctrine()->getManager();
        $host = $request->getHost();
        $protocol = $request->getScheme();
        $business = $em->getRepository("PagoBundle:business")->findNegocio($host); 
        if ($business && $usuario != NULL && $business->getId() == $usuario->getBusiness()->getId() ){
            if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true){
                if ($usuario->getPlanactivo() == 1 || $usuario->getTienepermiso()){
                    $kernel = $this->get('kernel');
                    $isdebug = $kernel->isDebug();
                    $briefing = $usuario->getBriefing();
                    if ($usuario->getSubdominio() == NULL){
                        list($usuario, $errorcode, $errortext) = Domainutils::crearsubdominioenweb($em, $usuario, $isdebug);
                        list($pathbanner, $pathlogo, $briefing) = $this->getPath($em, $briefing);
                        Domainutils::editarinformacion($em, $usuario, $briefing, $pathbanner, $pathlogo, $isdebug, $protocol);
                    }
                    
                    $style = NULL;
                    if($usuario->getBusiness() && $usuario->getBusiness()->getStyle()){
                        $style = $usuario->getBusiness()->getStyle();
                    }
                    
                    $urlapp = NULL;
                    if ($usuario->getAplicacioncreada() && $usuario->getIdapp() > 0){
                        $passopen = Cipher::decrypt($usuario->getPasscifrada());
                        $post = ['passopen' => $passopen,
                                 "usuario" => $usuario->getUsuarioapp() . ""];
                        $myjson = json_encode($post);
                        $code = Cipher::crypt($myjson);
                        
                        $urlapp = $business->getUrlloginapp() . "?code=" . $code;
                    }
                    
                    return $this->render('WebBundle:Public:panel.html.twig', 
                            array('usuario'=>$usuario, 'style'=>$style, 
                                "business" => $business, 'urlapp' => $urlapp));
                }
                return $this->redirectToRoute('tpv_index');
            }
        }
        return $this->redirectToRoute('logout');
    }
    
    public function getPath($em, $briefing){
        $pathbanner = "";
        $pathlogo = "";
        
        if ($briefing != NULL && $briefing->getCodigotemporal() == NULL){
            $briefing->setCodigotemporal(md5(time()));
            $em->persist($briefing);
            $em->flush();
        }
        
        if ($briefing != NULL && $briefing->getPathbanner()){
            $pathbanner = $this->generateUrl("public_imagen_exterior", 
                    array("idbriefing" => $briefing->getId(),
                        "tipo" => 2,
                        "name" => $briefing->getPathbanner(),
                        "codigo" => $briefing->getCodigotemporal()));
        }
        if ($briefing != NULL && $briefing->getPathlogo()){
            $pathlogo = $this->generateUrl("public_imagen_exterior", 
                    array("idbriefing" => $briefing->getId(),
                        "tipo" => 1,
                        "name" => $briefing->getPathlogo(),
                        "codigo" => $briefing->getCodigotemporal()));
        }
        return array($pathbanner, $pathlogo, $briefing);
    }
    
    public function reservardominioAction(Request $request){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true 
                && $usuario->getCondominio()){
            // Se comprueba si el usuario ha editado la información
            $em = $this->getDoctrine()->getManager();
            $style = NULL;
            $business = $usuario->getBusiness();
            if($usuario->getBusiness() && $usuario->getBusiness()->getStyle()){
                $style = $usuario->getBusiness()->getStyle();
            }
            $error = 0;
            $texto = "";
            if ($request->getMethod() == "POST"){
                $dominio = $request->request->get("domain");
                $extension = $request->request->get("extension");
                if ($dominio != NULL && $extension != NULL){
                    $dominio = $dominio . $extension;
                    $dominio = Utils::limpiardominio($dominio);
                    if (filter_var("http://" . $dominio, FILTER_VALIDATE_URL)){
                        list($error, $texto) = Utils::validarextension($dominio);
                        if ($error == 0){
                            $kernel = $this->get('kernel');
                            $isdebug = $kernel->isDebug();
                            $code = 0;
                            if ($isdebug == false){
                                $root = "php " . $request->server->get('DOCUMENT_ROOT') . "/../apidominios/reservardominio.php " . $dominio;
                                $process = new Process($root);
                                $process->run();
                                if (!$process->isSuccessful()) {
                                    throw new ProcessFailedException($process);
                                }
                                $responsereservardominio = $process->getOutput();
                                Utils::crearlogpeticion("reservardominio", $responsereservardominio);
                                $documentroot = $request->server->get('DOCUMENT_ROOT');
                                $business = $usuario->getBusiness();
                                if ($business){
                                    $code = Domainutils::crearplan($documentroot, $dominio, $business->getServerplan());
                                }
                            }else{
                                $code = 200;
                            }
                            if ($code == 200){
                                $usuario->setPlancreado(TRUE);
                                $usuario->setFechaplan(new \DateTime());
                            }

                            $usuario->setDominio($dominio);
                            $usuario->setDominioaceptado(TRUE);
                            $em->persist($usuario);
                            $em->flush();

                            return $this->redirectToRoute("public_reservado_dominio");
                        }
                    }
                }
            }
            
            return $this->render('WebBundle:Public:reservardominio.html.twig', 
                    array('usuario'=>$usuario, 
                            'style'=>$style, 
                            "texto" => $texto,
                            "error" => $error,
                            "business" => $business));
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function reservadodominioAction(){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true 
                && $usuario->getCondominio()){
            $style = NULL;
            if($usuario->getBusiness() && $usuario->getBusiness()->getStyle()){
                $style = $usuario->getBusiness()->getStyle();
            }
            return $this->render('WebBundle:Public:reservadodominio.html.twig', 
                array('usuario'=>$usuario, 
                    'style'=>$style));
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function editarAction(){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true
             && ($usuario->getPlanactivo()== 1 || $usuario->getTienepermiso() ) ){
            return $this->render('WebBundle:Public:editar.html.twig', 
                    array("usuario" => $usuario,'volver'=>1));
        }
        return $this->redirectToRoute('tpv_index');
    }
    
    public function politicaprivacidadAction()
    {   
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)    {
            $usuario = $this->get('security.token_storage')->getToken()->getUser();
            return $this->render('WebBundle:Public:politica.html.twig', array("usuario" => $usuario));
        }
        return $this->redirectToRoute('tpv_index');
    }
    
    public function publicarAction(){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();
        if ($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true
                && ($usuario->getPlanactivo()== 1 || $usuario->getTienepermiso() ) ){
            // Se comprueba si tiene un plan con dominio
            if ($usuario->getCondominio() == TRUE && $usuario->getDominioaceptado() == false){
                return $this->redirectToRoute("public_reservar_dominio");
            }
            
            $usuario->setPublicada(TRUE);
            $em = $this->getDoctrine()->getManager();
            $em->persist($usuario);
            $em->flush();
            
            return $this->redirectToRoute("redirection_web"); 
        }
        return $this->redirectToRoute('public_panel-index-user');
    }
    
    public function redirectionwebAction(){
        $usuario = $this->get('security.token_storage')->getToken()->getUser();

        if (($this->get('security.authorization_checker')->isGranted('ROLE_USER') === true)
                && ($usuario->getPlanactivo()== 1 || $usuario->getTienepermiso() ) ){
            $passopen = Cipher::decrypt($usuario->getPasscifrada());
            $post = ['passopen' => $passopen,
                     "usuario" => $usuario->getEmail() . ""];
            $myjson = json_encode($post);
            $jsonencrypt = Cipher::crypt($myjson);
            $urlencode = urlencode($jsonencrypt);
            
            $kernel = $this->get('kernel');
            $isdebug = $kernel->isDebug();
            if ($isdebug == false){
                $urlredirect = 'http://'.$usuario->getUrlredirect().'/acceso-encrypt?code='.$urlencode;
            }else{
                $urlredirect = 'http://'.$usuario->getUrlredirect().'/app_dev.php/acceso-encrypt?code='.$urlencode;
            }
            return $this->redirect($urlredirect);
        }
        return $this->redirectToRoute('tpv_index');
    }
    
    public function getimagelogoAction($id){
        $em = $this->getDoctrine()->getManager();
        $briefing = $em->getRepository('WebBundle:briefing')->find($id);
        if ($briefing != NULL && $briefing->getPathlogo() != NULL){
            $ruta= $briefing->getDir() . $briefing->getPathlogo();
            if (file_exists($ruta)){
                $headers = array('Content-Type' => "image/png",
                        'Content-Disposition' => 'inline; '
                        . 'filename="'.$ruta.'"');

                $file =  readfile($ruta);
                return new Response($file, 200, $headers); 
            }
        }
        $response = new Response(json_encode(array()));
        return $response;
    }
    
    public function getimagebannerAction($id){
        $em = $this->getDoctrine()->getManager();
        $briefing = $em->getRepository('WebBundle:briefing')->find($id);
        if ($briefing != NULL && $briefing->getPathbanner() != NULL){
            $ruta= $briefing->getDir() . $briefing->getPathbanner();
            if (file_exists($ruta)){
                $headers = array('Content-Type' => "image/png",
                        'Content-Disposition' => 'inline; '
                        . 'filename="'.$ruta.'"');

                $file =  readfile($ruta);
                return new Response($file, 200, $headers); 
            }
        }
        $response = new Response(json_encode(array()));
        return $response;
    }
    
    public function imagenexteriorAction(Request $request, $idbriefing, $tipo, $codigo){
        $em = $this->getDoctrine()->getManager();
        $briefing = $em->getRepository("WebBundle:briefing")->find($idbriefing);
        if ($briefing != NULL && $briefing->getCodigotemporal() == $codigo){
            if ($tipo == 1){
                $ruta = $briefing->getDir() . $briefing->getPathlogo();
            }else if ($tipo == 2){
                $ruta = $briefing->getDir() . $briefing->getPathbanner();
            }
        }else{
            $ruta = "./../data/aux/logo.png";
        }
        
        if (file_exists($ruta)){
            $headers = array('Content-Type' => "image/png",
                    'Content-Disposition' => 'inline; '
                    . 'filename="'.$ruta.'"');

            $file =  readfile($ruta);
            return new Response($file, 200, $headers); 
        }
        return new Response(json_encode(array()));
    }
}
