<?php

namespace WebBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * briefing
 *
 * @ORM\Table(name="briefing")
 * @ORM\Entity(repositoryClass="WebBundle\Repository\briefingRepository")
 */
class briefing
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var boolean
     *
     * @ORM\Column(name="editado", type="boolean")
     */
    private $editado;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre", type="string", length=255, nullable=true)
     */
    private $nombre;

    /**
     * @var string
     *
     * @ORM\Column(name="nombretienda", type="string", length=255, nullable=true)
     */
    private $nombretienda;

    /**
     * @var string
     *
     * @ORM\Column(name="descripcion", type="text", nullable=true)
     */
    private $descripcion;

    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=255, nullable=true)
     */
    private $email;

    /**
     * @var string
     *
     * @ORM\Column(name="emailpedidos", type="string", length=255, nullable=true)
     */
    private $emailpedidos;

    /**
     * @var string
     *
     * @ORM\Column(name="telefono", type="string", length=255, nullable=true)
     */
    private $telefono;

    /**
     * @var string
     *
     * @ORM\Column(name="direccion", type="string", length=255, nullable=true)
     */
    private $direccion;

    /**
     * @var string
     *
     * @ORM\Column(name="horario", type="string", length=255, nullable=true)
     */
    private $horario;

    /**
     * @var string
     *
     * @ORM\Column(name="facebook", type="string", length=255, nullable=true)
     */
    private $facebook;

    /**
     * @var string
     *
     * @ORM\Column(name="twitter", type="string", length=255, nullable=true)
     */
    private $twitter;

    /**
     * @var string
     *
     * @ORM\Column(name="instagram", type="string", length=255, nullable=true)
     */
    private $instagram;

    /**
     * @var string
     *
     * @ORM\Column(name="linkedin", type="string", length=255, nullable=true)
     */
    private $linkedin;

    /**
     * @var string
     *
     * @ORM\Column(name="pathlogo", type="string", length=255, nullable=true)
     */
    private $pathlogo;

    /**
     * @var string
     *
     * @ORM\Column(name="pathbanner", type="string", length=255, nullable=true)
     */
    private $pathbanner;

    /**
     * @var int
     *
     * @ORM\Column(name="numerosubidas", type="integer")
     */
    private $numerosubidas;

    /**
     * @var string
     *
     * @ORM\Column(name="textolegal", type="text", nullable=true)
     */
    private $textolegal;

    /**
     * @var string
     *
     * @ORM\Column(name="condicioneslegales", type="text", nullable=true)
     */
    private $condicioneslegales;

    /**
     * @var string
     *
     * @ORM\Column(name="politicaprivacidad", type="text", nullable=true)
     */
    private $politicaprivacidad;
    
    /**
     * @ORM\OneToOne(targetEntity="UsuarioBundle\Entity\administrador", inversedBy="briefing")
     * @ORM\JoinColumn(name="administrador_id", referencedColumnName="id")
     */
    protected $administrador;

    /**
     * @var boolean
     *
     * @ORM\Column(name="productosparaadultos", type="boolean")
     */
    private $productosparaadultos;

    /**
     * @var string
     *
     * @ORM\Column(name="codigotemporal", type="string", length=255, nullable=true)
     */
    private $codigotemporal;

    /**
     * @var subcategory
     *
     * @ORM\ManyToOne(targetEntity="CoreBundle\Entity\category")
     */
    private $category;

    /**
     * @var subcategory
     *
     * @ORM\ManyToOne(targetEntity="CoreBundle\Entity\subcategory")
     */
    private $subcategory;
    
    public function getDir(){
        return  "./../data/zipimagenes/";
    }
    
    public function removeUploadpathbanner()
    {
        if ($this->pathbanner){
            $file = $this->getDir() . $this->pathbanner;
            if (file_exists($file)){
                unlink($file);
            }
        }
    }
    
    public function removeUploadpathlogo()
    {
        if ($this->pathlogo){
            $file = $this->getDir() . $this->pathlogo;
            if (file_exists($file)){
                unlink($file);
            }
        }
    }
    
    public function __construct() {
        $this->numerosubidas = 0;
        $this->productosparaadultos = false;
        $this->editado = false;
    }
    
    public function getArrayvalores($arraycabecera){
        $array = array();
        $array["pass"] = $arraycabecera['passopen'];
        $array["email"] = $arraycabecera['email'];
        $array['fecha'] = $arraycabecera['fecha'];
        $array['subdominio'] = $arraycabecera['subdominio'];
        $array["nombre"] = $this->getNombre() . "";
        $array["nombretienda"] = $this->getNombretienda() . "";
        $array["descripcion"] = $this->getDescripcion() . "";
        $array["emailpedidos"] = $this->getEmailpedidos() . "";
        $array["telefono"] = $this->getTelefono() . "";
        $array["direccion"] = $this->getDireccion() . "";
        $array["horario"] = $this->getHorario() . "";
        $array["facebook"] = $this->getFacebook() . "";
        $array["twitter"] = $this->getTwitter() . "";
        $array["instagram"] = $this->getInstagram() . "";
        $array["linkedin"] = $this->getLinkedin() . "";
        $array["textolegal"] = $this->getTextolegal() . "";
        $array["condicioneslegales"] = $this->getCondicioneslegales() . "";
        $array["politicaprivacidad"] = $this->getPoliticaprivacidad() . "";
        $array["productosparaadultos"] = intval($this->getProductosparaadultos());
        if ($this->getSubcategory() != NULL){
            $array["subcategory"] = $this->getSubcategory()->getId();
        }else{
             $array["subcategory"] = -1;
        }
        if ($this->getCategory() != NULL){
            $array["category"] = $this->getCategory()->getId();
        }else{
             $array["category"] = -1;
        }
        return $array;
    }

    /**
     * Get id
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set nombre
     *
     * @param string $nombre
     *
     * @return briefing
     */
    public function setNombre($nombre)
    {
        $this->nombre = $nombre;

        return $this;
    }

    /**
     * Get nombre
     *
     * @return string
     */
    public function getNombre()
    {
        return $this->nombre;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     *
     * @return briefing
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set email
     *
     * @param string $email
     *
     * @return briefing
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set telefono
     *
     * @param string $telefono
     *
     * @return briefing
     */
    public function setTelefono($telefono)
    {
        $this->telefono = $telefono;

        return $this;
    }

    /**
     * Get telefono
     *
     * @return string
     */
    public function getTelefono()
    {
        return $this->telefono;
    }

    /**
     * Set direccion
     *
     * @param string $direccion
     *
     * @return briefing
     */
    public function setDireccion($direccion)
    {
        $this->direccion = $direccion;

        return $this;
    }

    /**
     * Get direccion
     *
     * @return string
     */
    public function getDireccion()
    {
        return $this->direccion;
    }

    /**
     * Set horario
     *
     * @param string $horario
     *
     * @return briefing
     */
    public function setHorario($horario)
    {
        $this->horario = $horario;

        return $this;
    }

    /**
     * Get horario
     *
     * @return string
     */
    public function getHorario()
    {
        return $this->horario;
    }

    /**
     * Set facebook
     *
     * @param string $facebook
     *
     * @return briefing
     */
    public function setFacebook($facebook)
    {
        $this->facebook = $facebook;

        return $this;
    }

    /**
     * Get facebook
     *
     * @return string
     */
    public function getFacebook()
    {
        return $this->facebook;
    }

    /**
     * Set twitter
     *
     * @param string $twitter
     *
     * @return briefing
     */
    public function setTwitter($twitter)
    {
        $this->twitter = $twitter;

        return $this;
    }

    /**
     * Get twitter
     *
     * @return string
     */
    public function getTwitter()
    {
        return $this->twitter;
    }

    /**
     * Set instagram
     *
     * @param string $instagram
     *
     * @return briefing
     */
    public function setInstagram($instagram)
    {
        $this->instagram = $instagram;

        return $this;
    }

    /**
     * Get instagram
     *
     * @return string
     */
    public function getInstagram()
    {
        return $this->instagram;
    }

    /**
     * Set linkedin
     *
     * @param string $linkedin
     *
     * @return briefing
     */
    public function setLinkedin($linkedin)
    {
        $this->linkedin = $linkedin;

        return $this;
    }

    /**
     * Get linkedin
     *
     * @return string
     */
    public function getLinkedin()
    {
        return $this->linkedin;
    }

    /**
     * Set pathlogo
     *
     * @param string $pathlogo
     *
     * @return briefing
     */
    public function setPathlogo($pathlogo)
    {
        $this->pathlogo = $pathlogo;

        return $this;
    }

    /**
     * Get pathlogo
     *
     * @return string
     */
    public function getPathlogo()
    {
        return $this->pathlogo;
    }

    /**
     * Set numerosubidas
     *
     * @param integer $numerosubidas
     *
     * @return briefing
     */
    public function setNumerosubidas($numerosubidas)
    {
        $this->numerosubidas = $numerosubidas;

        return $this;
    }

    /**
     * Get numerosubidas
     *
     * @return int
     */
    public function getNumerosubidas()
    {
        return $this->numerosubidas;
    }

    /**
     * Set textolegal
     *
     * @param string $textolegal
     *
     * @return briefing
     */
    public function setTextolegal($textolegal)
    {
        $this->textolegal = $textolegal;

        return $this;
    }

    /**
     * Get textolegal
     *
     * @return string
     */
    public function getTextolegal()
    {
        return $this->textolegal;
    }

    /**
     * Set nombretienda
     *
     * @param string $nombretienda
     *
     * @return briefing
     */
    public function setNombretienda($nombretienda)
    {
        $this->nombretienda = $nombretienda;

        return $this;
    }

    /**
     * Get nombretienda
     *
     * @return string
     */
    public function getNombretienda()
    {
        return $this->nombretienda;
    }

    /**
     * Set pathbanner
     *
     * @param string $pathbanner
     *
     * @return briefing
     */
    public function setPathbanner($pathbanner)
    {
        $this->pathbanner = $pathbanner;

        return $this;
    }

    /**
     * Get pathbanner
     *
     * @return string
     */
    public function getPathbanner()
    {
        return $this->pathbanner;
    }

    /**
     * Set condicioneslegales
     *
     * @param string $condicioneslegales
     *
     * @return briefing
     */
    public function setCondicioneslegales($condicioneslegales)
    {
        $this->condicioneslegales = $condicioneslegales;

        return $this;
    }

    /**
     * Get condicioneslegales
     *
     * @return string
     */
    public function getCondicioneslegales()
    {
        return $this->condicioneslegales;
    }

    /**
     * Set politicaprivacidad
     *
     * @param string $politicaprivacidad
     *
     * @return briefing
     */
    public function setPoliticaprivacidad($politicaprivacidad)
    {
        $this->politicaprivacidad = $politicaprivacidad;

        return $this;
    }

    /**
     * Get politicaprivacidad
     *
     * @return string
     */
    public function getPoliticaprivacidad()
    {
        return $this->politicaprivacidad;
    }

    /**
     * Set productosparaadultos
     *
     * @param boolean $productosparaadultos
     *
     * @return briefing
     */
    public function setProductosparaadultos($productosparaadultos)
    {
        $this->productosparaadultos = $productosparaadultos;

        return $this;
    }

    /**
     * Get productosparaadultos
     *
     * @return boolean
     */
    public function getProductosparaadultos()
    {
        return $this->productosparaadultos;
    }

    /**
     * Set codigotemporal
     *
     * @param string $codigotemporal
     *
     * @return briefing
     */
    public function setCodigotemporal($codigotemporal)
    {
        $this->codigotemporal = $codigotemporal;

        return $this;
    }

    /**
     * Get codigotemporal
     *
     * @return string
     */
    public function getCodigotemporal()
    {
        return $this->codigotemporal;
    }

    /**
     * Set subcategory
     *
     * @param \CoreBundle\Entity\subcategory $subcategory
     *
     * @return briefing
     */
    public function setSubcategory(\CoreBundle\Entity\subcategory $subcategory = null)
    {
        $this->subcategory = $subcategory;

        return $this;
    }

    /**
     * Get subcategory
     *
     * @return \CoreBundle\Entity\subcategory
     */
    public function getSubcategory()
    {
        return $this->subcategory;
    }

    /**
     * Set category
     *
     * @param \CoreBundle\Entity\category $category
     *
     * @return briefing
     */
    public function setCategory(\CoreBundle\Entity\category $category = null)
    {
        $this->category = $category;

        return $this;
    }

    /**
     * Get category
     *
     * @return \CoreBundle\Entity\category
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Set emailpedidos
     *
     * @param string $emailpedidos
     *
     * @return briefing
     */
    public function setEmailpedidos($emailpedidos)
    {
        $this->emailpedidos = $emailpedidos;

        return $this;
    }

    /**
     * Get emailpedidos
     *
     * @return string
     */
    public function getEmailpedidos()
    {
        return $this->emailpedidos;
    }

    /**
     * Set editado
     *
     * @param boolean $editado
     *
     * @return briefing
     */
    public function setEditado($editado)
    {
        $this->editado = $editado;

        return $this;
    }

    /**
     * Get editado
     *
     * @return boolean
     */
    public function getEditado()
    {
        return $this->editado;
    }

    /**
     * Set administrador
     *
     * @param \UsuarioBundle\Entity\administrador $administrador
     *
     * @return briefing
     */
    public function setAdministrador(\UsuarioBundle\Entity\administrador $administrador = null)
    {
        $this->administrador = $administrador;

        return $this;
    }

    /**
     * Get administrador
     *
     * @return \UsuarioBundle\Entity\administrador
     */
    public function getAdministrador()
    {
        return $this->administrador;
    }
}
