<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace WebBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Doctrine\ORM\EntityRepository;

class briefingInformacionType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $where = "u.deleted = 0";
        if (isset($options["attr"]["idcategory"]) && $options["attr"]["idcategory"] > 0){
            $where .= " AND u.category = " . $options["attr"]["idcategory"];
        }
        $builder
            ->add('nombre', TextType::class, array(
                'label' => 'Nombre de tu empresa',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('descripcion', TextareaType::class, array(
                'label' => 'Describe tu empresa',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('lema', TextareaType::class, array(
                'label' => '¿Tiene tu empresa un eslogan?',
                "attr" => array("class" => "form-control"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,    
            ))
            ->add('servicio1titulo', TextType::class, array(
                'label' => 'Servicio 1',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('servicio1descripcion', TextareaType::class, array(
                'label' => 'Descripción del servicio',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('servicio2titulo', TextType::class, array(
                'label' => 'Servicio 2',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('servicio2descripcion', TextareaType::class, array(
                'label' => 'Descripción del servicio',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('servicio3titulo', TextType::class, array(
                'label' => 'Servicio 3',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('servicio3descripcion', TextareaType::class, array(
                'label' => 'Descripción del servicio',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('email', EmailType::class, array(
                'label' => 'Email',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('telefono', TextType::class, array(
                'label' => 'Teléfono',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('direccion', TextType::class, array(
                'label' => 'Dirección',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('horario', TextType::class, array(
                'label' => 'Horario',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('facebook', TextType::class, array(
                'label' => 'Facebook',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('twitter', TextType::class, array(
                'label' => 'Twitter',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('instagram', TextType::class, array(
                'label' => 'Instagram',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('linkedin', TextType::class, array(
                'label' => 'Linkedin',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            /*->add('colorweb', TextType::class, array(
                'label' => '¿Qué color te gustaría como color principal? . (Si sabes el valor hexadecimal o RGB nos ayudarías mucho más)',
                "attr" => array("class" => "form-control jscolor required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('parecidas', TextareaType::class, array(
                'label' => '¿Hay algún diseño/modelo de tienda online que te guste?, indícanoslo, e intentaremos hacerlo lo más parecido posible.',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))
            ->add('observaciones', TextareaType::class, array(
                'label' => 'Información adicional',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ))*/
            ->add('category', EntityType::class, array(
                'class' => \CoreBundle\Entity\category::class,
                'query_builder' => function (EntityRepository $er) {
                    return $er->createQueryBuilder('u')->add('where', 'u.deleted = 0')
                        ->orderBy('u.name', 'ASC');
                },
                'label' => 'Selecciona el tipo de actividad',
                "attr" => array("class" => "form-control"),
                'required' => true,        
                'expanded' => false
            ))
            /*->add('subcategory', EntityType::class, array(
                'class' => \CoreBundle\Entity\subcategory::class,
                'query_builder' => function (EntityRepository $er) use ($where) {
                    return $er->createQueryBuilder('u')->add('where', $where)
                        ->orderBy('u.name', 'ASC');
                },
                'label' => 'Selecciona el tipo de actividad',
                "attr" => array("class" => "form-control"),
                'required' => true,        
                'expanded' => false
            ))*/
            ->add('nombretienda', TextType::class, array(
                'label' => 'Nombre de la aplicacion',
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ));  
                
        if (isset($options["attr"]["tiendaactiva"]) && $options["attr"]["tiendaactiva"]){
            $builder->add('productosparaadultos', ChoiceType::class, array(
                'choices' => array(
                    'No' => 0, 
                    'Si' => 1
                    ),
                'label'=> '¿Vendes productos para mayores de 18 años?',
                'expanded' => false,
                'required' => true,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"]
            ))
            ->add('emailpedidos', EmailType::class, array(
                'label' => 'Email para pedidos',
                "required" => false,
                "attr" => array("class" => "form-control required"),
                "disabled" => $options["attr"]["disabled"],
                'required' => false,
            ));
        }
            
    }
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'WebBundle\Entity\briefing',
            "allow_extra_fields" => true
        ));
    }
    public function getName()
    {
        return 'briefing';
    }
}

